/* $Id: Error.c,v 1.12 2000/01/11 01:28:45 frog Exp $ */

#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>
#include	<X11/Xaw/Dialog.h>
#include	<Haw/Command.h>
#include	<Haw/Util.h>
#include	"hanim.h"
#include	"buffer.h"

extern Pixel light_color( Colormap colormap, Pixel pixel );
static Widget ErrorShell = NULL;

void
error_cancel( Widget w, XtPointer client_data, XtPointer call_data )
{
    Buffer *b = (Buffer *)client_data;
    XtDestroyWidget( ErrorShell );
    ErrorShell = NULL;
    b->state &= ~ERROR;
}

void
hanim_error( Buffer *b, Widget widget, String string )
{
    Arg	args[10];
    int	n;
    Widget	dialog, label, icon, ok;
    Position	x, y;
    Dimension	width, height;
    Pixel	fg, bg, lbg;
    Screen	*screen;

    if ( b->state & ERROR )
        return;

    XtVaGetValues( widget, XtNforeground, &fg, XtNbackground, &bg,
                   XtNscreen, &screen, NULL );
    lbg = light_color( (Colormap)NULL, bg );

    n = 0;
    XtSetArg( args[n], XtNtitle, "Error Dialog" ); n++;
    XtSetArg( args[n], XtNbackground, bg ); n++;
    XtSetArg( args[n], XtNiconic, False ); n++;
    XtSetArg( args[n], XtNgeometry, "+0+0" ); n++;
    XtSetArg( args[n], XtNmappedWhenManaged, False ); n++;
    ErrorShell = XtCreatePopupShell( "Error", topLevelShellWidgetClass,
                                     TopLevel, args, n );

    n = 0;
    XtSetArg( args[n], XtNbackground, bg ); n++;
    XtSetArg( args[n], XtNlabel, string ); n++;
    dialog = XtCreateManagedWidget( "ErrorDialog", dialogWidgetClass,
                                    ErrorShell, args, n );

    n = 0;
    XtSetArg( args[n], XtNforeground, fg ); n++;
    XtSetArg( args[n], XtNbackground, lbg ); n++;
    XtSetArg( args[n], XtNborderColor, fg ); n++;
    ok = XtCreateManagedWidget( "Ok", hCommandWidgetClass, dialog, args, n );
    XtAddCallback( ok, XtNcallback, (XtCallbackProc)error_cancel, (XtPointer)b );

    label = XtNameToWidget( dialog, "label" );
    XtVaSetValues( label, XtNforeground, fg, XtNbackground, bg, NULL );
    icon = XtNameToWidget( dialog, "icon" );
    if ( icon )
        XtVaSetValues( icon, XtNforeground, fg, XtNbackground, bg, NULL );

    XtRealizeWidget( ErrorShell );

    XtVaGetValues( ErrorShell, XtNwidth, &width, XtNheight, &height, NULL );
    XtVaSetValues( ErrorShell, XtNminWidth, width, XtNminHeight, height,
                   XtNmaxWidth, width, XtNmaxHeight, height, NULL );
    x = ( WidthOfScreen(screen) - width ) / 2;
    y = ( HeightOfScreen(screen) - height ) / 2;
    XtVaSetValues( ErrorShell, XtNx, x, XtNy, y, NULL);
    XtPopup( ErrorShell, XtGrabExclusive);

    HawInstallTranslations( dialog, b->preedit_widget );
    XtAddGrab( ErrorShell, False, False );

    b->state |= ERROR;
}
