/* $Id: CommandP.h,v 1.3 1997/11/13 12:28:21 frog Exp $ */

/* 
 * CommandP.h - Private definitions for Command widget
 * 
 */

#ifndef _HawCommandP_h_
#define _HawCommandP_h_

#include <Haw/Command.h>
#include <Haw/LabelP.h>

/***********************************************************************
 *
 * Command Widget Private Data
 *
 ***********************************************************************/

typedef enum {
  HighlightNone,		/* Do not highlight. */
  HighlightWhenUnset,		/* Highlight only when unset, this is
				   to preserve current command widget 
				   functionality. */
  HighlightAlways		/* Always highlight, lets the toggle widget
				   and other subclasses do the right thing. */
} XtCommandHighlight;

/************************************
 *
 *  Class structure
 *
 ***********************************/


   /* New fields for the Command widget class record */
typedef struct _HCommandClass 
  {
    int makes_compiler_happy;  /* not used */
  } HCommandClassPart;

   /* Full class record declaration */
typedef struct _HCommandClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    HLabelClassPart	label_class;
    HCommandClassPart   command_class;
} HCommandClassRec;

extern HCommandClassRec hCommandClassRec;

/***************************************
 *
 *  Instance (widget) structure 
 *
 **************************************/

    /* New fields for the Command widget record */
typedef struct {
    /* resources */
    Dimension   highlight_thickness;
    XtCallbackList callbacks;

    /* private state */
    Pixmap      	gray_pixmap;
    GC          	normal_GC;
    GC          	inverse_GC;
    Boolean     	set;
    XtCommandHighlight	highlighted;
    /* more resources */
    int			shape_style;    
    Dimension		corner_round;
} HCommandPart;


/*    XtEventsPtr eventTable;*/


   /* Full widget declaration */
typedef struct _HCommandRec {
    CorePart         core;
    SimplePart	     simple;
    HLabelPart	     label;
    HCommandPart     command;
} HCommandRec;

#endif /* _HawCommandP_h_ */


