/* $Id: HanListP.h,v 1.1.1.1 1997/08/24 07:17:15 frog Exp $ */

#ifndef	_HanListP_h_
#define	_HanListP_h_

#include	<Haw/HanList.h>
#include	<X11/Xaw/SimpleP.h>
#include	<X11/Xaw/ViewportP.h>
#include	<X11/Xaw/ScrollbarP.h>

/* List class structure */
typedef struct	_HawListClassPart
{
  XtPointer	extension;
} HawListClassPart;

/* Full class record declaration for HawList class */
typedef struct	_HawListClassRec {
  CoreClassPart		core_class;
  SimpleClassPart	simple_class;
  HawListClassPart	list_class;
} HawListClassRec;

/* HawList instance record */
typedef struct	_HawListPart
{
  Pixel			foreground;		/* XtNforeground	      */
  Dimension		border_width;		/* HawNitemBorderWidth	      */
  int			dx;			/* XtNhorizDistance	      */
  int			dy;			/* XtNvertDistance	      */
  Dimension		highlight_thickness;	/* XtNhighlightThickness      */
  Dimension		base_width;		/* HawNitemBaseWidth	      */
  Dimension		base_height;		/* HawNitemBaseHeight	      */
  XFontSet		font_set;		/* HawNfontSet		      */
  Dimension		margin_width;		/* XtNmarginWidth	      */
  Dimension		margin_height;		/* XtNmarginHeight	      */
  Pixel			background;		/* HawNitemBackground	      */
  int			selected_item;		/* HawNselectedItem	      */
  int			visible_vitem_count;/* HawNvisibleVerticalItemCount   */
  int			visible_hitem_count;/* HawNvisibleHorizontalItemCount */
  short			num_rows;		/* HawNnumRows		      */
  short			num_columns;		/* HawNnumColumns	      */
  int			item_count;		/* HawNitemCount	      */
  int			item_length;		/* HawNitemLength	      */
  String		items;			/* HawNitems		      */
  unsigned char		source_cursor_icon_type;/* HawNsourceCursorIconType   */
  XtJustify		justify;		/* XtNjustify		      */
  Boolean		highlight_always;	/* HawNhighlightAlways	      */

  XtCallbackList	notify_callback;
  XtCallbackList	set_callback;
  XtCallbackList	unset_callback;
  XtCallbackList	browse_selection_callback;

  Pixmap		pixmap;

  GC			foreground_gc;
  GC			background_gc;
  GC			highlight_gc;
  GC			unhighlight_gc;

  int			last_selected_item;

  int			par_item_length;
  Dimension		font_width;
  Dimension		font_height;
  short			ascent;
  Boolean		button_press;
  Boolean		armed;
  Boolean		enter;

  Widget		viewport_window;
  Widget		clip_window;
  Widget		h_scroll_bar;
  Widget		v_scroll_bar;
} HawListPart;

/* Full instance record declaration */
typedef struct	_HawListRec {
  CorePart	core;
  SimplePart	simple;
  HawListPart	list;
} HawListRec;

/* Macros for instance fields */

#endif	/* _HanListP_h_ */
