/* $Id: LabelP.h,v 1.3 1997/11/13 12:28:21 frog Exp $ */

/* 
 * LabelP.h - Private definitions for Label widget
 * 
 */

#ifndef _HawLabelP_h_
#define _HawLabelP_h_

/***********************************************************************
 *
 * Label Widget Private Data
 *
 ***********************************************************************/

#include <Haw/Label.h>
#include <X11/Xaw/SimpleP.h>

/* New fields for the Label widget class record */

typedef struct {int foo;} HLabelClassPart;

/* Full class record declaration */
typedef struct _HLabelClassRec {
  CoreClassPart		core_class;
  SimpleClassPart	simple_class;
  HLabelClassPart	label_class;
} HLabelClassRec;

extern HLabelClassRec hLabelClassRec;

/* New fields for the Label widget record */
typedef struct {
  /* resources */
  Pixel		foreground;
  XFontStruct	*font;
  XFontSet	font_set;
  char		*label;
  int		ascent;
  Dimension	line_height;
  XtJustify	justify;
  Dimension	internal_width;
  Dimension	internal_height;
  Pixmap	pixmap;
  Boolean	resize;
  unsigned char encoding;
  Pixmap	left_bitmap;

  /* private state */
  GC		normal_GC;
  GC		gray_GC;
  Pixmap	stipple;
  Position	label_x;
  Position	label_y;
  Dimension	label_width;
  Dimension	label_height;
  Dimension	label_len;
  int		lbm_y;			/* where in label */
  unsigned int	lbm_width, lbm_height;	/* size of pixmap */
} HLabelPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _HLabelRec {
  CorePart	core;
  SimplePart	simple;
  HLabelPart	label;
} HLabelRec;

#define LEFT_OFFSET(lw) ((lw)->label.left_bitmap \
			 ? (lw)->label.lbm_width + (lw)->label.internal_width \
			 : 0)

#endif /* _HawLabelP_h_ */
