/* $Id: PreeditP.h,v 1.9 1999/04/17 11:03:35 frog Exp $ */

#ifndef	_HawPreeditP_h_
#define	_HawPreeditP_h_

#include	<Haw/Preedit.h>
#include	<X11/Xaw/SimpleP.h>
#include	"hcodec.h"

#define IBEAM_WIDTH 3
#define CARET_WIDTH 9
#define CARET_HEIGHT 5

static unsigned char caretBits[] = {
  0x10, 0x00, 0x38, 0x00, 0x6c, 0x00, 0xc6, 0x00, 0x83, 0x01
};

typedef struct {
  Position		position;
  HawHighlightMode	mode;
} HighlightRec;

typedef struct {
  Cardinal		number;
  Cardinal		maximum;
  HighlightRec		*list;
} HighlightData;

typedef struct {
  Cardinal		number;
  Cardinal		maximum;
  Position		*position;
} LineData;

typedef struct	_HawPreeditClassPart {
  XtPointer		extension;
} HawPreeditClassPart;

typedef struct	_HawPreeditClassRec {
  CoreClassPart		core_class;
  SimpleClassPart	simple_class;
  HawPreeditClassPart	preedit_class;
} HawPreeditClassRec;

typedef enum {
  XsmCURSOR_LEFT,
  XsmCURSOR_RIGHT
} XsmCursorAttachment;

extern HawPreeditClassRec	hawPreeditClassRec;

typedef struct	_HawPreeditPart
{
  Boolean		add_ascent;		/* HawNaddAscent	*/
  Window		focus_window;		/* HawNfocusWindow	*/
  Dimension		line_spacing;		/* HawNlineSpacing	*/
  Dimension		area_needed_width;	/* HawNareaNeededWidth	*/
  Dimension		area_needed_height;	/* HawNareaNeededHeight	*/
  Position		x;			/* HawNareaX		*/
  Position		y;			/* HawNareaY		*/
  Dimension		width;			/* HawNareaWidth	*/
  Dimension		height;			/* HawNareaHeight	*/
  int			top_line;		/* HawNtopLine		*/
  int			max_lines;

  long			event_mask;
  char			*value;			/* HawNvalue		*/
  hchar_t		*hvalue;		/* HawNhcsValue		*/
  Position		cursor_position;	/* HawNcursorPosition	*/
  Position		left_cursor_position;
  Position		right_cursor_position;
  HawCursorAttachment	attachment;
  short			columns;
  int			max_length;
  XFontSet		font_set;		/* HawNfontSet		*/
  int			ascent;
  int			descent;
  Pixel			foreground;		/* HawNforeground	*/

  Boolean		editable;
  Boolean		verify_bell;
  Boolean		has_focus;
  Boolean		cursor_on;
  Boolean		dest_on;

  GC			gc;
  GC			inv_gc;
  GC			xor_gc;

  int			string_length;

  int			alloc_size;

  int			cursor_height;
  int			cursor_width;
  Pixmap		dest_cursor;
  Pixmap		cursor;

  HighlightData	highlight;
  LineData		line;
  XtIntervalId		timer_id;
} HawPreeditPart;

typedef struct	_HawPreeditRec {
  CorePart		core;
  HawPreeditPart	preedit;
} HawPreeditRec;


/* Macros for the data */
#define	TextWindow1(w)		(((HawPreeditWidget)(w))->preedit.window1)
#define	TextLineSpacing(w)	(((HawPreeditWidget)(w))->preedit.line_spacing)
#define	TextWidth(w)		(((HawPreeditWidget)(w))->core.width)
#define	TextWidth1(w)		(((HawPreeditWidget)(w))->preedit.width1)

#define	TextCursorPosition(w)	(((HawPreeditWidget)(w))->preedit.cursor_position)
#define	TextValue(w)		(((HawPreeditWidget)(w))->preedit.value)

#define	TextHcsValue(w)		(((HawPreeditWidget)(w))->preedit.hvalue)
#define	TextFontSet(w)		(((HawPreeditWidget)(w))->preedit.font_set)
#define	TextColumns(w)		(((HawPreeditWidget)(w))->preedit.columns)
#define	TextEditable(w)		(((HawPreeditWidget)(w))->preedit.editable)
#define	TextColumns(w)		(((HawPreeditWidget)(w))->preedit.columns)
#define	TextMaxLength(w)	(((HawPreeditWidget)(w))->preedit.max_length)
#define	TextGC(w)		(((HawPreeditWidget)(w))->preedit.gc)

#endif	/* _HawPreeditP_h_ */
