/* $Id: TextOutP.h,v 1.5 1999/02/20 10:07:01 frog Exp $ */

#ifndef	_HawTextOutP_h_
#define	_HawTextOutP_h_

#include	<Haw/TextOut.h>
#include	<X11/Xaw/SimpleP.h>
#include	"hcodec.h"

#define IBEAM_WIDTH	3
#define CARET_WIDTH	9
#define CARET_HEIGHT	5

static unsigned char caretBits[] = {
  0x10, 0x00, 0x38, 0x00, 0x6c,
  0x00, 0xc6, 0x00, 0x83, 0x01
};

typedef struct {
  Position		position;
  HawHighlightMode	mode;
} HighlightRec;

typedef struct {
  Cardinal		number;
  Cardinal		maximum;
  HighlightRec		*list;
} HighlightData;

/* TextOut class structure */
typedef struct	_HawTextOutClassPart {
  XtPointer		extension;
} HawTextOutClassPart;


/* Full class record declaration for HawTextOut class */
typedef struct	_HawTextOutClassRec {
  CoreClassPart		core_class;
  SimpleClassPart	simple_class;
  HawTextOutClassPart	text_out_class;
} HawTextOutClassRec;


/* HawTextOut instance record */
typedef struct	_HawTextOutPart
{
  Dimension		old_width, old_height;
  long			event_mask;
  char			*value;			/* HawNvalue		*/
  hchar_t		*hvalue;		/* HawNhcsValue		*/
  Position		cursor_position;	/* HawNcursorPosition	*/
  Position		left_cursor_position;
  Position		right_cursor_position;
  short			columns;		/* HawNcolumns		*/
  HawCursorAttachment	attachment;
  int			max_length;		/* HawNmaxLength	*/
  XFontSet		font_set;		/* HawNfontSet		*/
  int			ascent;
  int			descent;
  Dimension		max_extent;
  Pixel			foreground;		/* HawNforeground	*/
  Position		top_margin;		/* XtNtopMargin		*/
  Position		bottom_margin;		/* XtNbottomMargin	*/
  Position		left_margin;		/* XtNleftMargin	*/
  Position		right_margin;		/* XtNrightMargin	*/

  Boolean		editable;
  Boolean		verify_bell;		/* HawNverifyBell	*/
  Boolean		enter;
  Boolean		cursor_on;
  Boolean		caret_on;

  GC			gc;
  GC			inv_gc;
  GC			xor_gc;

  int			string_length;

  int			alloc_size;

  int			cursor_height;
  int			cursor_width;
  Pixmap		dest_cursor;
  Pixmap		cursor;

  HighlightData		highlight;
  XtIntervalId		timer_id;
} HawTextOutPart;


/* Full instance record declaration */
typedef struct	_HawTextOutRec {
  CorePart		core;
  SimplePart		simple;
  HawTextOutPart	text_out;
} HawTextOutRec;


/* Macros for the data */
#define	TextLineSpacing(w)	(((HawTextOutWidget)(w))->text_out.line_spacing)
#define	TextWidth(w)		(((HawTextOutWidget)(w))->core.width)
#define	TextCursorPosition(w)	(((HawTextOutWidget)(w))->text_out.cursor_position)
#define	TextValue(w)		(((HawTextOutWidget)(w))->text_out.value)
#define	TextHcsValue(w)		(((HawTextOutWidget)(w))->text_out.hvalue)
#define	TextFontSet(w)		(((HawTextOutWidget)(w))->text_out.font_set)
#define	TextMaxLength(w)	(((HawTextOutWidget)(w))->text_out.max_length)
#define	TextGC(w)		(((HawTextOutWidget)(w))->text_out.gc)

#endif	/* _HawTextOutP_h_ */
