/* $Id: Util.c,v 1.9 1999/03/09 16:52:54 frog Exp $ */

#include	<stdlib.h>
#include	<Haw/Util.h>

#include	"hcodec.h"
#include	"hstring.h"

static char 	*conv_buf = NULL;
static int	conv_buf_hlen = 0;

static Boolean HawAllocBuf(int hlen)
{
  char	*ptr;
 
  ptr = (char *)XtRealloc( conv_buf, sizeof(hchar_t) * (hlen + 1) );
  if( !ptr )
    return False;
  conv_buf = ptr;
  conv_buf_hlen = hlen;
  return True;
}

void HawInstallTranslations( Widget d, Widget s )
{
  XtTranslations t;

  XtVaGetValues( s, XtNtranslations, &t, NULL );
  XtOverrideTranslations(d, t);
}

int HawTextEscapement( XFontSet font_set, hchar_t *hstr, int hlen )
{
#if 1 /* USE_JOHAB_CODE */
  int  len;

  if( conv_buf_hlen < hlen && False == HawAllocBuf(hlen) )
    return 0;
  if ( (len = hcstombs(conv_buf, hstr, hlen) ) < 0 )
    return 0;
  return XmbTextEscapement( font_set, conv_buf, len );
#else
  /*  ڵ wchar_t ϴ  */
  return XwcTextEscapement( font_set, (wchar_t *)hstr, hlen );
#endif
}

void HawDrawImageString( Display *display, Drawable d, XFontSet font_set,
    GC gc, int x, int y, hchar_t *hstr, int hlen )
{
#if 1 /* USE_JOHAB_CODE */
  int  len;

  if( conv_buf_hlen < hlen && False == HawAllocBuf(hlen) )
    return;
  if( (len = hcstombs(conv_buf, hstr, hlen)) < 0 )
    return;
  XmbDrawImageString( display, d, font_set, gc,
		      x, y, conv_buf, len );
#else
  /*  ڵ wchar_t ϴ  */
  XwcDrawImageString( display, d, font_set, gc,
		      x, y, (wchar_t *)hstr, hlen );
#endif
}

int HawHstrToTextProperty(Display *display, hchar_t *hstr,
    XICCEncodingStyle style, XTextProperty* text)
{
  int	hlen = hcslen(hstr);
  char  *list[1];

  if( conv_buf_hlen < hlen && False == HawAllocBuf(hlen) )
    return 0;
  if( hcstombs(conv_buf, hstr, hlen) < 0 )
    return 0;
  hcstombs( conv_buf, hstr, sizeof(hchar_t) * hlen );
  list[0] = conv_buf;
  return XmbTextListToTextProperty( display, list, 1, style, text );
}

