/* $Id: Ximcp.c,v 1.51 2000/01/11 01:28:45 frog Exp $ */
#ifdef USE_XIMCP

#define NEED_EVENTS
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Xlibint.h>
#include <Haw/Label.h>
#include <Haw/HanList.h>
#include <Haw/Preedit.h>
#include <Haw/StsArea.h>
#include <Haw/TextOut.h>
#include <Haw/Util.h>

#include "XimcpP.h"
#include "resource.h"
#include "preference.h"
#include "buffer.h"
#include "XuiXkey.h"
#include "XuiRootWin.h"
#include "hstring.h"
#include "mzdebug.h"

extern Widget	delterm_shell, question_shell;

extern void	hanim_connect();
extern void	hanim_disconnect();
extern void	set_conversion_mode(Buffer *, ConversionMode);
extern Pixel	light_color(Colormap, Pixel);
extern void	state_cancel(Widget, XtPointer, XtPointer);

#define	MAXSHORT	65535
#define XIMCP_BUFSIZE	2048

#define Pad(n)	((4 - ((n) % 4)) % 4)

static Atom	xim_selection;

static Atom	xim_servers;
static Atom	xim_transport;
static Atom	xim_locales;

static Atom	xim_connect;
static Atom	xim_protocol;

static Atom	xim_open;
static Atom	xim_register_triggerkeys;
static Atom	xim_query_extension;
static Atom	xim_im_values;
static Atom	xim_ic_values;
static Atom	xim_commit;
static Atom	xim_reset;
static Atom	xim_forward_event;

#define XIM_TRANSPORT_REPLY	"@transport=X/"
#define XIM_LOCALES_REPLY	"@locale=ko,ko_KR,korean"

enum {
    XimInitOpen = 0x01,
    XimInitEncodingNegotiation = 0x02,
    XimInitQueryExtension = 0x04,
    XimInitDone = 0x07
};

static XimConn	*connection = NULL;

static XimcpAttrRec im_attr[] = {
    { XNQueryInputStyle, XIM_QUERY_INPUT_STYLE, XimRimStyles, 0, 0, NULL },
    { NULL, 0, 0, 0, 0, NULL }
};

#define Offset(f) (Cardinal)&(((XimIC *)NULL))->preedit.f
static XimcpAttrRec ic_preedit_attr[] = {
    { XNArea, XIC_AREA, XimRrectangle,
      sizeof(XRectangle), Offset(area), NULL },
    { XNAreaNeeded, XIC_AREA_NEEDED, XimRrectangle,
      sizeof(XRectangle), Offset(area_needed), NULL },
    { XNSpotLocation, XIC_SPOT_LOCATION, XimRpoint,
      sizeof(XPoint), Offset(spot_location), NULL },
    { XNColormap, XIC_COLORMAP, XimRlongData,
      sizeof(Colormap), Offset(colormap), NULL },
    { XNForeground, XIC_FOREGROUND, XimRlongData,
      sizeof(unsigned long), Offset(foreground), NULL },
    { XNBackground, XIC_BACKGROUND, XimRlongData,
      sizeof(unsigned long), Offset(foreground), NULL },
    { XNBackgroundPixmap, XIC_BACKGROUND_PIXMAP, XimRlongData,
      sizeof(Pixmap), Offset(pixmap), NULL },
    { XNFontSet, XIC_FONTSET, XimRfontSet,
      0, Offset(fontset), NULL },
    { XNLineSpace, XIC_LINE_SPACING, XimRlongData,
      sizeof(int), Offset(line_spacing), NULL },
    { XNCursor, XIC_CURSOR, XimRlongData,
      sizeof(Cursor), Offset(cursor), NULL },
    { XNPreeditState, XIC_PREEDIT_STATE, XimRimPreeditState,
      sizeof(unsigned long), Offset(state), NULL },
    { XNSeparatorofNestedList, XIC_SEPARATOR_OF_NESTED_LIST,
      XimRseparatorOfNestedList, 0, 0, NULL },
    { 0, 0, 0, 0, 0, NULL }};

#undef Offset

#define Offset(f) (Cardinal)&(((XimIC *)NULL))->status.f
static XimcpAttrRec ic_status_attr[] = {
    { XNArea, XIC_AREA, XimRrectangle,
      sizeof(XRectangle), Offset(area), NULL },
    { XNAreaNeeded, XIC_AREA_NEEDED, XimRrectangle,
      sizeof(XRectangle), Offset(area_needed), NULL },
    { XNColormap, XIC_COLORMAP, XimRlongData,
      sizeof(Colormap), Offset(colormap), NULL },
    { XNForeground, XIC_FOREGROUND, XimRlongData,
      sizeof(unsigned long), Offset(foreground), NULL },
    { XNBackground, XIC_BACKGROUND, XimRlongData,
      sizeof(unsigned long), Offset(foreground), NULL },
    { XNBackgroundPixmap, XIC_BACKGROUND_PIXMAP, XimRlongData,
      sizeof(Pixmap), Offset(pixmap), NULL },
    { XNFontSet, XIC_FONTSET, XimRfontSet,
      0, Offset(fontset), NULL },
    { XNCursor, XIC_CURSOR, XimRlongData,
      sizeof(Cursor), Offset(cursor), NULL },
    { XNSeparatorofNestedList, XIC_SEPARATOR_OF_NESTED_LIST,
      XimRseparatorOfNestedList, 0, 0, NULL },
    { 0, 0, 0, 0, 0, NULL }
};
#undef Offset

#define Offset(f) (Cardinal)&(((XimIC *)NULL))->f
static XimcpAttrRec ic_attr[] = {
    { XNInputStyle, XIC_INPUT_STYLE, XimRlongData,
      sizeof(unsigned long), Offset(input_style), NULL },
    { XNClientWindow, XIC_CLIENT_WINDOW, XimRwindow,
      sizeof(Window), Offset(client_window), NULL },
    { XNFocusWindow, XIC_FOCUS_WINDOW, XimRwindow,
      sizeof(Window), Offset(focus_window), NULL },
    { XNFilterEvents, XIC_FILTER_EVENTS, XimRlongData,
      sizeof(long), Offset(filter_events), NULL },
    { XNResetState, XIC_RESET_STATE, XimRimResetState,
      sizeof(unsigned long), Offset(reset_state), NULL },
    { XNHotKey, XIC_HOT_KEY, XimRimHotKeyTriggers,
      sizeof(XIMHotKeyTriggers), Offset(hot_key), NULL },
    { XNHotKeyState, XIC_HOT_KEY_STATE, XimRimHotKeyState,
      sizeof(unsigned long), Offset(hot_key_state), NULL },
    { XNStringConversion, XIC_STRING_CONVERSION, XimRimStringConversion,
      0, 0, NULL },
    { XNPreeditAttributes, XIC_PREEDIT_ATTRIBUTES, XimRnestedList,
      0, 0, ic_preedit_attr },
    { XNStatusAttributes, XIC_STATUS_ATTRIBUTES, XimRnestedList,
      0, 0, ic_status_attr },
    { 0, 0, 0, 0, 0, NULL }
};
#undef Offset

static XimcpExtRec extension[] = {
    { XIM_EXT_MOVE, 0, "XIM_EXT_MOVE" },
#if 0 /* frog */
    /* IMDkit   ó ߴ. LATER */
    { XIM_EXT_SET_EVENT_MASK, 0, "XIM_EXT_SET_EVENT_MASK" },
    { XIM_EXT_FORWARD_KEYEVENT, 0, "XIM_EXT_FORWARD_KEYEVENT" },
#endif
    {(CARD8)0, (CARD8)0, (char *)NULL}
};

static CARD16	*attr_list = NULL;
static int	attr_size = 0;
static CARD16	*triggerkeys = NULL;
static int	triggerkeys_size = 0;
static Endian	current_endian, last_endian;

#if 0
// imRm.c
static char *supported_im_values_list[] = {
    XNQueryInputStyle,
    XNResourceName,
    XNResourceClass,
    XNDestroyCallback,
    XNQueryIMValuesList,
    XNQueryICValuesList,
    XNVisiblePosition,
    (char *)NULL
};

static char *supported_ic_values_list[] = {
    XNInputStyle,
    XNClientWindow,
    XNFocusWindow,
    XNResourceName,
    XNResourceClass,
    XNGeometryCallback,
    XNFilterEvents,
    XNDestroyCallback,
    XNStringConversionCallback,
    XNStringConversion,
    XNResetState,
    XNHotKey,
    XNHotKeyState,
    XNPreeditAttributes,
    XNStatusAttributes,
    XNArea,
    XNAreaNeeded,
    XNSpotLocation,
    XNColormap,
    XNStdColormap,
    XNForeground,
    XNBackground,
    XNBackgroundPixmap,
    XNFontSet,
    XNLineSpace,
    XNCursor,
    XNPreeditStartCallback,
    XNPreeditDoneCallback,
    XNPreeditDrawCallback,
    XNPreeditCaretCallback,
    XNStatusStartCallback,
    XNStatusDoneCallback,
    XNStatusDrawCallback,
    XNPreeditState,
    XNPreeditStateNotifyCallback,
    (char *)NULL
};
#endif

static XIMStyle	input_styles[] = {
    XIMPreeditPosition | XIMStatusArea,
    XIMPreeditArea | XIMStatusArea,
    XIMPreeditPosition | XIMStatusNothing,
    XIMPreeditArea | XIMStatusNothing,
    XIMPreeditNothing | XIMStatusNothing,
    0
};

// local functions
static void CreatePreedit(Display *, XimIC *, Arg *, int);
static void CreateStatus(Display *, XimIC *, Arg *, int);

static int fontset_ascent(XFontSet fs)
{
    XFontSetExtents *ext = XExtentsOfFontSet(fs);
    return - ext->max_ink_extent.y;
}

static int fontset_descent(XFontSet fs)
{
    XFontSetExtents *ext = XExtentsOfFontSet(fs);
    return ext->max_ink_extent.height + ext->max_ink_extent.y - 1;
}

static CARD16 swap16(CARD16 s)
{
    if (endian == current_endian)
        return(s);
    else {
        CARD8 *d = (CARD8 *) & s;
        return((d[0] << 8) | d[1]);
    }
}

static CARD32 swap32(CARD32 s)
{
    if (endian == current_endian)
        return(s);
    else {
        CARD8 *d = (CARD8 *) & s;
        return((d[0] << 24) | (d[1] << 16) | (d[2] << 8) | d[3]);
    }
}

static int new_imid()
{
    static int imid = 0;
    XimConn *xc;
    XimIM	*xim;
    int n;

    if (imid < MAXSHORT)
        return ++imid;
    for (n = 1; n <= MAXSHORT; n++) {
        for (xc = connection; xc; xc = xc->next) {
            for (xim = xc->xim; xim; xim = xim->next)
                if (xim->imid == n)
                    break;
        }
        if (xc == NULL)
            break;
    }
    return n;
}

static int new_icid()
{
    static int icid = 0;
    XimConn *xc;
    XimIM	*xim;
    XimIC	*xic;
    int n;

    if (icid < MAXSHORT)
        return ++icid;
    for (n = 1; n <= MAXSHORT; n++) {
        for (xc = connection; xc; xc = xc->next) {
            for (xim = xc->xim; xim; xim = xim->next)
                for (xic = xim->xic; xic; xic = xic->next)
                    if (xic->icid == n)
                        break;
        }
        if (xc == NULL)
            break;
    }
    return n;
}

static XimIM *imid2xim(CARD16 imid)
{
    XimConn *xc;
    XimIM	*xim;

    for (xc = connection; xc; xc = xc->next)
        for (xim = xc->xim; xim; xim = xim->next)
            if (xim->imid == imid)
                return(xim);
    return NULL;
}

static XimIC *icid2xic(CARD16 icid)
{
    XimConn *xc;
    XimIM	*xim;
    XimIC	*xic;

    for (xc = connection; xc; xc = xc->next)
        for (xim = xc->xim; xim; xim = xim->next)
            for (xic = xim->xic; xic; xic = xic->next)
                if (xic->icid == icid)
                    return(xic);
    return NULL;
}

static XimIC *window2xic(Window win)
{
    XimConn *xc;
    XimIM	*xim;
    XimIC	*xic, *xic2;

    xic2 = NULL;
    for (xc = connection; xc != NULL; xc = xc->next) {
        for (xim = xc->xim; xim != NULL; xim = xim->next) {
            for (xic = xim->xic; xic != NULL; xic = xic->next) {
                if ( xic->focus_window == win ||
                     XtWindow(xic->buffer->preedit_widget) == win ) {
                    if (xic->has_focus)
                        return(xic);
                    xic2 = xic;
                }
            }
        }
    }
    return(xic2);
}

static XimConn *imid2xc(CARD32 imid)
{
    XimConn *xc;
    XimIM *xim;

    //  ġ  ϱ   ٲ۴.
    if ((xim = imid2xim(imid))) {
        xc = xim->xc;
        if (xc->previous) {
            xc->previous->next = xc->next;
            if (xc->next)
                xc->next->previous = xc->previous;
            connection->previous = xc;
            xc->next = connection;
            xc->previous = NULL;
            connection = xc;
        }
    }
    return connection;
}

static void destroy_ic(XimIC *xic)
{
    if (xic->input_style & XIMPreeditNothing)
        PEWindowUnmap(xic->input_style);
    if (xic->buffer->state & (ERROR | DELETE | CODE | ADD | EDIT | HANJA))
        state_cancel(0, xic->buffer, 0);
    if (xic->preedit.fontset && xic->preedit.fontset != gFontSet)
        XFreeFontSet(XtDisplay(TopLevel), xic->preedit.fontset);
    if (xic->status.fontset && xic->status.fontset != gFontSet)
        XFreeFontSet(XtDisplay(TopLevel), xic->status.fontset);

    // Window alreay destroyed and I must free memories.
    // But, I don't know how to do it.
    if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea))
        XtDestroyWidget(xic->buffer->preedit_widget);
    if (xic->input_style & XIMStatusArea)
        XtDestroyWidget(xic->buffer->status_widget);
    if (xic->input_style != (XIMPreeditNothing | XIMStatusNothing))
        buffer_free(xic->buffer);
    XFree(xic);
}


Boolean XimcpCheckState(State state)
{
    XimConn *xc;
    XimIM	*xim;
    XimIC	*xic;

    for (xc = connection; xc; xc = xc->next)
        for (xim = xc->xim; xim; xim = xim->next)
            for (xic = xim->xic; xic; xic = xic->next)
                if (xic->buffer->state & state)
                    return(True);
    return(False);
}

static void XimSendClientMessage(Display *dpy, XimConn *xc,
                                 CARD8 protocol, CARD16 length, CARD8 *data)
{
    XClientMessageEvent	ev;

    memset(&ev, 0, sizeof(XClientMessageEvent));

    ev.type = ClientMessage;
    ev.window = xc->client_window;
    ev.message_type = xim_protocol;
    ev.format = 8;
    ev.data.b[0] = protocol;
    ev.data.b[1] = 0;
    ev.data.s[1] = xc->bug ? swap16(length + Pad(length))
                   : swap16((length + 3) / 4);
    if (length > 0)
        memcpy(ev.data.s + 2, data, length);

    XSendEvent(dpy, xc->client_window, False, 0, (XEvent *)&ev );
}

static void XimSendProperty(Display *dpy, XimConn *xc,
                            Atom atom, CARD16 length, CARD8 *data)
{
    XClientMessageEvent	ev;

    length = ((length + 3) / 4) * 4;
    *(CARD16*)(data + 2) = swap16(xc->bug ? length - 4 : (length - 4) / 4);
    XChangeProperty( dpy, xc->client_window, atom, XA_STRING, 8,
                     PropModeAppend, data, length );

    ev.type = ClientMessage;
    ev.window = xc->client_window;
    ev.message_type = xim_protocol;
    ev.format = 32;
    ev.data.l[0] = swap32(length);
    ev.data.l[1] = swap32(atom);
    XSendEvent(dpy, xc->client_window, False, 0, (XEvent *)&ev);
}

static void XimSendErrorMessage(Display *dpy, XimConn *xc,
                                CARD16 imid, CARD16 icid, CARD16 error_code)
{
    XClientMessageEvent	ev;

    ev.type = ClientMessage;
    ev.window = xc->client_window;
    ev.message_type = xim_protocol;
    ev.format = 8;
    ev.data.b[0] = XIM_ERROR;
    ev.data.b[1] = 0;
    ev.data.s[1] = swap16(xc->bug ? 12 : 12 / 4);
    ev.data.s[2] = swap16(imid);
    ev.data.s[3] = swap16(icid);
    ev.data.s[4] = swap16((imid ? 1 : 0) | (icid ? 2 : 0));
    ev.data.s[5] = swap16(error_code);
    ev.data.s[6] = 0;

    XSendEvent(dpy, xc->client_window, False, 0, (XEvent *)&ev);
}



Boolean XimcpSendCompoundText(Display *dpy, Window win, hchar_t *hstr)
{
    XimIC *xic;
    CARD8 reply[XIMCP_BUFSIZE];
    int	size;
    XTextProperty text;

    if ((xic = window2xic(win)) == NULL)
        return(False);

    HawHstrToTextProperty(dpy, hstr, XCompoundTextStyle, &text);
    memset(reply, 0, XIMCP_BUFSIZE);
    memcpy(&reply[12], text.value, text.nitems);
    size = 4 + 8 + text.nitems;
    *((CARD16 *)&reply[4]) = swap16(xic->xim->imid);
    *((CARD16 *)&reply[6]) = swap16(xic->icid);
    *((CARD16 *)&reply[8]) = swap16(0x0002);
    *((CARD16 *)&reply[10]) = swap16(text.nitems);
    if (size <= 20)
        XimSendClientMessage( dpy, xic->xim->xc, XIM_COMMIT, size - 4,
                              &reply[4] );
    else {
        reply[0] = XIM_COMMIT;
        reply[1] = 0;
        XimSendProperty(dpy, xic->xim->xc, xim_commit, size, reply);
    }
    XFree(text.value);

    if (xic->input_style & XIMPreeditNothing)
        HawTextOutSetString( xic->buffer->preedit_widget, NULL,
                             HawHIGHLIGHT_NORMAL );
    else if (xic->input_style & XIMPreeditPosition) {
        if (resources.auto_replace)
            HawPreeditAutoReplace(xic->buffer->preedit_widget);
        else
            HawPreeditSetString( xic->buffer->preedit_widget, NULL,
                                 HawHIGHLIGHT_SECONDARY_SELECTED );
    } else if (xic->input_style & XIMPreeditArea)
        HawPreeditSetString( xic->buffer->preedit_widget, NULL,
                             HawHIGHLIGHT_SECONDARY_SELECTED );

    return(True);
}

Boolean XimcpSendKeyEvent(Window win, XKeyEvent *key)
{
    XimIC *xic;
    CARD8	reply[XIMCP_BUFSIZE];

    if ((xic = window2xic(win)) == NULL)
        return(False);

    reply[0] = XIM_FORWARD_EVENT; ;
    reply[1] = 0;
    ((CARD16 *)reply)[2] = swap16(xic->xim->imid);
    ((CARD16 *)reply)[3] = swap16(xic->icid);
    ((CARD16 *)reply)[4] = 0;
    ((CARD16 *)reply)[5] = swap16(key->serial >> 16);

    ((xEvent *)(reply + 12))->u.u.type = KeyPress;
    ((xEvent *)(reply + 12))->u.u.sequenceNumber = swap16(key->serial & 0xffff);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.event =
        swap32(xic->focus_window);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.root = swap32(key->root);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.time = swap32(key->time);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.eventX = swap16(key->x);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.eventY = swap16(key->y);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.rootX = swap16(key->x_root);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.rootY = swap16(key->y_root);
    ((xEvent *)(reply + 12))->u.keyButtonPointer.state = swap16(key->state);
    ((xEvent *)(reply + 12))->u.u.detail = key->keycode;

    XimSendProperty( key->display, xic->xim->xc, xim_forward_event,
                     12 + sz_xEvent, reply );
    return(True);
}

static void XimConnect(Display *dpy, XimConn *xc, CARD data)
{
    CARD16 reply[2];

    if (data.s[5] != 0) {
        XimSendClientMessage(dpy, xc, XIM_AUTH_NG, 0, NULL);
    } else if (swap16(data.s[3]) != 1 || swap16(data.s[4]) != 0) {
        XimSendErrorMessage(dpy, xc, 0, 0, XIM_ERROR_BAD_SOMETHING);
    } else {
        reply[0] = 1;
        reply[1] = 0;
        XimSendClientMessage(dpy, xc, XIM_CONNECT_REPLY, 4, (CARD8 *)reply);
    }
}

static void XimDisconnect(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;

    XimSendClientMessage(dpy, xc, XIM_DISCONNECT_REPLY, 0, NULL);

    if (xc->previous)
        xc->previous->next = xc->next;
    else
        connection = xc->next;
    if (xc->next)
        xc->next->previous = xc->previous;

    for (xim = xc->xim; xim != NULL; xim = xim->next) {
        for (xic = xim->xic; xic != NULL; xic = xic->next)
            destroy_ic(xic);
        XFree(xim);
    }
    XDestroyWindow(dpy, xc->ims_window);
    XFree(xc);
}

static int create_attr_list(XimcpAttrRec *attr, CARD16 *list)
{
    int n, size = 0;

    while (attr->id != 0) {
        list[0] = swap16(attr->id);
        list[1] = swap16(attr->type);
        list[2] = swap16(strlen(attr->name));
        strcpy((char *)&list[3], attr->name);

        n = 6 + list[2] + Pad(2 + list[2]);
        size += n;
        list = (CARD16 *)((char *)list + n);

        if (attr->nested_list) {
            n = create_attr_list(attr->nested_list, list);
            size += n;
            list = (CARD16 *)((char *)list + n);
        }

        attr++;
    }
    return(size);
}

static void XimOpen(Display *dpy, XimConn *xc, CARD data)
{
    XimIM *xim, *xim2;
    int	im_size, ic_size;
    CARD16 im_list[XIMCP_BUFSIZE], ic_list[XIMCP_BUFSIZE];
    XIMTRIGGERKEY	*onkey, *offkey;
    int	n, m, nn, mm, ii;

    xim = (XimIM *)XtMalloc(sizeof(XimIM));
    xim->xc = xc;
    xim->imid = new_imid();
    xim->initialize = XimInitOpen;
    xim->extension = 0;
    xim->xic = NULL;
    xim->next = NULL;

    if (!((data.b[4] == 5 && !strncmp( (char *)&data.b[5], "ko_KR", 5)) ||
           (data.b[4] == 2 && !strncmp((char *)&data.b[5], "ko", 2 )))) {
        XimSendErrorMessage(dpy, xc, 0, 0, XIM_ERROR_LOCALE_NOT_SUPPORTED);
        XFree(xim);
        return;
    }

    if (current_endian != last_endian) {
        XFree(attr_list);
        XFree(triggerkeys);
        attr_list = NULL;
        triggerkeys = NULL;
    }

    if (prefer.event_flow == DYNAMIC_CONTROL) {
        if (triggerkeys == NULL) {
            onkey = Action2XimcpKey(hanim_connect);
            offkey = Action2XimcpKey(hanim_disconnect);
            n = m = nn = mm = 0;
            if (onkey) {
                for (n = 0; onkey[n].keysym != XK_VoidSymbol; n++);
                nn = n * sizeof(XIMTRIGGERKEY);
            }
            if (offkey) {
                for (m = 0; offkey[m].keysym != XK_VoidSymbol; m++);
                mm = m * sizeof(XIMTRIGGERKEY);
            }
            triggerkeys_size = sizeof(CARD8) + sizeof(CARD8) + sizeof(CARD16)
                               + sizeof(CARD16) + 2 + 4 + nn + 4 + mm;
            triggerkeys = (CARD16 *)XtMalloc(triggerkeys_size);
            ((CARD8 *)triggerkeys)[0] = XIM_REGISTER_TRIGGERKEYS;
            ((CARD8 *)triggerkeys)[1] = 0;
            ((CARD32 *)triggerkeys)[2] = swap16(nn);
            for (ii = 0; ii < n; ii++) {
                ((CARD32 *)triggerkeys)[3 + ii*3] = swap32(onkey[ii].keysym);
                ((CARD32 *)triggerkeys)[4 + ii*3] = swap32(onkey[ii].modifier);
                ((CARD32 *)triggerkeys)[5 + ii*3]
                = swap32(onkey[ii].modifier_mask);
            }
            ((CARD32 *)triggerkeys)[n*3 + 3] = swap16(mm);
            for (ii = 0; ii < m; ii++, n++) {
                ((CARD32 *)triggerkeys)[4 + n*3] = swap32(offkey[ii].keysym);
                ((CARD32 *)triggerkeys)[5 + n*3] = swap32(offkey[ii].modifier);
                ((CARD32 *)triggerkeys)[6 + n*3]
                = swap32(offkey[ii].modifier_mask);
            }
            XFree(onkey);
            XFree(offkey);
        }
        triggerkeys[2] = 0;
        XimSendProperty(dpy, xc, xim_register_triggerkeys,
	    triggerkeys_size, (CARD8 *)triggerkeys);
    }

    if (attr_list == NULL) {
        im_size = create_attr_list(im_attr, im_list);
        ic_size = create_attr_list(ic_attr, ic_list);
        attr_size = 4 + 2 + 2 + im_size + 2 + 2 + ic_size;
        attr_list = (CARD16 *)XtMalloc(attr_size);
        ((CARD8 *)attr_list)[0] = XIM_OPEN_REPLY;
        ((CARD8 *)attr_list)[1] = 0;
        attr_list[3] = swap16(im_size);
        memcpy(&attr_list[4], im_list, im_size);
        attr_list[im_size / 2 + 4] = swap16(ic_size);
        memcpy(&attr_list[im_size / 2 + 6], ic_list, ic_size);
    }
    attr_list[2] = swap16(xim->imid);
    XimSendProperty(dpy, xc, xim_open, attr_size, (CARD8 *)attr_list);

    if (prefer.event_flow != DYNAMIC_CONTROL) {
        CARD16 reply[6];

        reply[0] = xim->imid;
        reply[1] = 0;
        ((CARD32 *)reply)[1] = swap32(KeyPressMask);
        ((CARD32 *)reply)[2] = NoEventMask;
        XimSendClientMessage(dpy, xc, XIM_SET_EVENT_MASK, 12, (CARD8 *)reply);
    }

    if (xc->xim == NULL) {
        xc->xim = xim;
        xim->previous = NULL;
    } else {
        for (xim2 = xc->xim; xim2->next != NULL; xim2 = xim2->next);
        xim2->next = xim;
        xim->previous = xim2;
    }
}

static void XimClose(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[1];
    int imid;

    imid = swap16(data.s[2]);
    if (!(xim = imid2xim(imid))) {
        XimSendErrorMessage(dpy, xc, imid, 0, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[0] = swap16(imid);
    XimSendClientMessage(dpy, xc, XIM_CLOSE_REPLY, 2, (CARD8 *)reply);
    // clear data structure
    if (xim->previous)
        xim->previous->next = xim->next;
    else
        xc->xim = xim->next;
    if (xim->next)
        xim->next->previous = xim->previous;
    for (xic = xim->xic; xic; xic = xic->next)
        destroy_ic(xic);
    XFree(xim);
}

static void XimEncodingNegotiation(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    CARD16 replay[3];
    int	n, imid;
    int	point;

    imid = swap16(data.s[2]);
    if (!(xim = imid2xim(imid))) {
        XimSendErrorMessage(dpy, xc, imid, 0, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    replay[0] = swap16(xim->imid);
    replay[1] = 0;
    replay[2] = -1;
    for ( n = 0, point = 8; point < data.s[3];
          point += data.b[point] + Pad(data.b[point]), n++ ) {
        if (strncmp("COMPOUND_TEXT", data.b + point + 1, data.b[point])) {
            replay[2] = n;
            break;
        }
    }
    XimSendClientMessage(dpy, xc, XIM_ENCODING_NEGOTIATION_REPLY, 6,
                         (CARD8 *)replay);
    xim->initialize |= XimInitEncodingNegotiation;
}


static void XimQueryExtension(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimcpExtRec *ext;
    CARD8	reply[XIMCP_BUFSIZE];
    int	size = 8;
    int	n, m;

    if (!(xim = imid2xim(swap16(data.s[2])))) {
        XimSendErrorMessage(dpy, xc, swap16(data.s[2]), 0,
                            XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    for (n = 8; n < data.s[3] + 8; n += data.b[n] + Pad(data.b[n])) {
        for (ext = extension; ext->major_opcode != 0; ext++) {
            if (strncmp(ext->name, (char *)&data.b[n + 1], data.b[n]) == 0) {
                xim->extension |= ext->major_opcode;
                reply[size] = ext->major_opcode;
                reply[size + 1] = ext->minor_opcode;
                *((CARD16 *)&reply[size + 2]) = swap16(strlen(ext->name));
                strcpy((char *)&reply[size + 4], ext->name);

                m = 4 + Pad(*((CARD16 *) & reply[size + 2]));
                size += m;
                break;
            }
        }
    }
    *((CARD16 *)&reply[4]) = swap16(xim->imid);
    *((CARD16 *)&reply[6]) = swap16(size - 4);
    if (size <= 20)
        XimSendClientMessage(dpy, xc, XIM_QUERY_EXTENSION_REPLY, size - 4,
                             reply + 4);
    else {
        reply[0] = XIM_QUERY_EXTENSION_REPLY;
        reply[1] = 0;
        XimSendProperty(dpy, xc, xim_query_extension, size, reply);
    }

    xim->initialize |= XimInitQueryExtension;
}


static void XimSetImValues(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    CARD16 reply[1];

    if (!(xim = imid2xim(swap16(data.s[2])))) {
        XimSendErrorMessage(dpy, xc, swap16(data.s[2]), 0,
                            XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[0] = swap16(xim->imid);    /* LATER */
    XimSendClientMessage(dpy, xc, XIM_SET_IM_VALUES_REPLY, 2,
                         (CARD8 *)reply );
}

static void XimGetImValues(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    CARD16 reply[XIMCP_BUFSIZE];
    int	size = 4 + 2 + 2;
    int	n, m;

    if (!(xim = imid2xim(swap16(data.s[2])))) {
        XimSendErrorMessage(dpy, xc, swap16(data.s[2]), 0,
                            XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[2] = xim->imid;
    for (n = 0; n < swap16(data.s[3]) / 2; n++) {
        switch (swap16(data.s[4 + n])) {
        case XIM_QUERY_INPUT_STYLE:
            MZDEBUG(DBG_XIM, "   XIM_QUERY_INPUT_STYLE\n");

            reply[size / 2] = swap16(XIM_QUERY_INPUT_STYLE);
            for (m = 0; input_styles[m]; m++);
            reply[size / 2 + 2] = swap16(m);
            m *= sizeof(CARD32);
            reply[size / 2 + 1] = swap16(2 + 2 + m);
            memcpy(&reply[size / 2 + 4], input_styles, m);
            size += 2 + 2 + 2 + 2 + m;
            break;

        default:
            MZDEBUG1(DBG_XIM, "   GET_UNKNOWN_IM_VALUE : %d\n", swap16(data.s[4 + n]));

            XimSendErrorMessage(dpy, xc, xim->imid, 0, XIM_ERROR_BAD_SOMETHING);
            return;
        }
    }
    reply[3] = swap16(size - (4 + 2 + 2));

    if (size <= 20)
        XimSendClientMessage(dpy, xc, XIM_GET_IM_VALUES_REPLY, size - 4,
                             (CARD8 *)(reply + 2) );
    else {
        ((CARD8 *)reply)[0] = XIM_GET_IM_VALUES_REPLY;
        ((CARD8 *)reply)[1] = 0;
        XimSendProperty(dpy, xc, xim_im_values, size, (CARD8 *)reply);
    }
}

static CARD16 set_ic_attribute( Display *dpy,
                                XimIC *xic, int length, CARD data )
{
    int	n, m;
    int	len;
    int	p, s;
    Arg	pargs[20], sargs[20];
    CARD32	mask, pmask, smask;
    char	**missing_list, *def_string, *base_name;
    int	missing_count;

    pmask = smask = mask = 0;
    for ( n = 0; n < length;
          n += ((4 + swap16(data.s[n / 2 + 1]) + 3) / 4) * 4 ) {
        mask |= 1L << (swap16(*((CARD16 *) & data.b[n])) & 0x000f);

        switch (swap16(*((CARD16 *)&data.b[n]))) {
        case XIC_INPUT_STYLE:
            if (xic->input_style != 0)
                return(XIM_ERROR_BAD_SOMETHING);
            xic->input_style = swap32(*((CARD32 *) & data.b[n + 4]));
            if (xic->input_style == (XIMPreeditNothing | XIMStatusNothing))
                xic->buffer = &sys_buffer;
            else {
                if ((xic->buffer = buffer_alloc()) == NULL)
                    return(XIM_ERROR_BAD_ALLOC);
                xic->buffer->xim_style = xic->input_style;
                if (xic->input_style & XIMStatusNothing) {
                    xic->buffer->label_widget = sys_buffer.label_widget;
                }
            }
            break;
        case XIC_PREEDIT_ATTRIBUTES:
            for ( m = 4, len = swap16(*((CARD16 *) & data.b[n + 2])) + 4; m < len;
                  m += ((4 + swap16(*((CARD16 *) & data.b[n + m + 2]) + 3)) / 4) * 4 )
                pmask |= 1L << (swap16(*((CARD16 *) & data.b[n + m])) & 0x000f);
            break;
        case XIC_STATUS_ATTRIBUTES:
            for ( m = 4, len = swap16(*((CARD16 *) & data.b[n + 2])) + 4; m < len;
                  m += ((4 + swap16(*((CARD16 *) & data.b[n + m + 2])) + 3) / 4) * 4 )
                smask |= 1L << (swap16(*((CARD16 *) & data.b[n + m])) & 0x000f);
            break;
        }
    }
    xic->mask |= mask;
    xic->preedit.mask |= pmask;
    xic->status.mask |= smask;

    p = s = 0;
    for ( n = 0; n < length;
          n += ((4 + swap16(data.s[n / 2 + 1]) + 3) / 4) * 4 ) {
        assert(0 == (n % 2));
        switch (swap16(data.s[n / 2])) {
        case XIC_INPUT_STYLE:
            MZDEBUG1(DBG_XIM, " XIC_INPUT_STYLE [%d]\n", xic->icid );
            break;

        case XIC_CLIENT_WINDOW:
            xic->client_window = swap32(*((Window *) & data.b[n + 4]));

            MZDEBUG2(DBG_XIM, " XIC_CLIENT_WINDOW [%d] : %x\n",
                     xic->icid, xic->client_window);

            if (!(xic->mask & _XIC_FOCUS_WINDOW)) {
                xic->focus_window = xic->client_window;
                XSelectInput(dpy, xic->focus_window,
                             ExposureMask | StructureNotifyMask);
                if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea)) {
                    XtSetArg(pargs[p], HawNfocusWindow, xic->focus_window);
                    p++;
                }
            }
            if (xic->input_style & XIMStatusArea) {
                XtSetArg(sargs[s], HawNparentWindow, xic->client_window);
                s++;
            }
            break;

        case XIC_FOCUS_WINDOW:
            xic->focus_window = swap32(*((Window *) & data.b[n + 4]));

            MZDEBUG2(DBG_XIM, " XIC_FOCUS_WINDOW [%d] : %x\n",
                     xic->icid, xic->focus_window);

            XSelectInput( dpy, xic->focus_window,
                          ExposureMask | StructureNotifyMask );
            if (!(xic->mask & _XIC_CLIENT_WINDOW))
                xic->client_window = xic->focus_window;
            if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea)) {
                XtSetArg(pargs[p], HawNfocusWindow, xic->focus_window);
                p++;
            }
            break;

        case XIC_RESET_STATE:
            MZDEBUG1(DBG_XIM, " XIC_RESET_STATE [%d]\n", xic->icid );
            xic->reset_state = swap32(*((CARD32 *) & data.b[n + 4]));
            break;

        case XIC_HOT_KEY:
            MZDEBUG1(DBG_XIM, " XIC_HOT_KEY [%d]\n", xic->icid );
            /* LATER */
            break;

        case XIC_HOT_KEY_STATE:
            MZDEBUG1(DBG_XIM, " XIC_HOT_KEY_STATE [%d]\n", xic->icid );

            xic->hot_key_state = swap32(*((CARD32 *) & data.b[n + 4]));
            break;

        case XIC_STRING_CONVERSION:
            MZDEBUG1(DBG_XIM, " XIC_STRING_CONVERSION [%d]\n", xic->icid );
            /* LATER */
            break;

        case XIC_PREEDIT_ATTRIBUTES:
            MZDEBUG1(DBG_XIM, " XIC_PREEDIT_ATTRIBUTES [%d]\n", xic->icid );
            for ( m = 4, len = swap16(*((CARD16 *) & data.b[n + 2])) + 4; m < len;
                  m += ((4 + swap16(*((CARD16 *) & data.b[n + m + 2])) + 3) / 4) * 4 ) {
                switch (swap16(*((CARD16 *) & data.b[n + m]))) {
                case XIC_AREA:
                    xic->preedit.area.x = swap16(*((INT16 *) & data.b[n + m + 4]));
                    xic->preedit.area.y = swap16(*((INT16 *) & data.b[n + m + 6]));
                    xic->preedit.area.width
                    = swap16(*((INT16 *) & data.b[n + m + 8]));
                    xic->preedit.area.height
                    = swap16(*((INT16 *) & data.b[n + m + 10]));
                    XtSetArg(pargs[p], HawNareaX, xic->preedit.area.x); p++;
                    XtSetArg(pargs[p], HawNareaY, xic->preedit.area.y); p++;
                    XtSetArg(pargs[p], HawNareaWidth, xic->preedit.area.width); p++;
                    XtSetArg(pargs[p], HawNareaHeight, xic->preedit.area.height); p++;

                    MZDEBUG4(DBG_XIM, "  XIC_AREA (%d,%d) %dx%d\n",
                             xic->preedit.area.x, xic->preedit.area.y,
                             xic->preedit.area.width, xic->preedit.area.height );
                    break;

                case XIC_AREA_NEEDED:
                    xic->preedit.area_needed.width
                    = swap16(*((INT16 *) & data.b[n + m + 8]));
                    xic->preedit.area_needed.height
                    = swap16(*((INT16 *) & data.b[n + m + 10]));

                    MZDEBUG2(DBG_XIM, "  XIC_AREA_NEEDED %dx%d\n",
                             xic->preedit.area_needed.width, xic->preedit.area_needed.height );

                    if (xic->preedit.area_needed.width < 18)
                        xic->preedit.area_needed.width = 18;
                    if (xic->preedit.area_needed.height < 18)
                        xic->preedit.area_needed.height = 18;
                    XtSetArg( pargs[p], HawNareaNeededWidth,
                              xic->preedit.area_needed.width );
                    p++;
                    XtSetArg( pargs[p], HawNareaNeededHeight,
                              xic->preedit.area_needed.height );
                    p++;
                    break;

                case XIC_SPOT_LOCATION:
                    xic->preedit.spot_location.x
                    = swap16(*((INT16 *) & data.b[n + m + 4]));
                    xic->preedit.spot_location.y
                    = swap16(*((INT16 *) & data.b[n + m + 6]));
                    /* spot location   Ѵ. */
                    MZDEBUG2(DBG_XIM, "  XIC_SPOT_LOCATION (%d,%d)\n",
                             xic->preedit.spot_location.x,
                             xic->preedit.spot_location.y );
                    break;

                case XIC_COLORMAP:
                    MZDEBUG1(DBG_XIM, "  XIC_COLORMAP [%d]\n", xic->icid );

                    xic->preedit.colormap
                    = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(pargs[p], XtNcolormap, xic->preedit.colormap);
                    p++;
                    break;

                case XIC_FOREGROUND:
                    xic->preedit.foreground
                    = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg( pargs[p], XtNforeground,
                              xic->preedit.foreground );
                    p++;
                    MZDEBUG1(DBG_XIM, "  XIC_FOREGROUND %ld\n", xic->preedit.foreground);
                    break;

                case XIC_BACKGROUND:
                    xic->preedit.background
                    = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg( pargs[p], XtNbackground,
                              xic->preedit.background );
                    p++;
                    MZDEBUG1(DBG_XIM, "  XIC_BACKGROUND %ld\n", xic->preedit.background);
                    break;

                case XIC_BACKGROUND_PIXMAP:
                    MZDEBUG1(DBG_XIM, "  XIC_BACKGROUND_PIXMAP [%d]\n", xic->icid );
                    xic->preedit.pixmap = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(pargs[p], XtNbackgroundPixmap, xic->preedit.pixmap);
                    p++;
                    break;

                case XIC_FONTSET:
                    // preedit.font ǰ ο freeȴ.
                    base_name = XtMalloc(swap16(*((CARD16 *) & data.b[n + m + 4])) + 1);
                    memcpy( base_name, &data.b[n + m + 6],
                            swap16(*((CARD16 *)&data.b[n + m + 4])) );
                    base_name[swap16(*((INT16 *)&data.b[n + m + 4]))] = '\0';

                    MZDEBUG2(DBG_XIM, "  XIC_FONTSET [%d] : %s\n", xic->icid, base_name );

                    xic->preedit.fontset = XCreateFontSet(dpy, base_name,
                                                          &missing_list, &missing_count, &def_string);
                    if (missing_list)
                        XFreeStringList(missing_list);
                    if (base_name)
                        XtFree(base_name);
                    /* def_string client free()ϸ ȵȴ. */
                    if (xic->preedit.fontset == NULL)
                        return(XIM_ERROR_BAD_SOMETHING);
                    XtSetArg(pargs[p], XtNfontSet, xic->preedit.fontset); p++;
                    xic->preedit.ascent = fontset_ascent(xic->preedit.fontset);
                    break;

                case XIC_LINE_SPACING:
                    MZDEBUG1(DBG_XIM, "  XIC_LINE_SPACING [%d]\n", xic->icid );
                    xic->preedit.line_spacing = swap32(*((INT32 *) & data.b[n + m + 4]));
                    XtSetArg(pargs[p], HawNlineSpacing, xic->preedit.line_spacing);
                    p++;
                    break;

                case XIC_CURSOR:
                    MZDEBUG1(DBG_XIM, "  XIC_CURSOR [%d]\n", xic->icid );

                    xic->preedit.cursor = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(pargs[p], XtNcursor, xic->preedit.cursor);
                    p++;
                    break;

                case XIC_PREEDIT_STATE:
                    MZDEBUG1(DBG_XIM, "  XIC_PREEDIT_STATE [%d]\n", xic->icid );
                    xic->preedit.state = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    break;

                default:
                    return(XIM_ERROR_BAD_SOMETHING);
                }
            }
            break;

        case XIC_STATUS_ATTRIBUTES:
            MZDEBUG1(DBG_XIM, " XIC_STATUS_ATTRIBUTES [%d]\n", xic->icid );

            for ( m = 4, len = swap16(*((CARD16 *) & data.b[n + 2])) + 4; m < len;
                  m += ((4 + swap16(*((CARD16 *) & data.b[n + m + 2])) + 3) / 4) * 4 ) {
                switch (swap16(*((CARD16 *) & data.b[n + m]))) {
                case XIC_AREA:
                    xic->status.area.x = swap16(*((INT16 *) & data.b[n + m + 4]));
                    xic->status.area.y = swap16(*((INT16 *) & data.b[n + m + 6]));
                    xic->status.area.width = swap16(*((CARD16 *) & data.b[n + m + 8]));
                    xic->status.area.height = swap16(*((CARD16 *) & data.b[n + m + 10]));
                    XtSetArg(sargs[s], XtNx, xic->status.area.x); s++;
                    XtSetArg(sargs[s], XtNy, xic->status.area.y); s++;
                    XtSetArg(sargs[s], XtNwidth, xic->status.area.width); s++;
                    XtSetArg(sargs[s], XtNheight, xic->status.area.height); s++;

                    MZDEBUG4(DBG_XIM, "  XIC_AREA (%d,%d) %dx%d\n",
                             xic->status.area.x, xic->status.area.y,
                             xic->status.area.width, xic->status.area.height );
                    break;

                case XIC_AREA_NEEDED:
                    xic->status.area_needed.width
                    = swap16(*((CARD16 *) & data.b[n + m + 8]));
                    xic->status.area_needed.height
                    = swap16(*((CARD16 *) & data.b[n + m + 10]));
                    if (xic->status.area_needed.width < 18)
                        xic->status.area_needed.width = 18;
                    if (xic->status.area_needed.height < 18)
                        xic->status.area_needed.height = 18;
                    XtSetArg( sargs[s], HawNareaNeededWidth,
                              xic->status.area_needed.width );
                    s++;
                    XtSetArg( sargs[s], HawNareaNeededHeight,
                              xic->status.area_needed.height );
                    s++;

                    MZDEBUG2(DBG_XIM, "  XIC_AREA_NEEDED %dx%d\n",
                             xic->status.area_needed.width,
                             xic->status.area_needed.height );
                    break;

                case XIC_COLORMAP:
                    MZDEBUG1(DBG_XIM, "  XIC_COLORMAP [%d]\n", xic->icid );
                    xic->status.colormap = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(sargs[s], XtNcolormap, xic->status.colormap);
                    s++;
                    break;

                case XIC_FOREGROUND:
                    xic->status.foreground
                    = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(sargs[s], XtNforeground, xic->status.foreground);
                    s++;
                    MZDEBUG1(DBG_XIM, "  XIC_FOREGROUND %ld\n", xic->status.foreground );
                    break;

                case XIC_BACKGROUND:
                    xic->status.background
                    = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(sargs[s], XtNbackground, xic->status.background);
                    s++;
                    MZDEBUG1(DBG_XIM, "  XIC_BACKGROUND %ld\n", xic->status.background );
                    break;

                case XIC_BACKGROUND_PIXMAP:
                    MZDEBUG1(DBG_XIM, "  XIC_BACKGROUND_PIXMAP [%d]\n", xic->icid );
                    xic->status.pixmap = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(sargs[s], XtNbackgroundPixmap, xic->status.pixmap);
                    s++;
                    break;

                case XIC_FONTSET:
                    if (xic->status.fontset && xic->status.fontset != gFontSet)
                        XFreeFontSet(XtDisplay(TopLevel), xic->status.fontset);
                    base_name
                    = XtMalloc(swap16(*((CARD16 *) & data.b[n + m + 4])) + 1);
                    memcpy( base_name, &data.b[n + m + 6],
                            swap16(*((CARD16 *)&data.b[n + m + 4])) );
                    base_name[swap16(*((INT16 *)&data.b[n + m + 4]))] = '\0';
                    xic->status.fontset = XCreateFontSet(dpy, base_name,
                                                         &missing_list, &missing_count, &def_string);

                    MZDEBUG2(DBG_XIM, "  XIC_FONTSET [%d] : %s\n", xic->icid, base_name);

                    if (missing_list)
                        XFreeStringList(missing_list);
                    if (base_name)
                        XtFree(base_name);
                    /* def_string client free()ϸ ȵȴ. */
                    if (xic->status.fontset == NULL)
                        return(XIM_ERROR_BAD_SOMETHING);
                    XtSetArg(sargs[s], XtNfontSet, xic->status.fontset); s++;
                    break;

                case XIC_CURSOR:
                    MZDEBUG1(DBG_XIM, "  XIC_CURSOR [%d]\n", xic->icid);

                    xic->status.cursor = swap32(*((CARD32 *) & data.b[n + m + 4]));
                    XtSetArg(sargs[p], XtNcursor, xic->status.cursor);
                    s++;
                    break;

                case XIC_LINE_SPACING:
                    xic->status.line_spacing = swap32(*((INT32 *) & data.b[n + m + 4]));
                    MZDEBUG2(DBG_XIM, "  XIC_LINE_SPACING [%d] : %d\n",
                             xic->icid, xic->status.line_spacing);
                    XtSetArg(sargs[s], HawNlineSpacing, xic->status.line_spacing);
                    s++;
                    break;

                default:
                    MZDEBUG2(DBG_XIM, "  UNKNOWN_STATUS_PROTOCAOL[%d]: %x\n",
                             xic->icid, swap16(*((CARD16 *)&data.b[n + m])) );
#ifndef DEBUG
                    return(XIM_ERROR_BAD_SOMETHING);
#endif
                }
            }
            break;

        default:
            MZDEBUG2(DBG_XIM, "  UNKNOWN_PROTOCAOL[%d]: %x\n",
                     xic->icid, swap16(*((CARD16 *)&data.b[n + m])) );
#ifndef DEBUG
            return(XIM_ERROR_BAD_SOMETHING);
#endif
        }
    }
    /* preedit ó */
    if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea)) {
        /* CreatePreedit Լȿ ִ ۲  κ
            ѹ Ǵ ̰,  κ ۲ 
           츶 ȴ. */
        if (xic->preedit.fontset == NULL) {
            xic->preedit.fontset = gFontSet;
            XtSetArg(pargs[p], XtNfontSet, gFontSet); p++;
            xic->preedit.ascent = fontset_ascent(gFontSet);
        }
        if (pmask & _XIC_SPOT_LOCATION) {
            XtSetArg( pargs[p], HawNspotLocationX,
                      xic->preedit.spot_location.x );
            p++;
            XtSetArg( pargs[p], HawNspotLocationY,
                      xic->preedit.spot_location.y -
                      xic->preedit.ascent );
            p++;
            /*  SPOT_LOCAtION ϰ, AREA  ʴ 
             * xic->client_window xic->fontset  ǰ(widget)
             *  쿡 ϸ, ǰ   
             * CreateStatus() Լȿ Ѵ.
             */
            if (xic->buffer->preedit_widget && !(pmask & _XIC_AREA)) {
                XWindowAttributes	attr;

                XGetWindowAttributes(dpy, xic->focus_window, &attr);
                xic->preedit.area.x = xic->preedit.spot_location.x;
                xic->preedit.area.y = xic->preedit.spot_location.y
                                      - xic->preedit.ascent;
                XtSetArg(pargs[p], HawNareaX, xic->preedit.area.x); p++;
                XtSetArg(pargs[p], HawNareaY, xic->preedit.area.y); p++;

                xic->preedit.area.width = attr.width - xic->preedit.area.x;
                xic->preedit.area.height = fontset_ascent(xic->preedit.fontset) +
                                           fontset_descent(xic->preedit.fontset);
                XtSetArg(pargs[p], HawNareaWidth, xic->preedit.area.width);
                p++;
                XtSetArg(pargs[p], HawNareaHeight, xic->preedit.area.height);
                p++;
            }
        }
        if (!xic->buffer->preedit_widget)
            CreatePreedit(dpy, xic, pargs, p);
        else
            XtSetValues(xic->buffer->preedit_widget, pargs, p);
    }
    /* preedit */

    /* status area */
    if (xic->input_style & XIMStatusArea) {
        if (xic->status.fontset == NULL)
            xic->status.fontset = gFontSet;
        if (xic->buffer->status_widget == NULL)
            CreateStatus(dpy, xic, sargs, s);
        else
            XtSetValues(xic->buffer->status_widget, sargs, s);
        /* to change status label widget font value 98/06/25 uw7 */
        if ((smask & _XIC_FONTSET))
            XtVaSetValues(xic->buffer->label_widget, XtNfontSet,
                          xic->status.fontset, NULL);
    }
    return(XIM_NO_ERROR);
}

static void XimBegin(Display *dpy, XimIC *xic)
{
    CARD16 reply[6];

    if (xic->preedit.state == XIMPreeditEnable)
        return;
    xic->preedit.state = XIMPreeditEnable;

    reply[0] = swap16(xic->xim->imid);
    reply[1] = swap16(xic->icid);
    ((CARD32 *)reply)[1] = swap32(KeyPressMask);
    ((CARD32 *)reply)[2] = NoEventMask;
    XimSendClientMessage(dpy, xic->xim->xc, XIM_SET_EVENT_MASK,
		12, (CARD8 *)reply);

    xic->buffer->connect++;
    /* ȭ Ʒ   */
    if (xic->input_style & (XIMPreeditNothing | XIMStatusNothing))
        PEWindowMap(xic->input_style);
    /* â Ʒ ⳪  ڸ   */
    if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea))
        HawPreeditMapWidget(xic->buffer->preedit_widget);

    if (xic->buffer->state & DELETE) {
        XRaiseWindow(XtDisplay(delterm_shell), XtWindow(delterm_shell));
        XRaiseWindow(XtDisplay(question_shell), XtWindow(question_shell));
    }
    if (xic->buffer->state & (ADD | CODE | HANJA))
        XRaiseWindow(XtDisplay(xic->buffer->shell_widget),
			XtWindow(xic->buffer->shell_widget) );

    if (xic->input_style & XIMStatusArea) {
        set_conversion_mode(xic->buffer, xic->buffer->conversion_mode);
        XRaiseWindow(XtDisplay(xic->buffer->status_widget),
			XtWindow(xic->buffer->status_widget));
	}
    else if (xic->input_style & XIMStatusNothing)
        xic->buffer->conversion_mode = sys_buffer.conversion_mode;

    if (xic->input_style & XIMPreeditPosition)
        XtVaSetValues(xic->buffer->preedit_widget, HawNfocus, True, NULL);
	XtSetKeyboardFocus(TopLevel, xic->buffer->preedit_widget);

    set_buffer(xic->buffer->preedit_widget, KeyPress);
}

static void XimEnd(Display *dpy, XimIC *xic)
{
    CARD16 reply[6];

	if(xic->preedit.state == XIMPreeditDisable)
		return;

	xic->preedit.state = XIMPreeditDisable;
	xic->buffer->connect--;

	reply[0] = swap16(xic->xim->imid);
	reply[1] = swap16(xic->icid);
	((CARD32 *)reply)[1] = NoEventMask;
	((CARD32 *)reply)[2] = NoEventMask;
	XimSendClientMessage(dpy, xic->xim->xc, XIM_SET_EVENT_MASK,
		12,	(CARD8 *)reply);

	if (xic->buffer->state & (ERROR | DELETE | CODE | ADD | EDIT | HANJA))
		state_cancel(0, (XtPointer)xic->buffer, 0 );
	if (xic->input_style & (XIMPreeditNothing | XIMStatusNothing))
		PEWindowUnmap(xic->input_style);
	if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea))
		HawPreeditUnmapWidget(xic->buffer->preedit_widget);
	if ( (xic->input_style & XIMStatusArea) &&
		xic->buffer->status_widget ) {
		set_conversion_mode(xic->buffer, NONE);
	}
}

static void XimCreateIc(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic, *xic2;
    int	length;
    CARD16 reply[2];
    CARD16 error;

    if (!(xim = imid2xim(swap16(data.s[2])))) {
        XimSendErrorMessage(dpy, xc, swap16(data.s[2]), 0,
			XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    xic = (XimIC *) XtMalloc(sizeof(XimIC));

    memset(xic, 0, sizeof(XimIC));
    xic->xim = xim;
    xic->icid = new_icid();
    xic->input_style = 0;
    xic->client_window = None;
    xic->focus_window = None;
    xic->reset_state = XIMInitialState;
    xic->hot_key.num_hot_key = 0;
    xic->hot_key_state = XIMHotKeyStateOFF;
    xic->has_focus = False;
    xic->buffer = NULL;
    xic->mask = 0;

    xic->preedit.mask = 0;
    xic->preedit.fontset = NULL;
    xic->preedit.state = XIMPreeditDisable;

    xic->status.fontset = NULL;
    xic->status.mask = 0;

    length = swap16(data.s[3]);
    data.l = &data.l[2];

    if ((error = set_ic_attribute(dpy, xic, length, data))
		!= XIM_NO_ERROR ) {
        XimSendErrorMessage(dpy, xc, xim->imid, 0, error);
        XFree(xic);
        return;
    }

    xic->next = NULL;
    if (xim->xic == NULL) {
        xim->xic = xic;
        xic->previous = NULL;
    } else {
        for (xic2 = xim->xic; xic2->next; xic2 = xic2->next)
            ;
        xic2->next = xic;
        xic->previous = xic2;
    }

    reply[0] = xim->imid;
    reply[1] = xic->icid;
    XimSendClientMessage(dpy, xc, XIM_CREATE_IC_REPLY, 4, (CARD8 *)reply);
}

static void XimDestroyIc(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[2];
    int imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid))) {
        XimSendErrorMessage(dpy, xc, imid, icid, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[0] = swap16(xim->imid);
    reply[1] = swap16(xic->icid);
    XimSendClientMessage(dpy, xc, XIM_DESTROY_IC_REPLY, 4, (CARD8 *)reply);
    if (xic->previous)
        xic->previous->next = xic->next;
    else
        xim->xic = xic->next;
    if (xic->next)
        xic->next->previous = xic->previous;

    destroy_ic(xic);
}


static void XimSetIcValues(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[2];
    CARD16 error;
    int	length;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid))) {
        XimSendErrorMessage(dpy, xc, imid, icid, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    length = swap16(data.s[4]);
    data.l = data.l + 3;
    if ((error = set_ic_attribute(dpy, xic, length, data)) != XIM_NO_ERROR) {
        XimSendErrorMessage(dpy, xc, xim->imid, xic->icid, error);
        return;
    }

    reply[0] = swap16(xim->imid);
    reply[1] = swap16(xic->icid);
    XimSendClientMessage(dpy, xc, XIM_SET_IC_VALUES_REPLY, 4, (CARD8 *)reply);
}


static void XimGetIcValues(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[XIMCP_BUFSIZE];
    int	nreply, nattr, pos;
    int	n, len;
    XimcpAttrRec	*a, *attr;
    String s;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid))) {
        XimSendErrorMessage(dpy, xc, imid, icid, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[2] = swap16(xim->imid);
    reply[3] = swap16(xic->icid);
    reply[4] = 0;    /* return length */
    nreply = 6;
    nattr = swap16(data.s[4]) / 2;
    attr = ic_attr;

    for (n = 0; n < nattr; n++) {
        for (a = attr; a->id != 0; a++) {
            if (swap16(data.s[5 + n]) == a->id) {

                MZDEBUG1(DBG_XIM, "   %s\n", a->name);

                if (a->id == XIC_FONTSET) {
                    XFontSet	fs;

                    memcpy(&fs, (CARD8 *)xic + a->offset, sizeof(XFontSet));
                    s = XBaseFontNameListOfFontSet(fs);
                    len = strlen(s);
                    reply[nreply++] = swap16(len);
                    memcpy(&reply[nreply], s, len);
                    nreply += (len + Pad(len)) / 2;
                }
                /* nested list  Ͱ   Ѵ. */
                else if (a->nested_list) {
                    reply[nreply++] = swap16(a->id);
                    pos = nreply;
                    reply[nreply++] = 0;
                    attr = a->nested_list;
                } else if (a->type == XimRseparatorOfNestedList) {
                    reply[pos] = swap16((nreply - pos - 1) * 2);
                    attr = ic_attr;
                } else {
                    reply[nreply++] = swap16(a->id);
                    reply[nreply++] = swap16(a->size);
                    memcpy(reply + nreply, (CARD8 *)xic + a->offset, a->size);
                    nreply += (a->size + Pad(a->size)) / 2;
                }
                break;
            }
        }
    }

    nreply = (nreply - 1) * sizeof(CARD16);
    reply[4] = swap16(nreply - 12);
    if (nreply <= 20)
        XimSendClientMessage( dpy, xc, XIM_GET_IC_VALUES_REPLY, nreply - 4,
                              (CARD8 *)&reply[2] );
    else {
        ((CARD8 *)reply)[0] = XIM_GET_IC_VALUES_REPLY;
        ((CARD8 *)reply)[1] = 0;
        XimSendProperty(dpy, xc, xim_ic_values, nreply, (CARD8 *)reply);
    }
}

static void XimSetIcFocus(Display *dpy, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    MZDEBUG1(DBG_XIM, "[ICID : %d]\n", xic->icid);

    xic->has_focus = True;
    if (prefer.event_flow == STATIC_CONTROL)
        XimBegin(dpy, xic);
}

static void XimUnsetIcFocus(Display *dpy, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    MZDEBUG1(DBG_XIM, "[ICID : %d]\n", xic->icid);

    if ((xic->input_style & XIMStatusArea) && xic->buffer->status_widget)
        set_conversion_mode(xic->buffer, NONE);

    if (xic->input_style & (XIMPreeditPosition | XIMPreeditArea))
        XtVaSetValues(xic->buffer->preedit_widget, HawNfocus, False, NULL);
    xic->has_focus = False;
    if (prefer.event_flow == STATIC_CONTROL &&
        xic->buffer->state == PREEDIT)
        XimEnd(dpy, xic);
}

static void XimForwardEvent(Display *dpy, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    XKeyEvent key;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    key.type = KeyPress;
    key.serial = swap16(((xEvent *) & data.l[3])->u.u.sequenceNumber);
    key.serial |= swap16(data.s[5]) << 16;
    key.send_event = False;
    key.display = dpy;
    key.window = XtWindow(xic->buffer->preedit_widget);
    key.root = swap32(((xEvent *) & data.l[3])->u.keyButtonPointer.root);
    key.time = swap32(((xEvent *) & data.l[3])->u.keyButtonPointer.time);
    key.x = swap16(((xEvent *) & data.l[3])->u.keyButtonPointer.eventX);
    key.y = swap16(((xEvent *) & data.l[3])->u.keyButtonPointer.eventY);
    key.x_root = swap16(((xEvent *) & data.l[3])->u.keyButtonPointer.rootX);
    key.y_root = swap16(((xEvent *) & data.l[3])->u.keyButtonPointer.rootY);
    key.state = swap16(((xEvent *) & data.l[3])->u.keyButtonPointer.state);
    key.keycode = ((xEvent *) & data.l[3])->u.u.detail;
    key.same_screen = True;

    XPutBackEvent(dpy, (XEvent *)&key);
}

static void XimSync(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[2];
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid))) {
        XimSendErrorMessage(dpy, xc, imid, icid, XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    reply[0] = swap16(xim->imid);
    reply[1] = swap16(xic->icid);
    XimSendClientMessage(dpy, xc, XIM_SYNC_REPLY, 4, (CARD8 *)reply);
}

static void XimResetIc(XClientMessageEvent *event, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD8	reply[XIMCP_BUFSIZE];
    Buffer	*b;
    XTextProperty	text;
    int	n;
    hchar_t	hstr[512];
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid))) {
        XimSendErrorMessage(event->display, xc, imid, icid,
                            XIM_ERROR_BAD_PROTOCOL);
        return;
    }

    if (xic->reset_state == XIMInitialState) {
        ((CARD16 *)reply)[0] = swap16(xim->imid);
        ((CARD16 *)reply)[1] = swap16(xic->icid);
        ((CARD32 *)reply)[1] = NoEventMask;
        ((CARD32 *)reply)[2] = NoEventMask;
        XimSendClientMessage( event->display, xc, XIM_SET_EVENT_MASK,
                              12, (CARD8 *)reply );
    }

    b = xic->buffer;
    if (xic->preedit.state == XIMPreeditDisable) {
        text.nitems = 0;
        text.value = (unsigned char *)XtMalloc(1);
        text.value[0] = '\0';
    } else {
        if (b->state & ~(PREEDIT | HANJA)) {
            n = 0;
            cancel( b->preedit_widget, (XEvent *)event,
                    NULL, (XtPointer)&n );
        }
        if (b->state & PREEDIT) {
            register_buffer(b);
            hcscpy(hstr, b->hangul);
        } else if (b->state & HANJA)
            hanja_cancel(0, b, 0);
        if (hstr[0]) {
            HawHstrToTextProperty( event->display, hstr,
                                   XCompoundTextStyle, &text );
        } else {
            text.nitems = 0;
            text.value = (unsigned char *)XtMalloc(1);
            text.value[0] = '\0';
        }
    }

    ((CARD16 *)reply)[2] = swap16(xim->imid);
    ((CARD16 *)reply)[3] = swap16(xic->icid);
    ((CARD16 *)reply)[4] = swap16(text.nitems);
    memcpy(&reply[10], text.value, text.nitems);
    n = 4 + 6 + text.nitems;
    if (n <= 20)
        XimSendClientMessage(event->display, xc,
                             XIM_RESET_IC_REPLY, n - 4, reply + 4);
    else {
        reply[0] = XIM_RESET_IC_REPLY;
        reply[1] = 0;
        XimSendProperty(event->display, xim->xc, xim_reset, n, reply);
    }
    XFree(text.value);

    b->state = PREEDIT;
    if (xic->reset_state == XIMInitialState) {
        XimEnd(event->display, xic);
        ((CARD16 *)reply)[0] = swap16(xim->imid);
        ((CARD16 *)reply)[1] = swap16(xic->icid);
        ((CARD32 *)reply)[1] = swap32(KeyPressMask);
        ((CARD32 *)reply)[2] = swap32(NoEventMask);
        XimSendClientMessage( event->display, xc, XIM_SET_EVENT_MASK,
                              12, (CARD8 *)reply );
    }
}

static void XimTriggerNotify(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    CARD16 reply[8];
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    if (data.l[2] == 0) {
        MZDEBUG(DBG_XIM, " ON\n");
		XimBegin(dpy, xic);
    } else {
        MZDEBUG(DBG_XIM, " OFF\n");
		XimEnd(dpy, xic);
    }

    reply[0] = swap16(xim->imid);
    reply[1] = swap16(xic->icid);
    XimSendClientMessage(dpy, xc, XIM_TRIGGER_NOTIFY_REPLY, 4, (CARD8 *)reply);
}


static void
XimExtForwardKeyevent(XClientMessageEvent *event, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    XKeyEvent key;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    key.type = event->data.b[12];
    key.serial = event->serial;
    key.send_event = False;
    key.display = event->display;
    key.window = xic->focus_window;
    key.root = DefaultRootWindow(event->display);
    key.time = swap32(data.l[4]);
    key.x = 0;
    key.y = 0;
    key.x_root = 0;
    key.y_root = 0;
    key.state = swap16(data.s[7]);
    key.keycode = event->data.b[13];
    key.same_screen = True;
    XPutBackEvent(event->display, (XEvent *)&key);
}

static void XimExtMove(Display *dpy, XimConn *xc, CARD data)
{
    XimIM	*xim;
    XimIC	*xic;
    Arg	args[2];
    short	x, y;
    int	imid, icid;

    imid = swap16(data.s[2]);
    icid = swap16(data.s[3]);
    if (!(xim = imid2xim(imid)) || !(xic = icid2xic(icid)))
        return;

    if (xic->input_style & XIMPreeditPosition) {
        xic->preedit.spot_location.x = x = swap16(data.s[4]);
        xic->preedit.spot_location.y = y = swap16(data.s[5]);
        XtSetArg(args[0], HawNspotLocationX, x);
        XtSetArg(args[1], HawNspotLocationY, y - xic->preedit.ascent);
        XtSetValues(xic->buffer->preedit_widget, args, 2);

        MZDEBUG1(DBG_XIM, " Set PreeditArea : x : %d\n", (int)x );
        MZDEBUG1(DBG_XIM, " Set PreeditArea : y : %d\n", (int)y );
    }
}

static void ximcp_connect(XClientMessageEvent *event)
{
    XimConn	*xc;
    Window	window = (Window)event->data.l[0];
    XClientMessageEvent	ev;

    xc = (XimConn *)XtMalloc(sizeof(XimConn));
    xc->ims_window = XCreateSimpleWindow(event->display,
                                         event->window, 0, 0, 1, 1, 0, 0, 0);
    xc->client_window = window;
    xc->endian = 0;
    xc->xim = NULL;

    xc->next = connection;
    connection = xc;
    if (xc->next != NULL)
        xc->next->previous = xc;
    xc->previous = NULL;

    XSelectInput(event->display, window, StructureNotifyMask);

    ev.type = ClientMessage;
    ev.window = window;
    ev.message_type = xim_connect;
    ev.format = 32;
    ev.data.l[0] = xc->ims_window;
    ev.data.l[1] = 0;
    ev.data.l[2] = 0;

    XSendEvent(event->display, window, False, 0, (XEvent *)&ev);
}

static void ximcp_receive(XClientMessageEvent *event)
{
    XimConn	*xc;
    Atom	actual_type;
    int	actual_format;
    unsigned long	nitems;
    unsigned long	bytes_after;
    CARD	data;

    xc = connection;
    event->window = xc->ims_window;

    if (event->format == 8)
        data.b = (CARD8 *)event->data.b;
    else if (XGetWindowProperty( event->display, event->window,
                                 (Atom)event->data.l[1], 0L, 1000000L, True,
                                 AnyPropertyType, &actual_type, &actual_format,
                                 &nitems, &bytes_after,
                                 (unsigned char **)&data ) != Success) {
        XimSendErrorMessage( event->display, xc, 0, 0,
                             XIM_ERROR_BAD_PROTOCOL );
        return;
    }
    if (!data.b)
        return;

    last_endian = current_endian;
    current_endian = xc->endian;

    switch (data.b[0]) {
    case XIM_CONNECT:
        current_endian = xc->endian = data.b[4];
        if (event->format == 8)
            xc->bug = (swap16(data.s[1]) > 4);
        else
            xc->bug = (swap16(data.s[1]) == nitems - 4);
        MZDEBUG(DBG_XIM, xc->bug ? "XIM_CONNECT:bug\n" : "XIM_CONNECT\n");
        XimConnect(event->display, xc, data);
        break;

    case XIM_DISCONNECT:
        MZDEBUG(DBG_XIM, "XIM_DISCONNECT\n");
        XimDisconnect(event->display, xc, data);
        break;

    case XIM_OPEN:
        MZDEBUG(DBG_XIM, "XIM_OPEN\n");
        XimOpen(event->display, xc, data);
        break;

    case XIM_CLOSE:
        MZDEBUG(DBG_XIM, "XIM_CLOSE\n");
        XimClose(event->display, xc, data);
        break;

    case XIM_TRIGGER_NOTIFY:
        MZDEBUG(DBG_XIM, "XIM_TRIGGER_NOTIFY\n");
        XimTriggerNotify(event->display, xc, data);
        break;

    case XIM_ENCODING_NEGOTIATION:
        MZDEBUG(DBG_XIM, "XIM_ENCODING_NEGOTIATION\n");
        XimEncodingNegotiation(event->display, xc, data);
        break;

    case XIM_QUERY_EXTENSION:
        MZDEBUG(DBG_XIM, "XIM_QUERY_EXTENSION\n");
        XimQueryExtension(event->display, xc, data);
        break;

    case XIM_SET_IM_VALUES:
        MZDEBUG(DBG_XIM, "XIM_SET_IM_VALUES\n");
        XimSetImValues(event->display, xc, data);
        break;

    case XIM_GET_IM_VALUES:
        MZDEBUG(DBG_XIM, "XIM_GET_IM_VALUES\n");
        XimGetImValues(event->display, xc, data);
        break;

    case XIM_CREATE_IC:
        MZDEBUG(DBG_XIM, "XIM_CREATE_IC\n");
        XimCreateIc(event->display, xc, data);
        break;

    case XIM_DESTROY_IC:
        MZDEBUG(DBG_XIM, "XIM_DESTROY_IC\n");
        XimDestroyIc(event->display, xc, data);
        break;

    case XIM_SET_IC_VALUES:
        MZDEBUG(DBG_XIM, "XIM_SET_IC_VALUES\n");
        XimSetIcValues(event->display, xc, data);
        break;

    case XIM_GET_IC_VALUES:
        MZDEBUG(DBG_XIM, "XIM_GET_IC_VALUES\n");
        XimGetIcValues(event->display, xc, data);
        break;

    case XIM_SET_IC_FOCUS:
        MZDEBUG(DBG_XIM, "XIM_SET_IC_FOCUS");
        XimSetIcFocus(event->display, data);
        break;

    case XIM_UNSET_IC_FOCUS:
        MZDEBUG(DBG_XIM, "XIM_UNSET_IC_FOCUS");
        XimUnsetIcFocus(event->display, data);
        break;

    case XIM_FORWARD_EVENT:
        MZDEBUG(DBG_XIM, "XIM_FORWARD_EVENT\n");
        XimForwardEvent(event->display, data);
        break;

    case XIM_SYNC:
        MZDEBUG(DBG_XIM, "XIM_SYNC\n");
        XimSync(event->display, xc, data);
        break;

    case XIM_RESET_IC:
        MZDEBUG(DBG_XIM, "XIM_RESET_IC\n");
        XimResetIc(event, xc, data);
        break;

    case XIM_EXT_FORWARD_KEYEVENT:
        MZDEBUG(DBG_XIM, "XIM_EXT_FORWARD_KEYEVENT\n");
        XimExtForwardKeyevent(event, xc, data);
        break;

    case XIM_EXT_MOVE:
        MZDEBUG(DBG_XIM, "XIM_EXT_MOVE\n");
        XimExtMove(event->display, xc, data);
        break;

    case XIM_ERROR:
        MZDEBUG1(DBG_XIM, "%s : XIM_ERROR protocol received.\n",
                 program_name);
        break;

    default:
        MZDEBUG2(DBG_XIM, "%s : unknown XIM common protocol received. [%d]\n",
                 program_name, data.b[0]);
        XimSendErrorMessage( event->display, xc, 0, 0,
                             XIM_ERROR_BAD_PROTOCOL );
        break;
    }
}

static void procNoEventMask( Widget w, XtPointer client_data,
                             XEvent *event, Boolean *continue_to_dispatch )
{
    XSelectionEvent	xselection;
    Display	*display = event->xany.display;

    switch (event->type) {
    case SelectionClear:
        if (event->xselectionclear.selection == xim_selection) {
            fprintf(stderr, "%s : selection clear event occured.\n",
                    program_name);
            done();
        }
        break;

    case SelectionRequest:
        xselection.type = SelectionNotify;
        xselection.requestor = event->xselectionrequest.requestor;
        xselection.selection = event->xselectionrequest.selection;
        xselection.target = event->xselectionrequest.target;
        xselection.time = event->xselectionrequest.time;
        xselection.property = event->xselectionrequest.property;

        MZDEBUG1(DBG_XIM, "requestor : 0x%08x\n",
                 event->xselectionrequest.requestor );
        MZDEBUG1(DBG_XIM, "selection : %s\n",
                 XGetAtomName(display, event->xselectionrequest.selection) );
        MZDEBUG1(DBG_XIM, "target    : %s\n",
                 XGetAtomName(display, event->xselectionrequest.target ));
        MZDEBUG1(DBG_XIM, "property  : %s\n",
                 XGetAtomName(display, event->xselectionrequest.property ));

        if (event->xselectionrequest.selection == xim_selection) {
            if (event->xselectionrequest.target == xim_transport)
                XChangeProperty( display, xselection.requestor,
                                 xselection.property, xselection.target,
                                 8, PropModeReplace,
                                 (unsigned char *)XIM_TRANSPORT_REPLY,
                                 strlen(XIM_TRANSPORT_REPLY) );
            else if (event->xselectionrequest.target == xim_locales)
                XChangeProperty( display, xselection.requestor,
                                 xselection.property, xselection.target,
                                 8, PropModeReplace,
                                 (unsigned char *)XIM_LOCALES_REPLY,
                                 strlen(XIM_LOCALES_REPLY) );
            else
                xselection.property = None;
        } else
            xselection.property = None;
        XSendEvent( display, xselection.requestor, False, 0,
                    (XEvent *)&xselection );
        break;

    case ClientMessage:
        if (event->xclient.message_type == xim_protocol)
            ximcp_receive((XClientMessageEvent *)event);
        else if (event->xclient.message_type == xim_connect)
            ximcp_connect((XClientMessageEvent *)event);
        break;
    }
}


static void procPropertyChangeMask(Widget w, XtPointer client_data,
                                   XEvent *event, Boolean *continue_to_dispatch)
{
    XPropertyEvent	*ev = (XPropertyEvent *)event;
    Display	*display = XtDisplay(w);
    Window	window = XtWindow(w);
    Window	root = DefaultRootWindow(display);
    char	ss[256];
    int	ii, jj;
    Atom	type, *prop;
    int	format;
    unsigned long	nitems, after;

    XGrabServer(display);

    sprintf(ss, "@server=%s", program_name);
    xim_selection = XInternAtom(display, ss, False);
    XSetSelectionOwner(display, xim_selection, window, ev->time);

    XGetWindowProperty( display, root, xim_servers, 0, 10000, True, XA_ATOM,
                        &type, &format, &nitems, &after,
                        (unsigned char **)&prop );

    if (type == None && format == 0 && after == 0)
        XChangeProperty( display, root, xim_servers, XA_ATOM, 32,
                         PropModeReplace, (unsigned char *)&xim_selection, 1 );
    else {
        for (ii = 0; ii < nitems; ii++) {
            if (prop[ii] == xim_selection) {
                for (jj = ii; jj > 0; jj--)
                    prop[jj] = prop[jj - 1];
                ii = -1;
                break;
            }
        }
        if (ii == nitems) {
            nitems++;
            prop = (Atom *)XtRealloc((char *)prop, sizeof(Atom) * nitems);
            for (ii = nitems - 1; ii > 0; ii--)
                prop[ii] = prop[ii - 1];
        }
        prop[0] = xim_selection;
        XChangeProperty( display, root, xim_servers, XA_ATOM, 32,
                         PropModeReplace, (unsigned char *)prop, nitems );
        XFree((char *)prop);
    }

    XUngrabServer(display);

    XtRemoveEventHandler( (Widget)client_data, PropertyChangeMask, False,
                          procPropertyChangeMask, client_data );
}

void ximcp_initialize(void)
{
    Display *dpy = XtDisplay(TopLevel);

    XtAddEventHandler(TopLevel, NoEventMask, True, procNoEventMask, NULL);
    XtAddEventHandler( TopLevel, PropertyChangeMask, False,
                       procPropertyChangeMask, (XtPointer)TopLevel );

    xim_servers	= XInternAtom(dpy, _XIM_SERVERS, False);
    xim_transport = XInternAtom(dpy, _XIM_TRANSPORT, False);
    xim_locales = XInternAtom(dpy, _XIM_LOCALES, False);

    xim_connect = XInternAtom(dpy, _XIM_XCONNECT, False);
    xim_protocol = XInternAtom(dpy, _XIM_PROTOCOL, False);

    xim_open = XInternAtom(dpy, _XIM_OPEN, False);
    xim_register_triggerkeys =
        XInternAtom(dpy, _XIM_REGISTER_TRIGGERKEYS, False);
    xim_query_extension = XInternAtom(dpy, _XIM_QUERY_EXTENSION, False);
    xim_im_values = XInternAtom(dpy, _XIM_IM_VALUES, False);
    xim_ic_values = XInternAtom(dpy, _XIM_IC_VALUES, False);
    xim_commit = XInternAtom(dpy, _XIM_COMMIT, False);
    xim_reset = XInternAtom(dpy, _XIM_RESET, False);
    xim_forward_event = XInternAtom(dpy, _XIM_FORWARD_EVENT, False);

    current_endian = last_endian = endian;
}

Boolean XimcpChangeClientMessage(XEvent *event)
{
    XimConn *xc;

    if (event->xclient.message_type != xim_protocol)
        return False;
    if (event->xclient.message_type == xim_protocol) {
        for (xc = connection; xc != NULL; xc = xc->next) {
            if (xc->ims_window == event->xclient.window) {
                if (xc->previous) {
                    xc->previous->next = xc->next;
                    if (xc->next)
                        xc->next->previous = xc->previous;
                    connection->previous = xc;
                    xc->next = connection;
                    xc->previous = NULL;
                    connection = xc;
                }
                event->xclient.window = XtWindow(TopLevel);
                return(True);
            }
        }
    }
    return(False);
}

Boolean XimcpChangeExpose(XEvent *event)
{
    XimConn *xc;
    XimIM	*xim;
    XimIC	*xic;

    for (xc = connection; xc != NULL; xc = xc->next) {
        for (xim = xc->xim; xim != NULL; xim = xim->next) {
            for (xic = xim->xic; xic != NULL; xic = xic->next) {
                if ( xic->focus_window == event->xexpose.window &&
                     (xic->input_style & (XIMPreeditPosition | XIMPreeditArea)) ) {
                    event->xexpose.window = XtWindow(xic->buffer->preedit_widget);
                    return(True);
                }
            }
        }
    }
    return(False);
}

Boolean XimcpDestroyNotify(XEvent *event)
{
    XimConn *xc;
    XimIM *xim, *xim2;
    XimIC *xic, *xic2;

    for (xc = connection; xc; xc = xc->next) {
        if (xc->client_window == event->xdestroywindow.window) {
            for (xim = xc->xim; xim; xim = xim2) {
                for (xic = xim->xic; xic; xic = xic2) {
                    xic2 = xic->next;
                    destroy_ic(xic);
                }
                xim2 = xim->next;
                XFree(xim);
            }
            if (xc->previous)
                xc->previous->next = xc->next;
            else
                connection = xc->next;
            if (xc->next)
                xc->next->previous = xc->previous;
            XDestroyWindow(XtDisplay(TopLevel), xc->ims_window);
            XFree(xc);
            return(True);
            break;
        }
    }
    return(False);
}

// create preedit/status widget
static void CreatePreedit(Display *dpy, XimIC *xic, Arg *pargs, int p)
{
    XWindowAttributes	attr;
    char	name[20];
    CARD32	mask, pmask;

    mask = xic->mask;
    pmask = xic->preedit.mask;

    /* set_ic_attributes() */
    if (!(mask & (_XIC_CLIENT_WINDOW | _XIC_FOCUS_WINDOW))) {
        xic->focus_window = connection->client_window;
        xic->client_window = connection->client_window;
        XtSetArg(pargs[p], HawNfocusWindow, xic->focus_window);
        p++;
    }
    /* fontset  */
    if ((pmask & _XIC_FONTSET) == 0) {
        xic->preedit.fontset = gFontSet;
        XtSetArg( pargs[p], XtNfontSet, gFontSet); p++;
        xic->preedit.ascent = fontset_ascent(gFontSet);
        if (pmask & _XIC_SPOT_LOCATION) {
            XtSetArg( pargs[p], HawNspotLocationX,
                      xic->preedit.spot_location.x );
            p++;
            XtSetArg( pargs[p], HawNspotLocationY,
                      xic->preedit.spot_location.y - xic->preedit.ascent );
            p++;
        }
    }
    /* ʱȭ ѹ */
    XGetWindowAttributes(dpy, xic->focus_window, &attr);
    if ((pmask & _XIC_SPOT_LOCATION) && !(pmask & _XIC_AREA)) {
        xic->preedit.area.x = xic->preedit.spot_location.x;
        xic->preedit.area.y = xic->preedit.spot_location.y
                              - xic->preedit.ascent;
        XtSetArg(pargs[p], HawNareaX, xic->preedit.area.x); p++;
        XtSetArg(pargs[p], HawNareaY, xic->preedit.area.y); p++;

        xic->preedit.area.width = attr.width - xic->preedit.area.x;
        xic->preedit.area.height = fontset_ascent(xic->preedit.fontset) +
                                   fontset_descent(xic->preedit.fontset);
        XtSetArg(pargs[p], HawNareaWidth, xic->preedit.area.width);
        p++;
        XtSetArg(pargs[p], HawNareaHeight, xic->preedit.area.height);
        p++;
    }

    XtSetArg(pargs[p], XtNborderWidth, 0); p++;
    XtSetArg(pargs[p], XtNdepth, attr.depth); p++;
    XtSetArg(pargs[p], XtNscreen, attr.screen); p++;
    XtSetArg(pargs[p], XtNaccelerators, resources.base_accelerators);
    p++;

    /* area_needed */
    assert(xic->preedit.fontset != 0);
    if ((pmask & _XIC_AREA_NEEDED) == 0) {
        register int hh = fontset_ascent(xic->preedit.fontset)
                          + fontset_descent(xic->preedit.fontset);

        xic->preedit.area_needed.x = 150;
        xic->preedit.area_needed.y = attr.height - hh;
        xic->preedit.area_needed.width = attr.width - 160;
        xic->preedit.area_needed.height = hh;
    }
    if ( !(pmask & _XIC_COLORMAP) &&
         (pmask & (_XIC_FOREGROUND | _XIC_BACKGROUND)) ) {
        xic->preedit.colormap = attr.colormap;
        XtSetArg(pargs[p], XtNcolormap, xic->preedit.colormap);
        p++;
    }

    sprintf(name, "Pre%04x%04x", xic->xim->imid, xic->icid);
    xic->buffer->preedit_widget =
        HawCreatePreedit(TopLevel, name, pargs, p);
    if (xic->preedit.state == XIMPreeditEnable)
        HawPreeditMapWidget(xic->buffer->preedit_widget);
    else
        HawPreeditUnmapWidget(xic->buffer->preedit_widget);
    XtInstallAccelerators( xic->buffer->preedit_widget,
                           xic->buffer->preedit_widget );
    if (resources.accelerators) {
        XtOverrideTranslations( xic->buffer->preedit_widget,
                                resources.accelerators );
        XtInstallAccelerators( xic->buffer->preedit_widget,
                               xic->buffer->preedit_widget );
    }

    /* ڰ   κ ⺻ ġѴ. */
    p = 0;
    if (!(pmask & _XIC_SPOT_LOCATION )) {
        XtSetArg(pargs[p], HawNspotLocationX, &xic->preedit.spot_location.x);
        p++;
        XtSetArg(pargs[p], HawNspotLocationY, &xic->preedit.spot_location.y);
        p++;
    }
    if (!(pmask & _XIC_COLORMAP)) {
        XtSetArg(pargs[p], XtNcolormap, &xic->preedit.colormap);
        p++;
    }
    if (!(pmask & _XIC_FOREGROUND )) {
        XtSetArg(pargs[p], XtNforeground, &xic->preedit.foreground);
        p++;
    }
    if (!(pmask & _XIC_BACKGROUND )) {
        XtSetArg(pargs[p], XtNbackground, &xic->preedit.background);
        p++;
    }
    if (!(pmask & _XIC_BACKGROUND_PIXMAP)) {
        XtSetArg(pargs[p], XtNbackgroundPixmap, &xic->preedit.pixmap);
        p++;
    }
    XtGetValues(xic->buffer->preedit_widget, pargs, p);
}

static void CreateStatus(Display *dpy, XimIC *xic, Arg *sargs, int s)
{
    XWindowAttributes	attr;
    char	name[20];
    unsigned long	lbg;
    CARD32	mask, smask;

    mask = xic->mask;
    smask = xic->status.mask;

    if (!(mask & (_XIC_CLIENT_WINDOW | _XIC_FOCUS_WINDOW))) {
        xic->focus_window = connection->client_window;
        xic->client_window = connection->client_window;
        XtSetArg(sargs[s], HawNparentWindow, xic->client_window);
        s++;
    }

    XGetWindowAttributes(dpy, xic->focus_window, &attr);
    XtSetArg(sargs[s], XtNdepth, attr.depth); s++;
    XtSetArg(sargs[s], XtNscreen, attr.screen); s++;
    XtSetArg(sargs[s], XtNaccelerators, resources.base_accelerators); s++;

    /* area_needed */
    if ((smask & _XIC_AREA_NEEDED) == 0) {
        if (smask & _XIC_AREA) {
            xic->status.area_needed.x = xic->status.area.x;
            xic->status.area_needed.y = xic->status.area.y;
            xic->status.area_needed.width =
                XmbTextEscapement(xic->status.fontset, resources.hanIM, 100 ) + 40;
            xic->status.area_needed.height = xic->status.area.height;
        } else {
            register int hh = fontset_ascent(xic->status.fontset) +
                              fontset_descent(xic->status.fontset);

            xic->status.area_needed.x = 0;
            xic->status.area_needed.y = (attr.height > hh) ?
                                        (attr.height - hh) : 0; ;
            xic->status.area_needed.width =
                XmbTextEscapement(xic->status.fontset, resources.hanIM, 100 ) + 40;
            xic->status.area_needed.height = hh;
        }
    }
    /* area */
    if (!(smask & _XIC_AREA)) {
        /* set_ic_attributes() Լ Ǿ ִ. */
        xic->status.area.x = xic->status.area_needed.x;
        xic->status.area.y = xic->status.area_needed.y;
        xic->status.area.width = xic->status.area_needed.width;
        xic->status.area.height = xic->status.area_needed.height;

        XtSetArg(sargs[s], XtNx, xic->status.area.x); s++;
        XtSetArg(sargs[s], XtNy, xic->status.area.y); s++;
        XtSetArg(sargs[s], XtNwidth, xic->status.area.width); s++;
        XtSetArg(sargs[s], XtNheight, xic->status.area.height); s++;
    }
    if (!(smask & _XIC_COLORMAP)) {
        xic->status.colormap = attr.colormap;
        XtSetArg(sargs[s], XtNcolormap, xic->status.colormap); s++;
    }
    if (!(smask & _XIC_FOREGROUND)) {
        xic->status.foreground = default_foreground;
        XtSetArg(sargs[s], XtNforeground, default_foreground); s++;
    }
    if (!(smask & _XIC_BACKGROUND)) {
        xic->status.background = default_background;
        XtSetArg(sargs[s], XtNbackground, default_background); s++;
    }
    /*   . */
    sprintf(name, "Sts%04x%04x", xic->xim->imid, xic->icid);
    xic->buffer->status_widget =
        HawCreateManagedStatusArea(TopLevel, name, sargs, s);

    s = 0;
    lbg = light_color(xic->status.colormap, xic->status.background);
    XtSetArg(sargs[s], XtNborderWidth, 0); s++;
    XtSetArg(sargs[s], XtNbackground, xic->status.background); s++;
    XtSetArg(sargs[s], XtNforeground, xic->status.foreground); s++;
    XtSetArg(sargs[s], XtNlabel, resources.hanIM); s++;
    XtSetArg( sargs[s], XtNfontSet, xic->status.fontset); s++;

    xic->buffer->label_widget =
        XtCreateManagedWidget( "Label", hLabelWidgetClass,
                               xic->buffer->status_widget, sargs, s );

	if(xic->preedit.state == XIMPreeditDisable)
		set_conversion_mode(xic->buffer, 0);
	else
		set_conversion_mode(xic->buffer, resources.initial_mode);
    XtMapWidget(xic->buffer->status_widget);
}

#endif /* USE_XIMCP */
