/* $Id: XuiAction.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<assert.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>

#include	<X11/Xlib.h>
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/keysym.h>
#include	<X11/Xatom.h>
#include	<Haw/HanList.h>
#include	<Haw/Preedit.h>
#include	<Haw/TextOut.h>

#include	"hangul.h"
#include	"hcodec.h"
#include	"romandic.h"

#include	"hanim.h"
#include	"resource.h"
#include	"buffer.h"
#include	"XuiRootWin.h"
#include	"protowrap.h"

extern Widget	AddTermText[], AddTerm;

static void	bs();
static void	del();
static void	down();
static void	end();
static void	next();
static void	previous();
static void	scroll_down();
static void	scroll_up();
static void	through();
static void	toggle();
static void	top();
static void	up();

void	cancel();
void	help();
void	hanim_connect();
void	hanim_disconnect();

extern void	codetable();   		/* code.c	*/
extern void	edit();				/* edit.c	*/

extern void	initial_mode();   	/* mode.c	*/
extern void	english12();		/* mode.c	*/
extern void	cyrillic();   		/* mode.c	*/
extern void	english();   		/* mode.c	*/
extern void	english_qwerty();   /* mode.c	*/
extern void	english_dvorak();   /* mode.c	*/
extern void	hanja();			/* hanja.c	*/
extern void	hiragana();   		/* mode.c	*/
extern void	katakana();   		/* mode.c	*/
extern void	hiragana_roman();   /* mode.c	*/
extern void	katakana_roman();   /* mode.c	*/
#if 0 /* LATER */
extern void	hiragana_hangul();  /* mode.c	*/
extern void	katakana_hangul();  /* mode.c	*/
#endif    /* LATER */
extern void	hangul();   		/* mode.c	*/
extern void	hangul3();   		/* mode.c	*/
extern void	hangul2();   		/* mode.c	*/
#if 0 /* LATER */
extern void	hangul_roman();   	/* mode.c	*/
#endif    /* LATER */
extern void	keycap();   		/* keycap.c	*/
extern void	select_lang();   	/* langmenu.c	*/
extern void	inkey();			/* inkey.c	*/
extern void	idiom();			/* idiom.c	*/
extern void	edit_idiom();   	/* idiom.c	*/
extern void	commit();   		/* commit.c	*/
extern void	delterm();   		/* delterm.c	*/
extern void	addterm();   		/* addterm.c	*/

extern void	error_cancel	(Widget, XtPointer, XtPointer);
extern void	delterm_cancel	(Widget, XtPointer, XtPointer);
extern void	addterm_cancel	(Widget, XtPointer, XtPointer);
extern void	code_cancel		(Widget, XtPointer, XtPointer);
extern void	hanja_cancel	(Widget, XtPointer, XtPointer);
extern void	edit_cancel		(Buffer *);
extern void	open_url		(const char *url);

/** @name ൿ Լ(action)  κ */
/*@{*/

static	XtActionsRec	actionTable[] = {
    { "add-term", addterm	},
    { "cancel", cancel	},
    { "codetable", codetable	},
    { "connect", hanim_connect	},
    { "commit", commit	},
    { "cyrillic", cyrillic	},
    { "delete", del	},
    { "delete-term", delterm	},
    { "disconnect", hanim_disconnect },
    { "divided-delete", bs	},
    { "down", down	},
    { "edit", edit	},
    { "edit-idiom", edit_idiom	},
    { "english", english	},
    { "english-qwerty", english_qwerty	},
    { "english-dvorak", english_dvorak	},
    { "english12", english12	},
    { "end", end	},
    { "hanja", hanja	},
    { "help", help	},
    { "hiragana", hiragana	},
    { "hiragana-roman", hiragana_roman	},
    { "initial-mode", initial_mode	},
    { "inkey", inkey	},
    { "katakana", katakana	},
    { "katakana-roman", katakana_roman	},
    { "keycap", keycap	},
#if 0 /* LATER */
    { "hiragana-hangul", hiragana_hangul	},
    { "katakana-hangul", katakana_hangul	},
#endif    /* LATER */
    { "hangul", hangul	},
    { "hangul3", hangul3	},
    { "hangul2", hangul2	},
#if 0 /* LATER */
    { "hangul-roman", hangul_roman	},
#endif    /* LATER */
    { "next", next	},
    { "previous", previous	},
    { "idiom", idiom	},
    { "scroll-down", scroll_down	},
    { "scroll-up", scroll_up	},
    { "select-lang", select_lang	},
    { "through", through	},
    { "toggle", toggle	},
    { "top", top	},
    { "up", up	}};

#ifndef NDEBUG
static void action_hook( Widget w, XtPointer client,
                         String action_name, XEvent *ev,
                         String *params, Cardinal *num_params )
{
    int	n;

    printf("action_name = \"%s\"\n", action_name);
    for (n = 0; n < *num_params; n++)
        printf("params[%d] = \"%s\"\n", n, params[n]);
}
#endif

/// ർ Լ ߰Ѵ.
void AddActions(XtAppContext app)
{
    XtAppAddActions(app, actionTable, XtNumber(actionTable));
#ifndef NDEBUG
    if (resources.debug & DBG_ACTION)
        XtAppAddActionHook(app, action_hook, NULL);
#endif
}


#define	ALL_STATE	(INIT | PREEDIT | HANJA | EDIT | \
ADD | DELETE | CODE | ERROR)

/// ൿ Լ μ ˻Ѵ.
int check_action_args(String *params, int n, char *name )
{
#define	LEN	3

    int	ii;
    State	state1 = 0;
    State	state2 = ALL_STATE;

    static struct {
        char	*name;
        State	flag;
    } string[] = {
        { "init", INIT	},
        { "preedit", PREEDIT	},
        { "hanja", HANJA	},
        { "edit", EDIT	},
        { "add", ADD	},
        { "delete", DELETE	},
        { "code", CODE	},
        { "error", ERROR	}
    };
    register int	nitems = sizeof(string) / sizeof(string[1]);

    while (n-- > 0) {
        for (ii = 0; ii < nitems; ii++) {
            if (!STRNCASECMP(params[n], string[ii].name, LEN)) {
                state1 |= string[ii].flag;
                break;
            } else if (params[n][0] == '!' || params[n][0] == '~') {
                if (!STRNCASECMP(params[n] + 1, string[ii].name, LEN)) {
                    state2 &= ~string[ii].flag;
                    break;
                }
            }
        }
        if (ii == nitems)
            fprintf( stderr, "Warning: Invalid state, %s() ignored.\n",
                     name );
    }
    if (state1 != 0 && state2 != ALL_STATE) {
        fputs( "Warning: Invalid translation, translation ignored.",
               stderr );
        return(False);
    }
    if (state1 == 0)
        state1 = state2;

    if (buffer->state == PREEDIT && buffer->key[0] == '\0')
        return(state1 & INIT);
    else if ( buffer->state & ERROR)
        return(state1 & ERROR);
    else {
        state2 = buffer->state;
        if (state2 & (CODE | DELETE | HANJA))
            state2 &= CODE | DELETE | HANJA;
        return(state1 & state2);
    }
}

/// ̺ Ѵ.

void set_conversion_mode(Buffer *b, ConversionMode mode)
{
    String string;

    switch (mode) {
    case HANGUL_3BULSIK:
        string = resources.hangul_3bulsik;
        break;
    case HANGUL_2BULSIK:
        string = resources.hangul_2bulsik;
        break;
    case ENGLISH_QWERTY:
        string = resources.english_qwerty;
        break;
    case ENGLISH_DVORAK:
        string = resources.english_dvorak;
        break;
    case JAPANESE_ENG_HIRAGANA:
        string = resources.japanese_eng_hiragana;
        break;
    case JAPANESE_ENG_KATAKANA:
        string = resources.japanese_eng_katakana;
        break;
    case JAPANESE_HIRAGANA:
        string = resources.japanese_hiragana;
        break;
    case JAPANESE_KATAKANA:
        string = resources.japanese_katakana;
        break;
#if 0 /* LATER */
    case HANGUL_HAN_ROMAN:
        string = resources.hangul_roman;
        break;
    case JAPANESE_HAN_HIRAGANA:
        string = resources.japanese_han_hiragana;
        break;
    case JAPANESE_HAN_KATAKANA:
        string = resources.japanese_han_katakana;
        break;
#endif    /* LATER */
    case CYRILLIC:
        string = resources.cyrillic_mode;
        break;
    default:
        /* Ŀ    Ű  */
        string = resources.hanIM;
        break;
    }
    if (b->label_widget)
        XtVaSetValues(b->label_widget, XtNlabel, string, NULL);
    if (mode) {
        XtVaSetValues(b->preedit_widget, HawNdisplayCaret, True, NULL);
        b->conversion_mode = mode;
        /* we made system buffer's mode to last one. */
        sys_buffer.conversion_mode = mode;
    } else {
        XtVaSetValues(b->preedit_widget, HawNdisplayCaret, False, NULL);
    }
}

static void set_cursor_position(Buffer *b)
{
    Widget	w;
    Position	pos;

    if (b->state & ADD)
        HawTextOutSetCursorPosition(AddTermText[1], b->cursor);
    else if (b->xim_style & XIMPreeditNothing) {
        if (b->state & PREEDIT)
            w = b->preedit_widget;
        else if (b->state & EDIT)
            w = PEText; // zzz
        HawTextOutSetCursorPosition(w, b->cursor);
    } else if (b->xim_style & (XIMPreeditPosition | XIMPreeditArea)) {
        if (b->state & (PREEDIT | CODE))
            HawPreeditSetCursorPosition(b->preedit_widget, b->cursor);
        else if (b->state & EDIT) {
            HawPreeditSetCursorPosition(b->preedit_widget, pos);
        }
    }
}

/// ̺Ʈ Ŭ̾Ʈ Ѵ.

static void through(Widget w, XKeyEvent *ev, String *params, int *n)
{
    Buffer	*b;
    Window	win;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ~PREEDIT) ||
         !check_action_args(params, *n, "through" ))
        return;
    if (b->key[0] != '\0')
        return;
    win = ev->subwindow;
    SendKeyEvent(win, ev);
}

///  ׸ ̵Ѵ.

static void next(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer	*b;
    unsigned int	p;
    Position	pos;

    b = set_buffer(w, ev->type);
    if (b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "next" ))
        return;
    if (b->state & (PREEDIT | EDIT) && COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }

    p = b->point;

    if (b->state & CODE || b->state & HANJA) {
        HawListNextItem(b->list_widget);
        return;
    } else if (b->state & DELETE) {
        HawListNextItem(b->list_widget);
        return;
    } else if (b->state & PREEDIT && !b->hangul[0])
        return;
    else if (b->state & (PREEDIT | ADD | EDIT)) {
        pos = b->cursor;
        if (b->hangulC[b->end_point] == pos) {
            XBell(ev->xany.display, 0);
            return;
        } else {
            if (b->hangulC[p] != pos)
                p = ++b->point;
            if (b->conversion_flag[p]) {
                do {
                    p = ++b->point;
                    b->cursor = b->hangulC[p];
                } while ( b->str[b->keyC[p]] != '\0' &&
                          b->conversion_flag[p] );
                if ( b->str[b->keyC[p]] != '\0' &&
                     !b->conversion_flag[p] ) {
                    b->cursor = b->hangulC[p + 1];
                    set_conversion_mode(b, b->mode[p]);
                }
            } else if (p + 1 <= b->end_point) {
                b->cursor = b->hangulC[p + 1];
                set_conversion_mode(b, b->mode[p]);
            }
            if (pos != b->cursor)
                set_cursor_position(b);
        }
    } else if (b->state & HANJA) {
        HawListNextItem(b->list_widget);
        return;
    }
}

///  ׸ ̵Ѵ.

static void previous(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;
    unsigned int	p;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "previous" ))
        return;
    if (b->state & (PREEDIT | EDIT) && COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }

    p = b->point;
    if (b->state & DELETE) {
        HawListPreviousItem(b->list_widget);
        return;
    } else if ( b->state & CODE ||
                b->state & HANJA ) {
        HawListPreviousItem(b->list_widget);
        return;
    }

    if ((b->state & PREEDIT) && (! b->hangul[0]))
        return;
    if (b->state & (PREEDIT | ADD | EDIT)) {
        if (b->cursor == 0) {
            XBell(ev->xany.display, 0);
            return;
        } else {
            if (b->hangulC[p] == b->cursor)
                p = --b->point;
            b->cursor = b->hangulC[p];
            while (b->str[b->keyC[p]] != '\0') {
                p = --b->point;
                b->cursor = b->hangulC[p];
            }
            set_cursor_position(b);
        }

        if (p != 0 && !b->conversion_flag[p - 1]) {
            b->point--;
            set_conversion_mode(b, b->mode[b->point]);
        }
    }
}

///  ׸ ̵Ѵ.

static void up(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "up" ))
        return;
    if (b->state & (PREEDIT | EDIT) && COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }

    if (b->state & DELETE)
        HawListPreviousItem(b->list_widget);
    else if (b->state & CODE)
        HawListUpItem(b->list_widget);
    else if (b->state & HANJA) {
        HawListUpItem(b->list_widget);
    }
}

/// Ʒ ׸ ̵Ѵ.

static void down(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "down" ))
        return;
    if (b->state & (PREEDIT | EDIT) && COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }

    if (b->state & DELETE)
        HawListNextItem(b->list_widget);
    else if (b->state & CODE)
        HawListDownItem(b->list_widget);
    else if (b->state & HANJA) {
        HawListDownItem(b->list_widget);
    }
}

/// ó ̵Ѵ.

static void top(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "top" ))
        return;
    if ( (b->state & (PREEDIT | EDIT)) &&
         COMB_STATE(b->hautomata) ) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }
    if (b->state & DELETE) {
        HawListTopItem(b->list_widget);
        return;
    }
    if (b->state & PREEDIT && !b->hangul[0])
        return;
    if (b->state & (PREEDIT | ADD | EDIT)) {
        b->point = 0;
        if (b->cursor != 0) {
            b->cursor = 0;
            set_cursor_position(b);
        }
    } else if (b->state & (HANJA | CODE)) {
        HawListTopItem(b->list_widget);
    }
}

///  ̵Ѵ.

static void end(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer	*b;
    unsigned int	p;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "end" ))
        return;
    if (b->state & (PREEDIT | EDIT) && COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }

    if (b->state & DELETE) {
        HawListEndItem(b->list_widget);
        return;
    }
    if ((b->state & PREEDIT) && !b->hangul[0])
        return;
    if (b->state & (PREEDIT | ADD | EDIT)) {
        p = b->point = b->end_point - 1;
        if (b->hangulC[p] == b->hangulC[b->end_point])
            b->cursor = b->hangulC[p];
        else {
            b->cursor = b->hangulC[b->end_point];
            set_conversion_mode(b, b->mode[p]);
        }
        set_cursor_position(b);
    } else if (b->state & (HANJA | CODE)) {
        HawListEndItem(b->list_widget);
    }
}

///  ũѴ.

static void scroll_up(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "scroll-up" ))
        return;

    if (b->state & (HANJA | CODE | DELETE))
        HawListPageDownItem(b->list_widget);
}

/// Ʒ ũѴ.
static void scroll_down(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "scroll-down" ))
        return;

    if (b->state & ( HANJA | CODE | DELETE))
        HawListPageUpItem(b->list_widget);
}

/// ѿ ¸ ȯѴ.
/** 丶Ÿ ޾ƿ ΰ ƴϸ ó 
   ó ΰ   ִ. ӵ 鿡 丶Ÿ
        ѱ̳ Ϻ θ Է
    ǿ ϹǷ  óϿ. */

static void toggle(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, ev->type);

    if (b == NULL || !check_action_args(params, *n, "toggle"))
        return;
    if ((b->conversion_mode & LANGMASK) == HANGUL) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
        /* ڷ   ڷ  
           ڰ ҽ ǿ Ѵ. */
        english(w, ev, params, n);
    } else
        hangul(w, ev, params, n);
}

///    Ѵ.
void state_cancel(Widget w, XtPointer client, XtPointer call)
{
    Buffer *b = (Buffer *)client;

    if (b->state & ERROR)
        error_cancel((Widget)NULL, (XtPointer)b, (XtPointer)NULL);
    else if (b->state & DELETE)
        delterm_cancel((Widget)NULL, (XtPointer)b, (XtPointer)NULL);
    else if (b->state & ADD)
        addterm_cancel((Widget)NULL, (XtPointer)b, (XtPointer)NULL);
    else if (b->state & CODE)
        code_cancel((Widget)NULL, (XtPointer)b, (XtPointer)NULL);
    else if (b->state & EDIT)
        edit_cancel(b);
    else if (b->state & HANJA)
        hanja_cancel((Widget)NULL, (XtPointer)b, (XtPointer)NULL);
}

void cancel(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b;

    b = set_buffer(w, ev->type);
    if (b == NULL || !check_action_args(params, *n, "cancel"))
        return;

    if (b->state & (ERROR | DELETE | CODE | ADD | EDIT | HANJA))
        state_cancel(0, (XtPointer)b, 0 );
    else if (b->state & PREEDIT) {
        if (COMB_STATE(b->hautomata)) {
            complete_hangul(b);
            clear_hangul_automata(&b->hautomata);
        }
#if 1
        /* ESC ÿ disconnectϸ vi  ſ ϴ. */
        if (b->keyC[1] == 0)
            Disconnect(ev->xkey.display, ev->xkey.subwindow);
        else {
#endif
            XtVaSetValues(b->preedit_widget, HawNdisplayCaret, True, NULL);
            buffer_initialize(b);
            if (b->xim_style & XIMPreeditNothing)
                HawTextOutSetString( b->preedit_widget, NULL,
                                     HawHIGHLIGHT_NORMAL );
            else
                HawPreeditSetString( b->preedit_widget, NULL,
                                     HawHIGHLIGHT_SECONDARY_SELECTED );
#if 1
        }
#endif
    }
}

/// 齺̽ Ѵ.
static void bs(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer	*b;
    unsigned int	p, ep;
    unsigned short	fcode, ecode;
    ConversionMode	mode;
    char	*ss;
    hchar_t	hs1[MAX_KEY];
    Widget	widget;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "divided-delete" ))
        return;

    if (b->state & ADD) {
        widget = AddTermText[1];
    } else if (b->state & EDIT) {
        if (b->xim_style & (XIMPreeditPosition | XIMPreeditArea))
            widget = b->preedit_widget;
        else
            widget = PEText; // zzz
    } else if (b->state & (PREEDIT | CODE)) {
        widget = b->preedit_widget;
    }

    if (b->state & (PREEDIT | ADD | EDIT | CODE)) {
        if (b->cursor == 0) {
            assert( b->point == 0);
            return;
        }
        p = b->point;
        ep = b->end_point;
        if (b->keyC[p] == b->keyC[ep])
            ep = --b->end_point;
        if (b->cursor == b->hangulC[p])
            p = --b->point;

        switch (mode = b->mode[p]) {
        case HANGUL_3BULSIK:
        case HANGUL_2BULSIK:
#if 1 /* ڼҹ  */
            /* Է  ѱ  */
            if (get_hangul_code(&b->hautomata, '\b', &fcode, &ecode) == code_hanbs) {
                /* ڼ    */
                /* ѱ ̻ϰ óϴ ٶ  ̻. */
                hs1[0] = fcode; hs1[1] = 0;
                delete_character_buffer(b, widget, hs1, b->mode[p]);
                b->conversion_flag[b->point] = True;
#if 1	/* ϴ ǰ  LATER */
                b->cursor = b->point + 1;
                b->hangulC[p + 1] = b->hangulC[p] + 1;
#endif
            } else {
#endif     /* ڼҹ   */
                /*  ڸ    */
                delete_word_buffer(b, widget);
                if (p > 0 && !b->conversion_flag[p - 1]) {
                    set_conversion_mode(b, b->mode[p - 1]);
                    b->point--;
                    if (b->keyC[p] == b->keyC[ep])
                        b->end_point--;
                }
#if 1  /* ڼҹ  */
            }
#endif     /* ڼҹ  */
            break;

#if 0 /* FROG */
        case JAPANESE_ENG_HIRAGANA:
        case JAPANESE_ENG_KATAKANA:
        case HANGUL_HAN_ROMAN:
        case JAPANESE_HAN_HIRAGANA:
        case JAPANESE_HAN_KATAKANA:
            /* θ ȯ ̺ Էϴ  */
            if (p != 0 && b->str[b->keyC[p + 1]-1] != '\0') {
                delete_word_buffer(b, widget);
                if (b->keyC[p] == b->keyC[ep])
                    b->end_point--;
                p = --b->point;
            }
            if (b->conversion_flag[p]) {
                if ((ii = b->keyC[p + 1] - b->keyC[p] - 1) == 0) {
                    delete_word_buffer(b, widget);
                    if (p > 0 && !b->conversion_flag[p - 1]) {
                        set_conversion_mode(b, b->mode[p - 1]);
                        b->point--;
                        if (b->keyC[p] == b->keyC[p + 1])
                            b->end_point--;
                    }
                } else {
                    set_conversion_mode(b, mode);
                    strncpy((char *)s1, (char *)&b->key[b->keyC[p]], ii);
                    s1[ii] = '\0';
                    if (!(mode & (HANKAKU_HIRAGANA | HANKAKU_KATAKANA))) {
                        kssms2hcs(w2, s1, strlen((char *)s1));
#if 0 /* LATER */
                        one2two(w2, hs1, mode);
#endif
                    } else
                        mbstohcs(hs1, (char *)s1, strlen((char *)s1));

                    delete_character_buffer(b, widget, hs1, mode);

                    if (0xa1 <= s1[0] && s1[0] <= 0xdf) {
                        b->conversion_flag[p] = True;
                        p = ++b->point;
                        if (p == ep) {
                            b->end_point++;
                            b->keyC[ep + 1] = b->keyC[ep];
                            b->hangulC[ep + 1] = b->hangulC[ep];
                        }
                    } else {
                        rt = alpha2hiraganaUpperS(s1);
#if 0 /* LATER */
                        if ( rt != NULL &&
                             strncmp( (char *)s1, (char *)rt->next->key,
                                      strlen((char *)s1) ) == 0 )
                            b->rt = rt;
#endif
                    }
                }
            } else {
                if ((ii = b->keyC[p + 1] - b->keyC[p] - 1) == 0) {
                    delete_word_buffer(b, widget);
                    if (p > 0 && !b->conversion_flag[p - 1]) {
                        set_conversion_mode(b, b->mode[p - 1]);
                        b->point--;
                        if (b->keyC[p] == b->keyC[ep])
                            b->end_point--;
                    }
                } else {
                    delete_character_buffer(b, widget, NULL, mode);
                    strncpy((char *)s1, (char *)&b->key[b->keyC[p]], ii);
                    s1[ii] = '\0';
                    rt = hanim_forward_search(s1);
#if 0 /* LATER */
                    if ( rt != NULL &&
                         strncmp((char *)s1, (char *)rt->next->key, ii ) == 0)
                        b->rt = rt;
#endif
                }
            }
            break;
#endif

        case ENGLISH_QWERTY:
        case ENGLISH_DVORAK:
        case JAPANESE_HIRAGANA:
        case JAPANESE_KATAKANA:
        case CYRILLIC:
        default:
            /*  ʿ  ó */
            delete_word_buffer(b, widget);
            if (p > 0 && !b->conversion_flag[p - 1]) {
                set_conversion_mode(b, b->mode[p - 1]);
                b->point--;
                if (b->keyC[p] == b->keyC[ep])
                    b->end_point--;
            }
            break;
        }
    }

    if (b->state & ADD) {
        if (!strlen(ss = HawTextOutGetString(widget))) {
            XtVaSetValues(AddTerm, XtNsensitive, False, NULL);
        }
        XFree(ss);
    }
    set_cursor_position(b);
}

/// delete Ѵ.
static void del(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer	*b;
    unsigned int	p, ep;
    unsigned char	s1[MAX_HANGUL];
    int	ii;
    RomanTable	*rt;
    char	*ss;
    Widget	widget;

    b = set_buffer(w, ev->type);
    if ( b == NULL || (b->state & ERROR) ||
         !check_action_args(params, *n, "delete" ))
        return;

    if (b->state & (PREEDIT | CODE))
        widget = b->preedit_widget;
    else if (b->state & ADD)
        widget = AddTermText[1];
    else if (b->state & EDIT)
        widget = PEText; // zzz

    if (b->state & (PREEDIT | ADD | EDIT | CODE)) {
        if (b->cursor == 0)
            return;

        p = b->point;
        ep = b->end_point;
        if (b->keyC[p] == b->keyC[ep])
            ep = --b->end_point;
        if (b->cursor == b->hangulC[p])
            p = --b->point;

        switch (b->mode[p]) {
        case JAPANESE_ENG_HIRAGANA:
        case JAPANESE_ENG_KATAKANA:
#if 0 /* LATER */
            b->rt = NULL;
#endif
            if (p != 0 && b->str[b->keyC[p + 1]-1] != '\0') {
                delete_word_buffer(b, widget);
                if (b->keyC[p] == b->keyC[ep])
                    b->end_point--;
                p = --b->point;
            }
            if (b->conversion_flag[p]) {
                delete_word_buffer(b, widget);
                if (p > 0 && !b->conversion_flag[p - 1]) {
                    set_conversion_mode(b, b->mode[p - 1]);
                    b->point--;
                    if (b->keyC[p] == b->keyC[p + 1])
                        b->end_point--;
                }
            } else {
                if ((ii = b->keyC[p + 1] - b->keyC[p] - 1) == 0) {
                    delete_word_buffer(b, widget);
                    if (p > 0 && !b->conversion_flag[p - 1]) {
                        set_conversion_mode(b, b->mode[p - 1]);
                        b->point--;
                        if (b->keyC[p] == b->keyC[ep])
                            b->end_point--;
                    }
                } else {
                    delete_character_buffer(b, widget, NULL, b->mode[p]);
                    strncpy((char *)s1, (char *)&b->key[b->keyC[p]], ii);
                    s1[ii] = '\0';
                    rt = jp_forward_sub_search(s1);
#if 0 /* LATER */
                    if ( rt != NULL &&
                         strncmp((char *)s1, (char *)rt->next->key, ii ) == 0)
                        b->rt = rt;
#endif
                }
            }
            break;

#if 0 /* LATER */
        case HAN_ROMAN:
        case JAPANESE_HAN_HIRAGANA:
        case JAPANESE_HAN_KATAKANA:
#endif    /* LATER */
        case HANGUL3:
        case HANGUL2:
        case ENGLISH_QWERTY:
        case ENGLISH_DVORAK:
        case JAPANESE_HIRAGANA:
        case JAPANESE_KATAKANA:
        case CYRILLIC:
            /* 丶Ÿ ʱȭ  ܾ ⸦ Ѵ. */
            if (b->mode[p] == HANGUL3 || b->mode[p] == HANGUL2)
                clear_hangul_automata(&b->hautomata);

            delete_word_buffer(b, widget);
            if (p > 0 && !b->conversion_flag[p - 1]) {
                set_conversion_mode(b, b->mode[p - 1]);
                b->point--;
                if (b->keyC[p] == b->keyC[ep])
                    b->end_point--;
            }
            break;
        }
    }
    if (b->state & ADD) {
        if (!strlen(ss = HawTextOutGetString(widget))) {
            XtVaSetValues(AddTerm, XtNsensitive, False, NULL);
        }
        XFree(ss);
    }
    set_cursor_position(b);
}

/// 
void hanim_connect(Widget w, XEvent *ev, String *params, Cardinal *n)
{}

///  



void hanim_disconnect(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, ev->type);
    if (b == NULL || !check_action_args(params, *n, "disconnect"))
        return;
    if (COMB_STATE(b->hautomata)) {
        complete_hangul(b);
        clear_hangul_automata(&b->hautomata);
    }
    Disconnect(ev->xany.display, ev->xkey.subwindow);
}

/// 

void help(Widget w, XEvent *ev, String *params, Cardinal *n)
{
    char url[256];

    sprintf(url, "file:%s/help/index.html", sys_directory);
    open_url(url);
}

/*@}*/
