/* $Id: XuiCommit.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdlib.h>
#include	<Haw/Preedit.h>
#include	<Haw/TextOut.h>

#include	"hangul.h"
#include	"hcodec.h"

#include	"hanim.h"
#include	"resource.h"
#include	"buffer.h"
#include	"XuiRootWin.h"
#include	"protowrap.h"

extern int	check_action_args( String *, int, char * );
extern Pixel	light_color( Colormap, Pixel );

extern void	error_cancel( Widget, XtPointer, XtPointer );
extern void	delterm_commit( Widget, XtPointer, XtPointer );
extern void	addterm_commit( Widget, XtPointer, XtPointer );
extern void	hanja_commit( Widget, XtPointer, XtPointer );
extern void	edit_commit( Buffer *b );
extern void	code_commit( Buffer *b, hchar_t code );

/// Commit
/**  ϴ κ ַ  ڸ ġ ȴ.
    b->state 캸 ׿ ° Ѵ. */

void commit(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer	*b;
    hchar_t	hc;
    Window	win;

    b = set_buffer( w, event->type );
    if ( b == NULL || !check_action_args( params, *n, "commit" ) )
        return;

    if ( b->state & ERROR ) {
        error_cancel( (Widget)NULL, (XtPointer)b, (XtPointer)NULL );
        return;
    } else if ( b->state & DELETE )
        delterm_commit( w, (XtPointer)b, (XtPointer)NULL );
    else if ( b->state & CODE ) {
#ifdef DEBUG
        hc = ksc2hc(b->ksc5601);
        code_commit( b, hc );
#else
        code_commit( b, ksc2hc(b->ksc5601) );
#endif
    } else if ( b->state & ADD ) {
        addterm_commit( w, (XtPointer)b, (XtPointer)b );
    } else if ( b->state & EDIT ) {
        edit_commit( b );
    } else if ( b->state & HANJA ) {
        hanja_commit( w, (XtPointer)b, (XtPointer)b );
        XtVaSetValues( b->preedit_widget, HawNdisplayCaret, True, NULL );
    } else if ( b->state & PREEDIT ) {
        if ( (b->conversion_mode & LANGMASK) == HANGUL &&
             COMB_STATE(b->hautomata) ) {
            complete_hangul( b );
            clear_hangul_automata( &b->hautomata );
        }
        if ( b->hangul[0] != '\0' ) {
            win = event->xkey.subwindow;
            if ( SendCompoundText( event->xany.display, win, b->hangul ) ) {
                register_buffer( b );
                buffer_initialize( b );
            }
        }
        if ( (b->xim_style & XIMPreeditNothing) &&    /* root Է Ÿ */
             resources.ghost_mode == True ) {
            GhostHide();
        }
    } /* PREEDIT */
}
