/* $Id: XuiEdit.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<Haw/TextOut.h>
#include	<Haw/Preedit.h>

#include	"hangul.h"
#include	"hcodec.h"

#include	"hanim.h"
#include	"resource.h"
#include	"hstring.h"
#include	"buffer.h"
#include	"XuiRootWin.h"

extern int check_action_args(String *, int, char *);

static Widget shell, Edit;

static void edit_position(Buffer *b, Widget w,
                          XEvent *event, String *params, Cardinal *n)
{
    b->state = EDIT;
}


void edit(Widget w, XEvent *event, String *params, Cardinal *n)
{
    /* LATER */
    return;

#ifdef LATER
    Buffer	*b;
    int	ii, jj;
    int	start, end;
    int	key_start, hangul_start;
    Position	x;

    b = set_buffer( w, event->type );
    if ( b == NULL || !check_action_args( params, *n, "edit" ) )
        return;

    if ( !(b->state & HANJA) )
        return;

    if ( b->xim_style & (XIMPreeditPosition | XIMPreeditArea) ) {
        edit_position( b, w, event, params, n );
        return;
    }

    push_buffer( b );
    b->state = EDIT;
    XtVaSetValues( Edit, HawNdisplayCaret, True, NULL );
    XtMapWidget( Edit);
    HawTextOutSetHighlight( Edit, 0, 1000, HawHIGHLIGHT_NORMAL );

    XtSetKeyboardFocus( shell, Edit);

    for ( start = 0; b->hangulC[start] != ii; start++ );
    for ( end = start; b->hangulC[end] != ii; end++ );
    if ( end >= MAX_KEY )	/* LATER */
        return;

    for ( ii = 0, jj = b->keyC[start]; jj < b->keyC[end]; ii++, jj++ ) {
        b->key[ii] = b->key[jj];
        b->str[ii] = b->str[jj];
    }
    while ( ii < MAX_KEY ) {
        b->key[ii] = b->str[ii] = '\0';
        ii++;
    }
    for ( ii = 0, jj = b->hangulC[start]; jj < b->hangulC[end]; ii++, jj++ )
        b->hangul[ii] = b->hangul[jj];
    while ( ii < MAX_HANGUL )
        b->hangul[ii++] = '\0';
    key_start = b->keyC[start];
    hangul_start = b->hangulC[start];
    for ( ii = 0, jj = start; jj <= end; ii++, jj++ ) {
        b->keyC[ii] = b->keyC[jj] - key_start;
        b->hangulC[ii] = b->hangulC[jj] - hangul_start;
        b->mode[ii] = b->mode[jj];
        b->conversion_flag[ii] = b->conversion_flag[jj];
    }
    b->keyC[ii + 1] = b->keyC[ii];
    b->hangulC[ii + 1] = b->hangulC[ii];
    jj = ii;
    while ( ++ii < MAX_KEY ) {
        b->keyC[ii] = 0;
        b->mode[ii] = 0;
        b->conversion_flag[ii] = False;
    }
    while ( ++jj < MAX_HANGUL )
        b->hangulC[jj] = 0;

    b->end_point = end - start;
    if ( b->conversion_flag[b->end_point - 1] ) {
        end = ++b->end_point;
        b->keyC[end] = b->keyC[end - 1];
        b->hangulC[end] = b->hangulC[end - 1];
    }
    b->point = b->end_point - 1;
    b->cursor = b->hangulC[b->end_point];

    HawTextOutSetStringHcs( Edit, b->hangul, HawHIGHLIGHT_NORMAL );
    HawTextOutSetCursorPosition( Edit, b->cursor );
#endif
}

void edit_cancel( Buffer *b )
{
    int	start, end;

    if ( b->xim_style & (XIMPreeditPosition | XIMPreeditArea) ) {
        hchar_t	ss[MAX_KEY];

        XtVaSetValues( b->preedit_widget, HawNdisplayCaret, False, NULL );

        end = start + hcslen( b->hangul );
        pop_buffer( b );

        HawPreeditReplaceHcs( b->preedit_widget, start, end, ss );
        HawPreeditSetHighlight( b->preedit_widget, start, start + hcslen(ss),
                                HawHIGHLIGHT_SELECTED );
        b->state = HANJA;
    } else {
        XtUnmapWidget( Edit);

        XtVaSetValues( Edit, HawNdisplayCaret, False, NULL );
        if ( b->xim_style & XIMPreeditNothing )
            XtSetKeyboardFocus( shell, Edit );
        pop_buffer( b );
        b->state = HANJA;
    }
}

void edit_commit( Buffer *b )
{
    int	ii, jj, delta;
    int	start, end, length;
    Buffer	btmp;

    btmp = *b;
    edit_cancel( b );

    for ( start = 0; b->hangulC[start] != ii; start++ );
    for ( end = start; b->hangulC[end] != ii; end++ );

    length = hcslen( btmp.hangul );

    for ( ii = b->keyC[end]; ii < b->keyC[end + 1]; ii++ )
        b->str[ii] = '\0';
    for ( ii = btmp.keyC[btmp.end_point], jj = b->keyC[end];
          jj < b->keyC[b->end_point]; ii++, jj++ ) {
        btmp.key[ii] = b->key[jj];
        btmp.str[ii] = b->str[jj];
    }
    btmp.key[ii] = btmp.str[ii] = '\0';

    for ( ii = btmp.hangulC[btmp.end_point], jj = b->hangulC[end];
          jj < b->hangulC[b->end_point]; ii++, jj++ )
        btmp.hangul[ii] = b->hangul[jj];
    btmp.hangul[ii] = '\0';

    if ( btmp.keyC[btmp.end_point - 1] == btmp.keyC[btmp.end_point] )
        btmp.end_point--;
    if ( btmp.keyC[btmp.end_point] == 0 )
        btmp.end_point = 0;
    for ( ii = btmp.end_point, jj = end; jj <= b->end_point; ii++, jj++ ) {
        btmp.keyC[ii] = b->keyC[jj] - b->keyC[end] + btmp.keyC[btmp.end_point];
        btmp.hangulC[ii] = b->hangulC[jj] - b->hangulC[end] +
                           btmp.hangulC[btmp.end_point];
        btmp.mode[ii] = b->mode[jj];
        btmp.conversion_flag[ii] = b->conversion_flag[jj];
    }
    btmp.end_point += b->end_point - end;
    b->end_point = start;


    delta = 0;
    if ( b->str[b->keyC[start]] ) {
        ii = strlen( (char *) & b->str[b->keyC[start]] );
        if ( ii > b->keyC[start + 1] - b->keyC[start] )
            ii = b->keyC[start + 1] - b->keyC[start];
        if ( strncmp( (char *)&b->str[b->keyC[start]], (char *)btmp.str, ii ) )
            delta = ii;
    }

    for ( ii = b->keyC[start] - delta, jj = 0; jj < btmp.keyC[btmp.end_point];
          ii++, jj++ ) {
        b->key[ii] = btmp.key[jj];
        b->str[ii] = btmp.str[jj];
    }
    b->key[ii] = b->str[ii] = '\0';

    for ( ii = b->hangulC[start], jj = 0; jj < btmp.hangulC[btmp.end_point];
          ii++, jj++ )
        b->hangul[ii] = btmp.hangul[jj];
    b->hangul[ii] = '\0';

    for ( ii = start, jj = 0, start = b->keyC[start] - delta;
          jj <= btmp.end_point; ii++, jj++ ) {
        b->keyC[ii] = btmp.keyC[jj] + start;
        b->hangulC[ii] = btmp.hangulC[jj] + b->hangulC[start];
        b->mode[ii] = btmp.mode[jj];
        b->conversion_flag[ii] = btmp.conversion_flag[jj];
    }
    b->end_point += btmp.end_point;

    b->conversion_mode = btmp.conversion_mode;
}
