/* $Id: XuiHanja.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>
#include	<Haw/HanList.h>
#include	<Haw/Preedit.h>
#include	<Haw/TextOut.h>
#include	<Haw/Util.h>

#include	"hangul.h"
#include	"hcodec.h"
#include	"hanjadic.h"

#include	"hanim.h"
#include	"resource.h"
#include	"buffer.h"
#include	"XuiDialog.h"
#include	"XuiRootWin.h"

extern int	check_action_args( String *, int, char * );
extern void	hanim_error(Buffer *, Widget, String);
extern Pixel	light_color( Colormap, Pixel );

#define MAXHANJA 64

static hchar_t	gHanja[MAXHANJA];
static int	gHanjaLen;

/** @name  ȯ Լ */
/*@{*/

///  ȯ Ѵ.

void hanja_cancel(Widget w, XtPointer client, XtPointer call)
{
    Buffer	*b = (Buffer *)client;

    XtDestroyWidget( b->shell_widget );
    b->shell_widget = NULL;
    b->state &= ~HANJA;

    hjdic_close();
}

///  ȭ Ѵ.

void hanja_commit(Widget w, XtPointer client, XtPointer call)
{
    Buffer	*b = (Buffer *)client;
    unsigned int	p;
    hchar_t	hh[2];
    int	count, selected_item;

    XtVaGetValues( b->list_widget, HawNselectedItem, &selected_item, NULL );

    if ( selected_item != -1 ) {
        save_buffer( b );

        /*  ȯ */
        p = --b->point;
        hh[0] = gHanja[selected_item];
        hh[1] = '\0';
        if ( !replace_hangul( b, hh ) ) {
            load_buffer( b );
            return;
        }

        count = b->hangulC[p];
        if ( b->xim_style & XIMPreeditNothing )
            HawTextOutReplaceHcs( b->preedit_widget, count, count + 1, hh );
        else if ( b->xim_style & (XIMPreeditPosition | XIMPreeditArea) )
            HawPreeditReplaceHcs( b->preedit_widget, count, count + 1, hh );

        b->conversion_flag[p] = True;
        b->point++;
    }

    /* dialog ְ, b->state · . */
    hanja_cancel(w, client, call);
}

static void CreateHanjaSelectWidget( Buffer *b )
{
    Widget	widget, form;
    Pixel	lbg;
    int	n, ii;
    Arg	args[10];
    unsigned char	*item;
    Dimension	width, height;
    Dimension	vbar_width, base_width;
    short	num_rows;
    int	horiz_distance;
    unsigned short code;

    //  item 
    if ( !(item = (unsigned char *)XtMalloc(MAXHANJA * 2)) )
        return;
    memset( item, 0, MAXHANJA * sizeof(hchar_t) );
    for ( ii = 0; ii < gHanjaLen; ii++ ) {
        code = hc2ksc(gHanja[ii]);
        item[ii * 2 ] = code >> 8;
        item[ii * 2 + 1] = code & 0x00ff;
    }

    lbg = light_color( None, default_background);

    n = 0;
    XtSetArg( args[n], XtNiconic, False ); n++;
    XtSetArg( args[n], XtNgeometry, "+0+0" ); n++;
    XtSetArg( args[n], XtNmappedWhenManaged, False ); n++;
    b->shell_widget =
        XtCreatePopupShell("HanjaDialog",
                           topLevelShellWidgetClass,
                           TopLevel, args, n);

    /* Form which contains push buttons */
    // LATER ߿ add, del  ̱ 
    form = XtCreateManagedWidget( "Form", formWidgetClass,
                                  b->shell_widget, NULL, 0 );

    n = 0;
    XtSetArg( args[n], HawNitems, item ); n++;
    XtSetArg( args[n], HawNitemLength, MAXHANJA * 2 ); n++;
    XtSetArg( args[n], HawNitemCount, MAXHANJA ); n++;
    XtSetArg( args[n], HawNnumRows, 8 ); n++;
    XtSetArg( args[n], HawNvisibleHorizontalItemCount, 8 ); n++;
    XtSetArg( args[n], HawNvisibleVerticalItemCount, 8 ); n++;

    XtSetArg( args[n], HawNitemBackground, lbg ); n++;
    XtSetArg( args[n], HawNhighlightAlways, True ); n++;
    b->list_widget =
        HawCreateScrolledList( form, "Hanja", args, n );
    XtAddCallback( b->list_widget, HawNsetCallback,
                   (XtCallbackProc)hanja_commit, (XtPointer)b );
    XtManageChild( b->list_widget );
    XtRealizeWidget( b->shell_widget );

    /*   */
    vbar_width = 0;
    widget = XtNameToWidget( XtParent(b->list_widget), "vertical" );
    if ( widget )
        XtVaGetValues( widget, XtNwidth, &vbar_width, NULL );

    XtVaGetValues( b->list_widget,
                   HawNnumRows, &num_rows,
                   HawNitemBaseWidth, &base_width,
                   XtNhorizDistance, &horiz_distance,
                   NULL );
    width = 10 + vbar_width + base_width * num_rows + horiz_distance;

    XtVaGetValues( b->shell_widget, XtNheight, &height, NULL );
    XtVaSetValues( b->shell_widget,
                   XtNwidth, width, XtNheight, height,
                   XtNminWidth, width, XtNminHeight, height,
                   XtNmaxWidth, width, XtNmaxHeight, height,
                   NULL );

    /* ⼭ popup Ѵ. */
    if ( b->xim_style & (XIMPreeditPosition | XIMPreeditArea) )
        HawPreeditMoveWidget( b->preedit_widget, b->hangulC[b->point],
                              b->shell_widget );
    else
        PEMoveWidget( b->shell_widget );

    HawInstallTranslations( b->list_widget, b->preedit_widget );
    HawInstallTranslations( form, b->preedit_widget );

    AddWMDelCallback(b->shell_widget, hanja_cancel, b);
    XtAddGrab( b->shell_widget, False, False );

    XFree(item);
}

///  ȯ Ѵ.
/**
    Ǿ       
  зϴ  մ ̴.
 
  \begin{description}
  \item[MDICT]	ý 
  \item[UDICT]	 
  \item[STUDY]	 ǿ  ܾ
  \end{description}
  */
void hanja( Widget w, XEvent *event, String *params, Cardinal *n )
{
    Buffer	*b;

    if ( (b = set_buffer( w, event->type )) == NULL )
        return;
    if ( (b->state & ERROR) || b->shell_widget )
        return;
    if ( !check_action_args( params, *n, "hanja" ) )
        return;
    /* ζ װ ϼѴ. */
    if ( COMB_STATE(b->hautomata) ) {
        complete_hangul( b );
        clear_hangul_automata( &b->hautomata );
    }

    if ( b->hangul[0] == '\0' ||
         (b->conversion_mode & LANGMASK) != HANGUL ||
         !ishangul(hc2ksc(b->hangul[b->cursor - 1])) )
        return;
    if ( (gHanjaLen = hjdic_gethanja(b->hangul + b->cursor - 1,
                                     gHanja, MAXHANJA)) < 1 )
        return;

    switch ( hjdic_open( resources.hjdic ) ) {
    case HANJA_CANNOT_OPEN_MDICT:
        hanim_error( b, w, resources.open_error2 );
        return;
    case HANJA_CANNOT_OPEN_UDICT:
        hanim_error( b, w, resources.open_error3 );
        return;
    case HANJA_CANNOT_OPEN_STUDY:
        hanim_error( b, w, resources.open_error4 );
        return;
    case HANJA_CANNOT_MAKE_UDIR:
        hanim_error( b, w, resources.open_error5 );
        return;
    case HANJA_CANNOT_MAKE_UDICT:
        hanim_error( b, w, resources.open_error6 );
        return;
    case HANJA_CANNOT_MAKE_STUDY:
        hanim_error( b, w, resources.open_error7 );
        return;
    }

    if ( b->state & (PREEDIT | EDIT) ) {
        b->state |= HANJA;
        CreateHanjaSelectWidget( b );
    }
}

/*@}*/
