/* $Id: XuiInit.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdio.h>
#include	<stdlib.h>
#include	<assert.h>

#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Xaw/Form.h>
#include	<X11/Xaw/Command.h>
#include	<Haw/Label.h>
#include	<Haw/Command.h>
#include	<Haw/HanList.h>
#include	<X11/keysym.h>
#include	<X11/Shell.h>

#ifndef WIN32
#include	<unistd.h>	// execvp()
#else /* WIN32 */
#include	<X11/XlibXtra.h> // HCLXawInit()
#endif    /* !WIN32*/

#include	"version.h"
#include	"hanim.h"
#include	"XuiBitmap.h"
#include	"buffer.h"
#include	"hcodec.h"
#include	"XuiDialog.h"
#include	"XuiIcon.h"
#include	"XuiXkey.h"
#include	"XuiRootWin.h"
#include	"resource.h"

#include	"bitmaps/hanIMlogo.xpm"

extern void	hanim_connect	();
extern void	AddActions	(XtAppContext app);
extern void	AddConverter	(XtAppContext app);
extern void	GetResources	(Widget widget);
extern void	open_url	(const char *url);
extern void	preference	(void);
extern void	keycap	(Widget, XEvent *, String *, Cardinal *);
extern void	help	(Widget, XEvent *, String *, Cardinal *);
extern void	done	(void);

#define HOMEURL		"http://www.mizi.co.kr"

Widget	TopLevel = 0;
XFontSet	gFontSet = 0;

static XrmOptionDescRec	option[] = {
    { "-no_auto_replace", "*autoReplace", XrmoptionNoArg, "False" },
    { "-nar", "*autoReplace", XrmoptionNoArg, "False" },
    { "-ipc", "*ignorePreeditColor", XrmoptionNoArg, "True" },
    { "-isc", "*ignoreStatusColor", XrmoptionNoArg, "True" },
#if defined(USE_XIMCP)
    { "-ximcp", "*ximcProtocol", XrmoptionNoArg, "True" }
    ,
    { "+ximcp", "*ximcProtocol", XrmoptionNoArg, "False" },
#endif
#ifdef USE_XIMP
    { "-ximp", "*ximProtocol", XrmoptionSepArg, NULL },
#endif
    { "-debug", "*debug", XrmoptionSepArg, NULL }
};

static Colormap	colormap = None;
unsigned long	default_foreground, default_background;

/* set up fallbask resources */
static String fallback_resources[] = {
    "*foreground:	#000000",
    "*background:	#c4c4c4",
    "*fontSet:		-misc-gothic-medium-r-normal--16-*-75-75-*-*",
    "*encoding:		2",   	/* Xt Ѵ */
    "*hanIM:		ѱԷ",
    "*defaultCode:	euckr",
    "*hangul3Bulsik:	ѱ 3",
    "*englishqwerty:	 ̱",
    "*japaneseEngHiragana:Ҫ骫",
    "*japaneseEngKatakana:",
    "*kssm:		",
    "*euckr:		ϼ",
    "*button1Label:	",
    "*button2Label:	",
    "*button3Label:	ݱ",
    "*button4Label:	ȯ漳",
    "*button5Label:	ۼ迭",
    "*button6Label:	",
    "*rootwin1Label:	ںȯ",
    "*rootwin2Label:	ڵǥ",
    "*rootwin3Label:	Ǻ",
    "*rootwin4Label:	",
    "*RootWin.geometry:	-20-20",   	/* RooWin Էâ */
    "*RootWin.width:	600",
    "*RootWin.height:	70",
	"*okLabel:			",
	"*cancelLabel:		ƴϿ",
	"*closeLabel:		ݱ",

    "*baseHanIMAccelerators: \
    Ctrl<Key>space:	connect()disconnect(!HANJA)	\\n\
    Shift<Key>space:	toggle()			\\n\
    Shift<Key>F1:	help()                          \\n\
    ~s ~c<Key>F2:	select-lang()			\\n\
    <Key>F6:		cancel(HANJA)hiragana-roman()	\\n\
    <Key>F7:		cancel(HANJA)katakana-roman()	\\n\
    <Key>F9:		hanja()				\\n\
    <Key>F10:		codetable()			\\n\
    <Key>F11:		keycap()			\\n\
    <Key>BackSpace:	through()cancel(HANJA)		\
    divided-delete()					\\n\
    <Key>Delete:	through()cancel(HANJA)		\
    delete()						\\n\
    <Key>Left:		through()previous()             \\n\
    <Key>Right:		through()next()                 \\n\
    <Key>Up:		through()up()			\
    codetable(PREEDIT,EDIT)				\\n\
    <Key>Down:		through()down()			\
    codetable(PREEDIT,EDIT)				\\n\
    ~s ~c<Key>Return:	commit()through()		\\n\
    Shift<Key>Return:	through()commit()		\\n\
    <Key>Escape:	commit(PREEDIT)			\
    through()						\
    cancel(INIT,CODE,HANJA,ERROR)			\\n\
    ~Ctrl ~Alt<Key>:inkey()",
    NULL
};

static int error_handler(Display *d, XErrorEvent *event)
{
#ifdef DEBUG
    char error[80];
    if ( resources.debug > 1 ) {
        XGetErrorText( d, event->error_code, error, 80 );
        fprintf( stderr, "%s: X Error %s\n", program_name, error );
        fprintf( stderr, "request_code: %d\t", event->request_code );
        fprintf( stderr, "minor code: %d\n", event->minor_code );
    }
#endif
    return( 0 );
}

#define	LIGHT(x,y)	(((ii=(int)x*y/1000)>65535)?65535:ii)
#define	C_LIGHT(x)	((((ii=(int)x*1194/1000)>65535)?65535:ii)*1000/x)

Pixel light_color( Colormap cm, Pixel pixel )
{
    XColor xcolor;
    int	ii, bye = 1194;

    if ( XDefaultDepthOfScreen( XtScreen(TopLevel) ) == 1 )
        return pixel;

    if ( cm == None )
        cm = colormap;
    xcolor.pixel = pixel;
    XQueryColor( XtDisplay(TopLevel), cm, &xcolor );

    if ( xcolor.red != 0 )	bye = MIN( bye, C_LIGHT(xcolor.red) );
    if ( xcolor.green != 0 )	bye = MIN( bye, C_LIGHT(xcolor.green) );
    if ( xcolor.blue != 0 )	bye = MIN( bye, C_LIGHT(xcolor.blue) );
    if ( bye == 1000 )	bye = 1100;

    xcolor.red = LIGHT(xcolor.red, bye);
    xcolor.green = LIGHT(xcolor.green, bye);
    xcolor.blue = LIGHT(xcolor.blue, bye);
    if ( XAllocColor( XtDisplay(TopLevel), cm, &xcolor ) )
        return( xcolor.pixel );
    else
        return( pixel );
}

static void QuitCB(Widget w, XtPointer data, XtPointer dummy)
{
    if (AskBoolean(resources.ask_quit, resources.ok_label,
	resources.cancel_label) == True)
        done();
}

static void RestartCB(Widget w, XtPointer data, XtPointer dummy)
{
    if (AskBoolean(resources.ask_restart, resources.ok_label,
                    resources.cancel_label) == True)
        execvp(program_name, command_vector);
}

static void ButtonPressCB(Widget w, XtPointer client, XtPointer call )
{
    HawListCallback lc = (HawListCallback)call;
    int	item = lc->item;

    switch (item) {
    case 0:
	QuitCB(w, client, call );
        break;
    case 1:
	RestartCB(w, client, call );
        break;
    case 2:
	XIconifyWindow(XtDisplay(TopLevel), XtWindow(TopLevel),
	DefaultScreen(XtDisplay(TopLevel)));
        break;
    case 3:
	preference();
        break;
    case 4:
	keycap( w, NULL, NULL, NULL);
        break;
    case 5:
	help( w, NULL, NULL, NULL );
        break;
    }
}

static void open_www_mizi(Widget w, XtPointer client, XtPointer call )
{
    open_url(HOMEURL);
}

#define MAX_BUTTON	6

XtAppContext hanim_window_init(int argc, char *argv[])
{
    XtAppContext app;
    XimpKey *keys;
    Pixel lbg;
    Widget form, label, cmds, logo = 0;
    Pixmap pixmap;
    Dimension width, height, depth;
    Arg	args[20];
    int	n, ii, length;
    char title[32], *button_items;

#ifdef WIN32
    HCLXawInit();
#endif    /* WIN32 */
    XtSetLanguageProc(NULL, NULL, NULL);
    TopLevel = XtVaAppInitialize( &app, CLASS_NAME,
	option, XtNumber(option),
	&argc, argv, fallback_resources,
#ifndef WIN32
	XtNiconic, True,
#endif    /* !WIN32 */
	NULL );

    AddConverter(app);
    GetResources(TopLevel);
    AddActions(app);
    XtVaGetValues( TopLevel, XtNcolormap, &colormap,
	XtNforeground, &default_foreground,
	XtNbackground, &default_background,
	NULL );

    /* ΰ ȭ ׸ */
    lbg = light_color((Colormap)NULL, default_background);
    form = XtVaCreateManagedWidget("Form",
	formWidgetClass, TopLevel,
	NULL);
    sprintf(title, "%s %d.%d",resources.hanIM,
	MAJOR_VERSION, MINOR_VERSION);
    label = XtVaCreateManagedWidget("Label",
	hLabelWidgetClass, form,
	XtNlabel, title,
	XtNbackground, lbg,
	XtNhorizDistance, 10,
	XtNvertDistance, 10,
	XtNwidth, 100, XtNheight, 20,
	NULL);

    if ((pixmap = LoadXPM(hanIMlogo_xpm))) {
        GetPixmapWHD(XtDisplay(TopLevel), pixmap, &width, &height, &depth);
        logo = XtVaCreateManagedWidget("",
	    hCommandWidgetClass, form,
	    XtNfromVert, label,
	    XtNvertDistance, 10,
	    XtNhorizDistance, 3,
	    XtNbottom, XawChainTop,
	    XtNbackgroundPixmap, pixmap,
	    XtNwidth, width,
	    XtNheight, height,
	    NULL);
        XtAddCallback(logo, XtNcallback, open_www_mizi, 0);
    }

    n = 0;
    if (pixmap && logo)
        XtSetArg(args[n], XtNfromVert, logo);
    else
        XtSetArg(args[n], XtNfromVert, label);
    n++;
    XtSetArg(args[n], XtNvertDistance, 5); n++;
    XtSetArg(args[n], XtNhorizDistance, 10); n++;
    XtSetArg(args[n], XtNleft, XawChainLeft); n++;
    XtSetArg(args[n], XtNright, XawChainLeft); n++;
    XtSetArg(args[n], XtNtop, XawChainBottom); n++;
    XtSetArg(args[n], XtNbottom, XawChainBottom); n++;
    XtSetArg(args[n], XtNborderWidth, 0); n++;
    XtSetArg(args[n], HawNitemBackground, lbg); n++;
    XtSetArg(args[n], HawNitemCount, MAX_BUTTON); n++;
    for (ii = length = 0; ii < MAX_BUTTON; ii++)
        if (length < strlen(resources.button_label[ii]))
            length = strlen(resources.button_label[ii]);
    button_items = XtMalloc(length * MAX_BUTTON + 1);
    memset(button_items, 0, length * MAX_BUTTON + 1);
    for (ii = 0; ii < MAX_BUTTON; ii++)
        strcpy(button_items + ii * length, resources.button_label[ii]);
    XtSetArg(args[n], HawNitemLength, length * MAX_BUTTON); n++;
    XtSetArg(args[n], HawNitems, button_items); n++;
    XtSetArg( args[n], HawNnumRows, MAX_BUTTON / 2); n++;
    XtSetArg(args[n], HawNvisibleHorizontalItemCount, MAX_BUTTON / 2);
    n++;
    XtSetArg(args[n], HawNvisibleVerticalItemCount, 2); n++;
    cmds = HawCreateList(form, "Command", args, n);
    XtManageChild(cmds);
    XtAddCallback(cmds, HawNunsetCallback,
	(XtCallbackProc)ButtonPressCB,
	(XtPointer)cmds );
    XtAddGrab(TopLevel, False, False);
    XtRealizeWidget(TopLevel);

    XtVaGetValues(TopLevel, XtNwidth, &width, XtNheight, &height, NULL);
    XtVaSetValues(TopLevel,
	XtNminWidth, width, XtNminHeight, height,
	XtNmaxWidth, width, XtNmaxHeight, height,
	NULL );
    /* TopLevel  fontSetڿ . */
    XtVaGetValues(label, XtNfontSet, &gFontSet, NULL);
    
    /* Create rootwin input window */
    hanim_rootwin_init();
    /* Error Handler */
    XSetErrorHandler(error_handler);
    /* Set Icon */
    SetIcon();
    /* WM_DELETE_WINDOW ó */
    AddWMDelCallback(TopLevel, QuitCB, NULL);
    
    /* reset the list on keys */
    if ((keys = Action2XimpKey(hanim_connect)) != NULL) {
        for (ii = 0;
			 resources.process_start_keys[ii].keysym != XK_VoidSymbol;
			 ii++ ) {
            for (n = 0; keys[n].keysym != XK_VoidSymbol; n++) {
                if (keys[n].keysym == resources.process_start_keys[ii].keysym &&
					keys[n].modifier == resources.process_start_keys[ii].modifier &&
					keys[n].modifier_mask ==
					resources.process_start_keys[ii].modifier_mask )
                    goto next;
            }
            keys = (XimpKey *)XtRealloc( (char*)keys, sizeof(XimpKey) * (n + 2) );
            if (keys == NULL) {
                XtError( "memory allocation" );
                exit( 1 );
            }
            keys[n].keysym = resources.process_start_keys[ii].keysym;
            keys[n].modifier = resources.process_start_keys[ii].modifier;
            keys[n].modifier_mask =
                resources.process_start_keys[ii].modifier_mask;
            keys[n + 1].keysym = XK_VoidSymbol;
			
        next:
            ;
        }
        XFree(resources.process_start_keys);
        resources.process_start_keys = keys;
    }
	
    XFree(button_items);
    return( app );
}
