/* $Id: XuiMode.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdlib.h>
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>
#include	<Haw/Preedit.h>
#include	<Haw/TextOut.h>

#include	"buffer.h"
#include	"romandic.h"
#include	"hcodec.h"
#include	"hangul.h"
#include	"preference.h"
#include	"resource.h"

extern int check_action_args(String *, int, char *);

/** @name Է   HimMode.c */
//@{

/// english dvorak keyboard ԷѴ.
void
english_dvorak(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "english-dvorak"))
        return;
    if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == ENGLISH_DVORAK)
            return;
        set_conversion_mode(b, ENGLISH_DVORAK);
    }
}

///  qwerty  ԷѴ.
void
english_qwerty(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "english-qwerty"))
        return;
    if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == ENGLISH_QWERTY)
            return;
        set_conversion_mode(b, ENGLISH_QWERTY);
    }
}

///hiragan ĺ ԷѴ.

/*   Ϻ Էϴ 
    忡 Ƽ 庸 . */
void
hiragana_roman(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "hiragana-roman"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_ENG_HIRAGANA)
            return;
        set_conversion_mode(b, JAPANESE_ENG_HIRAGANA);
    }
}

///katakgan ĺ ԷѴ.
void
katakana_roman(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "katakana-roman"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_ENG_KATAKANA)
            return;
        set_conversion_mode(b, JAPANESE_ENG_KATAKANA);
    }
}

///hiragan   ԷѴ.
void
hiragana(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "hiragana"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_HIRAGANA)
            return;
        set_conversion_mode(b, JAPANESE_HIRAGANA);
    }
}

///katakgan   ԷѴ.
void
katakana(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "katakana"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_KATAKANA)
            return;
        set_conversion_mode(b, JAPANESE_KATAKANA);
    }
}

#if 0 /* LATER */
/* ѱ  Ϻ Էϴ  ѱ ǿ Ѵ. */
void
hiragana_hangul(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "hiragana-hangul"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_HAN_HIRAGANA)
            return;
        set_conversion_mode(b, JAPANESE_HIRAGANA);
    }
}

void
katakana_hangul(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "katakana-hangul"))
        return;
    if (b->state & HANJA)
        return;
    else if (b->state & (PREEDIT | EDIT)) {
        if (b->conversion_mode == JAPANESE_HAN_KATAKANA)
            return;
        set_conversion_mode(b, JAPANESE_HIRAGANA);
    }
}
#endif    /* LATER */

/// ѱ  ԷѴ.
void hangul3(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if ( b == NULL || (b->state & (DELETE | CODE | ERROR)) ||
         b->conversion_mode == HANGUL_3BULSIK )
        return;
    b->hautomata.han_kbd_kind = 3;
    set_conversion_mode(b, HANGUL_3BULSIK);
}

/// ѱ ι ԷѴ.
void hangul2(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if ( b == NULL || (b->state & (DELETE | CODE | ERROR)) ||
         b->conversion_mode == HANGUL_2BULSIK )
        return;
    b->hautomata.han_kbd_kind = 2;
    set_conversion_mode(b, HANGUL_2BULSIK);
}

#if 0 /* LATER */
void hangul_roman(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if ( b == NULL || (b->state & (DELETE | CODE | ERROR)) ||
         b->conversion_mode == HANGUL_HAN_ROMAN )
        return;
    set_conversion_mode(b, HANGUL_HAN_ROMAN);
}
#endif    /* LATER */

///    ̸ 1 Ǵ 2 Ʈ Ѵ.
void english12(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "english12"))
        return;
    if (prefer.english12 == 1)
        prefer.english12 = 2;
    else
        prefer.english12 = 1;
}

/// ʱ · Ѵ.
void initial_mode(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if ( b == NULL || (b->state & ~(PREEDIT | EDIT)) ||
         !check_action_args(params, *n, "initial-mode" ))
        return;
    if (b->state & (PREEDIT | EDIT))
        set_conversion_mode(b, resources.initial_mode);
}

/** @name    ȯ
 * toggle()      ѱ, , Ϻ, 
 * θ    hangul(), enlglish()  θ,
 *  Լ     ¸   
 *  Ǿ ִ  Լ ȣѴ.
 */

///
void english(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "english"))
        return;
    if (b->state & (PREEDIT | EDIT)) {
        switch (resources.english_keyboard) {
        case ENGLISH_QWERTY:
            english_qwerty(w, event, params, n);
            break;
        case ENGLISH_DVORAK:
            english_dvorak(w, event, params, n);
            break;
        }
    }
}

///
void cyrillic(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "cyrillic"))
        return;
    if (b->state & (PREEDIT | EDIT)) {
        b->conversion_mode = CYRILLIC;
        set_conversion_mode(b, CYRILLIC);
    }
}

///
void hangul(Widget w, XEvent *event, String *params, Cardinal *n)
{
    Buffer *b = set_buffer(w, event->type);
    if (b == NULL || (b->state & (DELETE | CODE | ERROR)))
        return;
    if (!check_action_args(params, *n, "hangul"))
        return;
    if (b->state & (PREEDIT | EDIT)) {
        switch (resources.hangul_keyboard) {
        case HANGUL3:
            hangul3(w, event, params, n);
            break;
        case HANGUL2:
            hangul2(w, event, params, n);
            break;
#if 0 /* LATER */
        case HAN_ROMAN:
            hangul_roman(w, event, params, n);
            break;
#endif    /* LATER */
        default:
            hangul3(w, event, params, n);
            break;
        }
    }
}

//@}
