/* $Id: XuiResource.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdio.h>
#include	<stdlib.h>
#include	<X11/keysym.h>
#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Xatom.h>
#include	<Haw/HawStrDefs.h>

#include	"hanim.h"
#include	"resource.h"
#include	"preference.h"
#include	"hangul.h"
#include	"hcodec.h"
#include	"mzdebug.h"

/** @name ҽ    Լ HimResource.c */
//@{

static void get_hjdic(Widget widget, int offset, XrmValue *value)
{
    char hjdic_name[256];

    value->size = sizeof(char *);
    value->addr = hjdic_name;

    sprintf(hjdic_name, "%s/hjdic.dic", sys_directory);
}

typedef HanIM *HanIMPtr;
#define Offset(x) XtOffset(HanIMPtr,x)

static XtResource local_resources[] = {
    {
	"baseHanIMAccelerators", "BaseHanIMAccelerators", XtRAcceleratorTable,
	sizeof(XtTranslations), Offset(base_accelerators),
	XtRTranslationTable, (XtPointer)NULL
    },
    {
	"hanIMAccelerators", "HanIMAccelerators", XtRAcceleratorTable,
	sizeof(XtTranslations), Offset(accelerators),
	XtRTranslationTable, (XtPointer)NULL
    },
    {
	"hanIM", "HanIM", XtRString,
	sizeof(String), Offset(hanIM),
	XtRString, ""
    },
    {
	"defaultCode", "DefaultCode", HawRCharacterCode,
	sizeof(CharacterCode), Offset(code),
	XtRString, "euckr"
    },
    {
	"initialLanguage", "InitialLanguage", HawRInputLanguage,
	sizeof(InputLanguage), Offset(lang),
	XtRString, ""
    },
    {
	"hangulKeyboard", "HangulKeyboard", HawRLangKeyboard,
	sizeof(LangKeyboard), Offset(hangul_keyboard),
	XtRString, "3bulsik"
    },
    {
	"englishKeyboard", "EnglishKeyboard", HawRLangKeyboard,
	sizeof(LangKeyboard), Offset(english_keyboard),
	XtRString, "qwerty"
    },
    /* þƾ   ʿ. */
    /* button labels */
    {
	"button1Label", "Button1Label", XtRString,
	sizeof(String), Offset(button_label[0]),
	XtRString, ""
    },
    {
	"button2Label", "Button2Label", XtRString,
	sizeof(String), Offset(button_label[1]),
	XtRString, ""
    },
    {
	"button3Label", "Button3Label", XtRString,
	sizeof(String), Offset(button_label[2]),
	XtRString, ""
    },
    {
	"button4Label", "Button4Label", XtRString,
	sizeof(String), Offset(button_label[3]),
	XtRString, ""
    },
    {
	"button5Label", "Button5Label", XtRString,
	sizeof(String), Offset(button_label[4]),
	XtRString, ""
    },
    {
	"button6Label", "Button6Label", XtRString,
	sizeof(String), Offset(button_label[5]),
	XtRString, ""
    },
    {
	"rootwin1Label", "Rootwin1Label", XtRString,
	sizeof(String), Offset(rootwin_label[0]),
	XtRString, ""
    },
    {
	"rootwin2Label", "Rootwin2Label", XtRString,
	sizeof(String), Offset(rootwin_label[1]),
	XtRString, ""
    },
    {
	"rootwin3Label", "Rootwin3Label", XtRString,
	sizeof(String), Offset(rootwin_label[2]),
	XtRString, ""
    },
    {
	"rootwin4Label", "Rootwin4Label", XtRString,
	sizeof(String), Offset(rootwin_label[3]),
	XtRString, ""
    },
    {
	"okLabel", "OkLabel", XtRString,
	sizeof(String), Offset(ok_label),
	XtRString, ""
    },
    {
	"cancelLabel", "CancelLabel", XtRString,
	sizeof(String), Offset(cancel_label),
	XtRString, ""
    },
    {
	"closeLabel", "CloseLabel", XtRString,
	sizeof(String), Offset(close_label),
	XtRString, ""
    },
    /* status area label messages */
    {
	"hangul3Bulsik", "Hangul3Bulsik", XtRString,
	sizeof(String), Offset(hangul_3bulsik),
	XtRString, ""
    },
    {
	"hangul2Bulsik", "Hangul2Bulsik", XtRString,
	sizeof(String), Offset(hangul_2bulsik),
	XtRString, ""
    },
#if 0 /* LATER */
    {
	"hangulRoman", "HangulRoman", XtRString,
	sizeof(String), Offset(hangul_roman),
	XtRString, ""
    },
#endif
    {
	"englishqwerty", "EnglishQwerty", XtRString,
	sizeof(String), Offset(english_qwerty),
	XtRString, ""
    },
    {
	"englishDvorak", "EnglishDvorak", XtRString,
	sizeof(String), Offset(english_dvorak),
	XtRString, ""
    },
    {
	"japaneseEngHiragana", "JapaneseEngHiragana", XtRString,
	sizeof(String), Offset(japanese_eng_hiragana),
	XtRString, ""
    },
    {
	"japaneseEngKatakana", "JapaneseEngKatakana", XtRString,
	sizeof(String), Offset(japanese_eng_katakana),
	XtRString, ""
    },
    {
	"japaneseHiragana", "JapaneseHiragana", XtRString,
	sizeof(String), Offset(japanese_hiragana),
	XtRString, ""
    },
    {
	"japaneseKatakana", "JapaneseKatakana", XtRString,
	sizeof(String), Offset(japanese_katakana),
	XtRString, ""
    },
#if 0 /* LATER */
    {
	"japaneseHanHiragana", "JapaneseHanHiragana", XtRString,
	sizeof(String), Offset(japanese_han_hiragana),
	XtRString, ""
    },
    {
	"japaneseHanKatakana", "JapaneseHanKatakana", XtRString,
	sizeof(String), Offset(japanese_han_katakana),
	XtRString, ""
    },
#endif
    {
	"cyrillic", "Cyrillic", XtRString,
	sizeof(String), Offset(cyrillic_mode),
	XtRString, ""
    },
    /* code names */
    {
	"euckr", "Euckr", XtRString,
	sizeof(String), Offset(euckr),
	XtRString, "Completeted Code"
    },
    {
	"kssm", "Kssm", XtRString,
	sizeof(String), Offset(kssm),
	XtRString, "Combinatorial Code"
    },
    {
	"ucs2", "Ucs2", XtRString,
	sizeof(String), Offset(ucs2),
	XtRString, "UCS2"
    },

    {
	"ksc5601", "Ksc5601", XtRString,
	sizeof(String), Offset(ksc5601),
	XtRString, "KSC5601"
    },
    /* messages */
    {
	"askQuit", "AskQuit", XtRString,
	sizeof(String), Offset(ask_quit),
	XtRString, ""
    },
    {
	"askRestart", "AskRestart", XtRString,
	sizeof(String), Offset(ask_restart),
	XtRString, ""
    },
    {
	"unimplemented", "Unimplemented", XtRString,
	sizeof(String), Offset(unimplemented),
	XtRString, ""
    },
    {
	"mallocError", "MallocError", XtRString,
	sizeof(String), Offset(malloc_error),
	XtRString, "Not enough memory"
    },
    {
	"openError1", "OpenError1", XtRString,
	sizeof(String), Offset(open_error1),
	XtRString, ""
    },
    {
	"closeError1", "CloseError1", XtRString,
	sizeof(String), Offset(close_error1),
	XtRString, ""
    },
    {
	"addError1", "AddError1", XtRString,
	sizeof(String), Offset(add_error1),
	XtRString, ""
    },
    {
	"deleteError1", "DeleteError1", XtRString,
	sizeof(String), Offset(delete_error1),
	XtRString, ""
    },
    {
	"conversionError1", "ConversionError1", XtRString,
	sizeof(String), Offset(conversion_error1),
	XtRString, ""
    },
    {
	"hjdic", "Hjdic", XtRString,
	sizeof(String), Offset(hjdic),
	XtRCallProc, (XtPointer)get_hjdic
    },
    {
	"processStartKeys", "ProcessStartKeys", HawRProcessStartKeys,
	sizeof(XimpKey *), Offset(process_start_keys),
	XtRString, "Ctrl<Key>space"
    },
    {
	"autoReplace", "AutoReplace", XtRBoolean,
	sizeof(Boolean), Offset(auto_replace),
	XtRString, "True"
    },
    {
	"ignorePreeditColor", "IgnorePreeditColor", XtRBoolean,
	sizeof(Boolean), Offset(ignore_preedit_color),
	XtRString, "False"
    },
    {
	"ignoreStatusColor", "IgnoreStatusColor", XtRBoolean,
	sizeof(Boolean), Offset(ignore_status_color),
	XtRString, "False"
    },
    {
	"conversionMessage", "MultiClientMessage", XtRBoolean,
	sizeof(Boolean), Offset(conversion_message),
	XtRString, "False"
    },
    {
	"resetMessage", "MultiClientMessage", XtRBoolean,
	sizeof(Boolean), Offset(reset_message),
	XtRString, "False"
    },
    {
	"ghostMode", "GhostMode", XtRBoolean,
	sizeof(Boolean), Offset(ghost_mode),
	XtRInt, "True"
    },
    {
	"debug", "Debug", HawRFlag,
	sizeof(long), Offset(debug),
	XtRInt, 0
    },
#ifdef USE_XIMP
    {
	"ximProtocol", "XimProtocol", XtRInt,
	sizeof(int), Offset(xim_protocol),
	XtRImmediate, (XtPointer)4
    },
#endif
#if defined(USE_XIMCP)
    {
	"ximcProtocol", "XimcProtocol", XtRBoolean,
	sizeof(Boolean), Offset(ximc_protocol),
	XtRString, "True"
    },
#endif
};

/// ü ϴ ҽ ڷ
HanIM	resources;

/// ǰ  ҽ оδ.

void GetResources(Widget widget)
{
    char *ptr;

    // LAER move to hanim.c
    read_hanim_rc();

    XtGetApplicationResources(widget, &resources, local_resources,
	XtNumber(local_resources), NULL, 0);

    if ((ptr = getenv("HANGUL_KEYBOARD")) ||
	(ptr = getenv("HANGUL_KEYBOARD_TYPE")) ) {
        resources.hangul_keyboard = (*ptr == '3') ? HANGUL3 : HANGUL2;
    }

    switch (resources.lang) {
    case HANGUL:
	resources.initial_mode = resources.hangul_keyboard; break;
    case ENGLISH:
	resources.initial_mode = resources.english_keyboard; break;
    case JAPANESE:
	resources.initial_mode = JAPANESE_ENG_HIRAGANA; break;
    case CYRILLIC:
	resources.initial_mode = CYRILLIC; break;
    default:
	if (prefer.event_flow == DYNAMIC_CONTROL)
	    resources.initial_mode = resources.hangul_keyboard;
	else
	    resources.initial_mode = resources.english_keyboard;
    }
		
#ifndef NDEBUG
    mzdebug_set_mask(resources.debug);
#endif
}

/// ѱ Է  Ű ȮѴ. Ximp ƾ Ѵ.
Boolean is_started_key(XKeyEvent *event)
{
    XimpKey *list;
    KeySym keysym;

    keysym = XLookupKeysym(event, 0);
    for (list = resources.process_start_keys; list->keysym != XK_VoidSymbol;
	 list++) {
        if ((keysym == list->keysym) &&
	    ((event->state & list->modifier_mask) == list->modifier))
            return(True);
    }
    return False;
}

//@}
