/* $Id: XuiXkey.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<X11/Xlib.h>
#include	<X11/IntrinsicP.h>
#include	<X11/CoreP.h>
#include	<X11/keysym.h>
#include	<Haw/TranslateI.h>

#include	"hanim.h"
#include	"XuiRootWin.h"
#include	"Ximp.h"
#include	"Ximcp.h"

/** @name ൿ(action) Ximp/Ximcp Ű */
//@{

/// ൿ Լ XimpKey ȯѴ.
XimpKey *Action2XimpKey( void (*func)() )
{
#ifndef WIN32
    XtTM	tmRecPtr = &((CoreWidget)PEText)->core.tm;
    TMSimpleStateTree	stateTree;
    TMBranchHead	branchHead;
    TMTypeMatch	typeMatch;
    TMModifierMatch	modMatch;
    XtActionProc	*procs;
    TMBindData	bindData;
    ActionRec	*actions;
    int	ii, jj;
    XimpKey	*keys = NULL;
    int	count = 0;

    if ( tmRecPtr->translations == NULL )
        return( NULL );
    stateTree = (TMSimpleStateTree)tmRecPtr->translations->stateTreeTbl[0];
    for ( ii = 0; ii < stateTree->numBranchHeads; ii++ ) {
        branchHead = &stateTree->branchHeadTbl[ii];
        typeMatch = TMGetTypeMatch(branchHead->typeIndex);
        modMatch = TMGetModifierMatch(branchHead->modIndex);

        bindData = (TMBindData)tmRecPtr->proc_table;
        if ( bindData->simple.isComplex ) {
            TMComplexBindProcs	bindProcs;
            bindProcs = TMGetComplexBindEntry( bindData, 0 );
            procs = bindProcs->procs;
        } else {
            TMSimpleBindProcs	bindProcs;
            bindProcs = TMGetSimpleBindEntry( bindData, 0 );
            procs = bindProcs->procs;
        }
        if ( branchHead->isSimple ) {
            static ActionRec	dummyAction;
            dummyAction.idx = TMBranchMore(branchHead);
            actions = &dummyAction;
        } else {
            StatePtr currState = ((TMComplexStateTree)stateTree)->complexBranchHeadTbl[TMBranchMore(branchHead)];
            actions = currState->actions;
        }

        while ( actions != NULL ) {
            if ( *(procs[actions->idx]) == func &&
                 typeMatch->eventType == KeyPress ) {
                if ( modMatch->modifiers == AnyModifier )
                    continue;
                for ( jj = 0; jj < count; jj++ )
                    if ( keys[jj].keysym == typeMatch->eventCode &&
                         keys[jj].modifier == modMatch->modifiers &&
                         keys[jj].modifier_mask == modMatch->modifierMask )
                        goto next;
                count++;
                if ( keys == NULL )
                    keys = (XimpKey *)XtMalloc( sizeof(XimpKey) * 2 );
                else
                    keys = (XimpKey *)XtRealloc( (char*)keys,
                                                 sizeof(XimpKey) * (count + 1) );
                if ( keys == NULL ) {
                    XtError( "memory allocation error." );
                    exit( 1 );
                }
                keys[count - 1].keysym = typeMatch->eventCode;
                keys[count - 1].modifier = modMatch->modifiers;
                keys[count - 1].modifier_mask = modMatch->modifierMask;
                keys[count].keysym = XK_VoidSymbol;
                break;
            }
            actions = actions->next;
        }
    next: ;
    }
    if ( count > 0 )
        for ( count = 0; keys[count].keysym != XK_VoidSymbol; count++ )
            if ( keys[count].modifier_mask == ~0 )
                keys[count].modifier_mask = keys[count].modifier;
    return( keys );
#else
    return 0;
#endif
}


#if defined(USE_XIMCP)
/// ൿ Լ XimcpKey ȯѴ.
XIMTRIGGERKEY *Action2XimcpKey( void (*func)() )
{
    XIMTRIGGERKEY	*keys;
    XimpKey *k;
    int n, count;

    k = Action2XimpKey( func );
    if ( !k ) {
        keys = (XIMTRIGGERKEY *)XtMalloc(2 * sizeof(XIMTRIGGERKEY));
        keys[0].keysym = XK_space;
        keys[0].modifier = ControlMask;
        keys[0].modifier_mask = ControlMask;
        keys[1].keysym = XK_VoidSymbol;
    } else {
        // calc key list size including last XK_VoidSymbol
        count = 0;
        while ( k[count++].keysym != XK_VoidSymbol ) ;

        keys = (XIMTRIGGERKEY *)XtMalloc(count * sizeof(XIMTRIGGERKEY));
        for ( n = 0; n < count; ++n ) {
            keys[n].keysym = k[n].keysym;
            keys[n].modifier = k[n].modifier;
            keys[n].modifier_mask = k[n].modifier_mask;
        }
        XFree(k);
    }
    return( keys );
}
#endif

//@}
