/* $Id: hangul.c,v 1.7 2000/01/11 01:28:45 frog Exp $ */

#include "resource.h"
#include "hangul.h"

static int han_johab_mode = 1;   	/* default to KSSM 98/03/02 */

extern int hangul_automata_2(struct hangul_automata_state*, unsigned );
extern int hangul_automata_3(struct hangul_automata_state*, unsigned );

/** @name ѱ 丶Ÿ  ƾ hangul.c */
/*@{*/

/* Hangul keyboard for 2 bulsik */
static unsigned char kbd_table_2[] =
    {
        0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,     /*  !"#$%&' */
        0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,     /* ()*+,-./ */
        0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,     /* 01234567 */
        0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,     /* 89:;<=>? */
        0x40, 0x88, 0xBA, 0x90, 0x8D, 0x86, 0x87, 0x94,     /* @ABCDEFG */
        0xAD, 0xA5, 0xA7, 0xA3, 0xBD, 0xBB, 0xB4, 0xA6,     /* HIJKLMNO */
        0xAC, 0x8A, 0x83, 0x84, 0x8C, 0xAB, 0x93, 0x8F,     /* PQRSTUVW */
        0x92, 0xB3, 0x91, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,     /* XYZ[\]^_ */
        0x60, 0x88, 0xBA, 0x90, 0x8D, 0x85, 0x87, 0x94,     /* `abcdefg */
        0xAD, 0xA5, 0xA7, 0xA3, 0xBD, 0xBB, 0xB4, 0xA4,     /* hijklmno */
        0xAA, 0x89, 0x82, 0x84, 0x8B, 0xAB, 0x93, 0x8E,     /* pqrstuvw */
        0x92, 0xB3, 0x91, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F   /* xyz{|}~  */
    };

/* Hangul keyboard for 3 bulsik */
static unsigned char kbd_table_3[] =
    {
        0x20, 0xD8, 0x22, 0x23, 0x24, 0x25, 0x26, 0x92,     /*  !"#$%&' */
        0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0xAD,     /* ()*+,-./ */
        0x91, 0xDD, 0xD6, 0xD3, 0xB3, 0xBA, 0xA5, 0xAC,     /* 01234567 */
        0xBC, 0xB4, 0x3A, 0x89, 0x32, 0x3D, 0x33, 0x3F,     /* 89:;<=>? */
        0x40, 0xC8, 0x21, 0xCB, 0xCA, 0xDA, 0xC3, 0x2F,     /* @ABCDEFG */
        0x27, 0x38, 0x34, 0x35, 0x36, 0x31, 0x30, 0x39,     /* HIJKLMNO */
        0x3E, 0xDC, 0xA6, 0xC7, 0x3B, 0x37, 0xD0, 0xDB,     /* PQRSTUVW */
        0xD4, 0x3C, 0xD9, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,     /* XYZ[\]^_ */
        0x60, 0xD7, 0xB4, 0xAA, 0xBD, 0xAB, 0xA3, 0xBB,     /* `abcdefg */
        0x84, 0x88, 0x8D, 0x82, 0x8E, 0x94, 0x8B, 0x90,     /* hijklmno */
        0x93, 0xD5, 0xA4, 0xC5, 0xA7, 0x85, 0xAD, 0xC9,     /* pqrstuvw */
        0xC2, 0x87, 0xD1, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F   /* xyz{|}~  */
    };

static unsigned short
convert_ascii_for_hangul_keyboard ( struct hangul_automata_state *hfrm,
                                                unsigned short key )
{
    if ( !hfrm->han_kbd_state || key <= 32 || key >= 127 )
        return key;
    return(hfrm->han_kbd_kind == 3 ?
           kbd_table_3[key - 32] : kbd_table_2[key - 32]);
}

/// ѱ 丶Ÿ ʱȭѴ.
void init_hangul_automata(struct hangul_automata_state *hfrm)
{
    hfrm->han_kbd_kind = (resources.hangul_keyboard == HANGUL2) ? 2 : 3;
    hfrm->han_kbd_state = 1;

    hfrm->AMstate = 0;
    hfrm->input_sp = 0;
    hfrm->output_sp = 0;
}

/// ѱ 丶Ÿ Ѵ.
void clear_hangul_automata( struct hangul_automata_state *hfrm )
{
    hfrm->AMstate = 0;
    hfrm->input_sp = 0;
    hfrm->output_sp = 0;
}

static int
hangul_automata(struct hangul_automata_state *hfrm, unsigned key)
{
    return(hfrm->han_kbd_kind == 3 ? hangul_automata_3(hfrm, key) :
           hangul_automata_2(hfrm, key));
}

/// ѱ ڵ ȯ Ѵ.
int
get_hangul_code(struct hangul_automata_state *hfrm, unsigned short key,
                unsigned short *fcode, unsigned short *scode)
{
    int t, s, result;
    unsigned short newkey;
    unsigned short code1 = 0, code2 = 0;

    code1 = newkey = convert_ascii_for_hangul_keyboard(hfrm, key);
    if ( !newkey || newkey == '\b' ) {
        /* delete or backspace one component of hangul character */
        if ( hfrm->input_sp ) /* when automaton is being activated */
        {
            hfrm->input_sp--;
            if ( hfrm->input_sp )
            {
                hfrm->AMstate = hfrm->input_stack[hfrm->input_sp - 1].amstate;
                code1 = hfrm->input_stack[hfrm->input_sp - 1].code;
                result = code_hanbs;
            } else /* completely deleted */
            {
                clear_hangul_automata (hfrm);
                result = code_nohan;
            }
        }
        else /* when automaton is not being activated;
                              	  * type backspace behind ascii or C-d */
            result = code_delete;
    } else if ( newkey > 127 && newkey < 256 )
        /* automaton should take care of this key. be activated! */
    {
        s = hfrm->AMstate;
        t = hangul_automata (hfrm, newkey);
        code1 = hfrm->input_stack[hfrm->input_sp - 1].code;
        if ( ! kssmc2ksc(code1) )
            /* wansung code doesn't exist corresponding to the johab code;
             * for example, ++-> /*/
        {
            code1 = hfrm->input_stack[hfrm->input_sp - 2].code;
            clear_hangul_automata (hfrm);
            hangul_automata (hfrm, newkey);
            code2 = hfrm->input_stack[hfrm->input_sp - 1].code;
            result = code_hanend;
        } else if ( t ) /* just now, first code completely generated */
        {
            hfrm->AMstate = hfrm->input_sp = 0;
            while ( hfrm->output_sp )
                hangul_automata(hfrm, hfrm->output_stack[--(hfrm->output_sp)]);
            code2 = hfrm->input_stack[hfrm->input_sp - 1].code;
            result = code_hanend;
        } else if (!s)
            result = code_hanst;
        else
            result = code_hanin;
    } else if ( hfrm->AMstate )
        /* where automaton is being activated, be forced to insert ascii code */
    {
        code1 = hfrm->input_stack[hfrm->input_sp - 1].code;
        code2 = newkey;
        clear_hangul_automata (hfrm);
        result = code_hanend;
    } else
        /* where automaton is not being activated, just insert ascii code */
        result = code_ascii;
    *fcode = (han_johab_mode ? code1 : kssmc2ksc (code1));
    *scode = (han_johab_mode ? code2 : kssmc2ksc (code2));
    return (hfrm->CDstate = result);
}

/*@}*/
