/*$Id: hstring.c,v 1.6 2000/01/11 01:28:46 frog Exp $ */

#include <stdio.h>
#include <stdlib.h>

#include "hcodec.h"

/** @name  ڵ忡  string ó Լ */
/*@{*/

/// ڿ ̸ ȯѴ.
size_t hcslen(const hchar_t *s)
{
    register int	n = 0;
    while ( *s++ )
        n++;
    return( n );
}

/// ڿ s2 ڿ s1 ڿ ģ.
hchar_t *hcscat(hchar_t *s1, const hchar_t *s2)
{
    hchar_t *s = s1;
    while (*s1) s1++;
    while ((*s1++ = *s2++) != '\0') ;
    return (s);
}

/// Ʈ  ȯѴ.
hchar_t *hcsdup(const hchar_t *s1)
{
    hchar_t *s ;
    register hchar_t *s2;

    s = s2 = (hchar_t *)malloc(sizeof(hchar_t) * (hcslen(s1) + 1));

    if ( s )
        while ( (*s2++ = *s1++) != '\0' );
    return(s);
}

/// s2  lŬ Ʈ s1 ģ.
hchar_t *hcstrncat(hchar_t *s1, const hchar_t *s2, size_t l)
{
    hchar_t *s = s1;
    while (*s1++);

    while (l-- && ((*s1++ = *s2++) != (hchar_t) '\0'));
    if (!l) *s1 = (hchar_t) '\0';

    return (s);
}

/// ڿ Ѵ.
int hcscmp( const hchar_t *s1, const hchar_t *s2 )
{
    while ( *s1 && *s2 && *s1 == *s2 ) {
        s1++;
        s2++;
    }
    return( *s1 - *s2 );
}

/// ڿ ΰ տ n Ѵ.
int hcsncmp(const hchar_t *s1, const hchar_t *s2, size_t n)
{
    while (*s1 && (*s1 == *s2) && --n) {
        s1++;
        s2++;
    }
    return (*s1 - *s2);
}

/// ڿ s2 s1 Ѵ.
hchar_t *hcscpy(hchar_t *s1, const hchar_t *s2)
{
    hchar_t *s = s1;
    while ((*s1 = *s2++) != '\0') s1++;
    return (s);
}

/// ڿ s2  nŭ s1 Ѵ.
hchar_t *hcsncpy( hchar_t *s1, const hchar_t *s2, size_t n )
{
    hchar_t *s = s1;
    while ( n > 0 && (*s1 = *s2) ) {
        s1++;
        s2++;
        n--;
    }
    return s;
}

/// ڿ s ڵ c ã´.
hchar_t *hcschr(const hchar_t *s, hchar_t c)
{
    register hchar_t *s1 = (hchar_t *)s;

    while (*s1 && (*s1 != (hchar_t) c))
        s1++;
    if ((!*s1) && c)
        s1 = (hchar_t *) 0;
    return (s1);
}

/// ڿ s Ĺ̿ c ã´.
hchar_t *hcsrchr(const hchar_t *s1, hchar_t c)
{
    register hchar_t *s = (hchar_t *) 0;

    while (*s1) {
        if (*s1 == (hchar_t) c)
            s = (hchar_t *)s1;
        s1++;
    }
    return (s);
}

/// ڿ ū .
hchar_t *hcspbrk(const hchar_t *s1, const hchar_t *s2)
{
    register hchar_t *s;
    while (*s1) {
        for (s = (hchar_t *)s2; *s && *s != *s1; s++)
            ;
        if (*s)
            break;
        s1++;
    }
    if (!*s1) {
        s1 = (hchar_t *) 0;
    }
    return (hchar_t *)s1;
}

size_t hcsspn(const hchar_t *s1, const hchar_t *s2)
{
    register hchar_t *s;
    hchar_t *orig = (hchar_t *)s1;

    while (*s1) {
        for (s = (hchar_t *)s2; *s && *s != *s1; s++);
        if (!*s)
            break;
        s1++;
    }
    return ((int) (s1 - orig));
}


///
/**
  Get next token from string *stringp, where tokens are (possibly empty)
  strings separated by characters from delim.  Tokens are separated by
  exactly one delimiter iff the skip parameter is false; otherwise they are
  separated by runs of characters from delim, because we skip over any
  initial `delim' characters.
  
  Writes NULs into the string at *stringp to end tokens. delim will usually,
  but need not, remain constant from call to call. On return, *stringp
  points past the last NUL written (if there might be further tokens), or is
  NULL (if there are definitely no more tokens).
  
  If *stringp is NULL, strtoken returns NULL.
 */
hchar_t *hcstrtoken(hchar_t **stringp, hchar_t *delim, int skip)
{
    register hchar_t *s;
    register hchar_t *spanp;
    register int c, sc;
    hchar_t *tok;

    if ((s = *stringp) == NULL)
        return (NULL);

    if (skip) {
        /*
         * Skip (span) leading delimiters (s += hcstrspn(s, delim)).
         */
    cont:
        c = *s;
        for (spanp = delim; (sc = *spanp++) != 0; ) {
            if (c == sc) {
                s++;
                goto cont;
            }
        }
        if (c == 0) {	/* no token found */
            *stringp = NULL;
            return (NULL);
        }
    }
    /*
     * Scan token (scan for delimiters: s += hcstrcspn(s, delim), sort
     * of). Note that delim must have one NUL; we stop if we see that,
     * too.
     */
    for (tok = s; ; ) {
        c = *s++;
        spanp = delim;
        do {
            if ((sc = *spanp++) == c) {
                if (c == 0)
                    s = NULL;
                else
                    s[ -1] = 0;
                *stringp = s;
                return (tok);
            }
        } while (sc != 0);
    }
    /* NOTREACHED */
}

///
/**
  Get next token from string s (NULL on 2nd, 3rd, etc. calls), where tokens
  are nonempty strings separated by runs of chars from delim.  Writes NULs
  into s to end tokens.  delim need not remain constant from call to call.
  
  Modified by cpc: 	changed variable names to conform with naming
  conventions used in rest of code.  Added malloc pointer check calls.
 */
hchar_t *hcstok(hchar_t *str1, const hchar_t *str2)
{
    static hchar_t *last;
    if (str1) {
        last = str1;
    }
    return (hcstrtoken(&last, (hchar_t *)str2, 1));
}

/*@}*/
