/* $Id: debug.c,v 1.2 1999/03/10 21:39:27 frog Exp $ */

#ifndef WIN32
#ifdef DEBUG

#include <stdio.h>
#include <dlfcn.h>
#include <X11/Xlib.h>

static XFontSet (*xcfs)(Display *, const char *, char ***, int *, char **) = 0;
static void (*xffs)(Display *, XFontSet) = 0;

static void load_functions()
{
  void *handle = dlopen ("libX11.so", RTLD_LAZY);
  char *error;

  if ((error = dlerror()) != NULL) {
     fputs(error, stderr);
     exit(1);
  }
  xcfs = dlsym(handle, "XCreateFontSet");
  xffs = dlsym(handle, "XFreeFontSet");
  if ((error = dlerror()) != NULL) {
     fputs(error, stderr);
     exit(1);
  }
  // dlclose(handle);
}

XFontSet XCreateFontSet(Display *display, const char *base_font_name_list,
			char ***missing_charset_list_return,
			int *missing_charset_count_return,
			char **def_string_return)
{
  XFontSet fs;
  if( xcfs == 0 )
    load_functions();
  fs = (*xcfs)(display, base_font_name_list, missing_charset_list_return,
    missing_charset_count_return, def_string_return) ;
  fprintf(stderr, "CFontSet : %x\n", fs);
  return fs;
}

void XFreeFontSet(Display *display, XFontSet font_set)
{
  if( xffs == 0 )
    load_functions();
  fprintf(stderr, "FFontSet : %x\n", font_set);
  (*xffs)(display, font_set) ;
}

#endif /* DEBUG */
#endif /* WIN32 */
