/* $Id: mzdebug.c,v 1.2 2000/01/11 01:28:46 frog Exp $ */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#include "mzdebug.h"

#ifdef mzdebug
# undef mzdebug
#endif    /* mzdebug */

#define MZDEBUG_DEFAULT	0xffffffff

static unsigned int mz_debug = MZDEBUG_DEFAULT;

void mzdebug_set_mask(unsigned value)
{
    mz_debug = value;
}

void mzdebug(unsigned flag, const char *fmt, ...)
{
    if ( mz_debug == MZDEBUG_DEFAULT ) {
        char *s;
        if ((s = getenv ("MZDEBUG")))
            mz_debug = strtol(s, (char **)NULL, 0);
    }

    if ( flag & mz_debug ) {
        static char	buffer[256];
        va_list	args;

        va_start(args, fmt);
        vsprintf(buffer, fmt, args);
        va_end(args);

#ifdef _WIN32
# ifdef _DEBUG_MSG
        _RPT1(_CRT_WARN, "[%d] %s", flag, buffer);
# endif
#else /* !_WIN32 */
        fprintf(stderr, "[%d] %s", flag, buffer);
#endif    /* _WIN32 */
    }
}

void mzdebug0(unsigned flag, const char *fmt, ...)
{}
