/* $Id: mzdebug.h,v 1.2 2000/01/11 01:28:46 frog Exp $ */

#ifndef _MZDEBUG_H_
#define _MZDEBUG_H_

#ifdef __cplusplus
extern "C"
{
#endif    /* __cplusplus */

#if defined(WIN32)
#if defined(_DEBUG)
    /* This was needed at some time for catching errors in pdftex. */
#include <crtdbg.h>
#define  SET_CRT_DEBUG_FIELD(a) \
    _CrtSetDbgFlag((a) | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#define  CLEAR_CRT_DEBUG_FIELD(a) \
    _CrtSetDbgFlag(~(a) & _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#define  SETUP_CRTDBG \
    { _CrtSetReportMode( _CRT_WARN, _CRTDBG_MODE_FILE );    \
        _CrtSetReportFile( _CRT_WARN, _CRTDBG_FILE_STDOUT );  \
        _CrtSetReportMode( _CRT_ERROR, _CRTDBG_MODE_FILE );   \
        _CrtSetReportFile( _CRT_ERROR, _CRTDBG_FILE_STDOUT ); \
        _CrtSetReportMode( _CRT_ASSERT, _CRTDBG_MODE_FILE );  \
        _CrtSetReportFile( _CRT_ASSERT, _CRTDBG_FILE_STDOUT );\
    }
#else /* ! _DEBUG */
#define SET_CRT_DEBUG_FIELD(a)
#define CLEAR_CRT_DEBUG_FIELD(a)
#define SETUP_CRTDBG
#endif    /* _DEBUG */
#endif    /* WIN32 */

#undef mzdebug
#ifdef NDEBUG
# define mzdebug mzdebug0
#endif

    void mzdebug_set_mask(unsigned mask);
    void mzdebug(unsigned level, const char *fmt, ... );
    void mzdebug0(unsigned level, const char *fmt, ...);

#ifndef NDEBUG
# define MZDEBUG(f, s) mzdebug(f, s);
# define MZDEBUG1(f, s, p1) mzdebug(f, s, p1);
# define MZDEBUG2(f, s, p1, p2) mzdebug(f, s, p1, p2);
# define MZDEBUG3(f, s, p1, p2, p3) mzdebug(f, s, p1, p2, p3);
# define MZDEBUG4(f, s, p1, p2, p3, p4) mzdebug(f, s, p1, p2, p3, p4);
# define MZDEBUG5(f, s, p1, p2, p3, p4, p5) mzdebug(f, s, p1, p2, p3, p4, p5);
# define MZDEBUG6(f, s, p1, p2, p3, p4, p5, p6) mzdebug(f, s, p1, p2, p3, p4, p5, p6);
# define MZDEBUG7(f, s, p1, p2, p3, p4, p5, p6, p7) mzdebug(f, s, p1, p2, p3, p4, p5, p6, p7);
# define MZDEBUG8(f, s, p1, p2, p3, p4, p5, p6, p7, p8) mzdebug(f, s, p1, p2, p3, p4, p5, p6, p7, p8);
# define MZDEBUG9(f, s, p1, p2, p3, p4, p5, p6, p7, p8, p9) mzdebug(f, s, p1, p2, p3, p4, p5, p6, p7, p8, p9);
#else /* !NDEBUG */
# define MZDEBUG(f, s)
# define MZDEBUG1(f, s, p1)
# define MZDEBUG2(f, s, p1, p2)
# define MZDEBUG3(f, s, p1, p2, p3)
# define MZDEBUG4(f, s, p1, p2, p3, p4)
# define MZDEBUG5(f, s, p1, p2, p3, p4, p5)
# define MZDEBUG6(f, s, p1, p2, p3, p4, p5, p6)
# define MZDEBUG7(f, s, p1, p2, p3, p4, p5, p6, p7)
# define MZDEBUG8(f, s, p1, p2, p3, p4, p5, p6, p7, p8)
# define MZDEBUG9(f, s, p1, p2, p3, p4, p5, p6, p7, p8, p9)
#endif    /* NDEBUG */

#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif    /* _MZDEBUG_H_ */
