#include <stdio.h>
#include <stdlib.h>

#include <X11/Xlib.h>
#include <X11/Xlocale.h>
// #include <locale.h>

test1()
{
  unsigned char	*ka = "";
  wchar_t	wc;
  unsigned char	buf[100];
  int		len;

  mbtowc(&wc, ka, 2);
  printf("in = %s,[%x,%x]\n", ka, ka[0], ka[1]);
  printf("wc = %08x\n", wc);

  len = wctomb(buf, wc);
  buf[len] = 0;
  printf("out[%d] = %s, [%x,%x]\n", len, buf, buf[0], buf[1]);
}

test2()
{
  char 		*s = "ȳϼabc";
  char 		*p;
  wchar_t 	pwcs[1024];
  char 		pmbs[1024];
  int 		n1,n2,n3,n4;

  n1 = mbstowcs(pwcs, s, 1024);
  n2 = wcstombs(pmbs, pwcs, 1024);
  n3 = mbstowcs(NULL, s, 0);
  n4 = wcstombs(NULL, pwcs, 0);

  printf("%d %d %d %d\n", n1, n2, n3, n4);
}

test3()
{
  char 		*s = "ȳϼabc";
  wchar_t 	pwcs[1024];
  char 		pmbs[1024];
  int 		n1,n2;

  printf("in[%d] = [%s]\n", strlen(s), s);
  n1 = mbstowcs(pwcs, s, 1024);
  n2 = wcslen(pwcs);
  printf("return = %d, wslen = %d\n", n1, n2);

  n1 = wcstombs(pmbs, pwcs, 1024);
  printf("wcstombs[%d] = [%s]\n", strlen(pmbs), pmbs);
}

test4()
{
  char 		*s1 = "ȳϼ";
  char 		*s2 = "abc";
  wchar_t 	pwcs[1024], pwcs1[1024], pwcs2[1024];
  char 		pmbs[1024];
  int		n1, n2;

  printf("in1[%d] = [%s]\n", strlen(s1), s1);
  printf("in2[%d] = [%s]\n", strlen(s2), s2);

  n1 = mbstowcs(pwcs1, s1, 1024);
  n2 = mbstowcs(pwcs2, s2, 1024);
  wcscpy(pwcs, pwcs1);
  wcscat(pwcs, pwcs2);

  printf("len1 = %d, len2 = %d, len3 = %d\n",
         wcslen(pwcs1), wcslen(pwcs2), wcslen(pwcs));

  wcstombs(pmbs, pwcs, 1024);
  printf("wcstombs[%d] = [%s]\n", strlen(pmbs), pmbs);
}

main()
{
  setlocale(LC_ALL, "");
  printf("== test 1 [wctomb, mbtowc]==\n");
  test1();
  printf("== test 2 ==\n");
  test2();
  printf("== test 3 [wcslen] ==\n");
  test3();
  printf("== test 4 [wcscpy, wcscat] ==\n");
  test4();
}
