/* $Id: util.c,v 1.1 2000/02/16 20:44:20 frog Exp $ */

#include	<stdio.h>
#include	<sys/stat.h>

#include	<X11/Intrinsic.h>
#include	<X11/Xatom.h>

#include	"hanim.h"

/*
 * Returns non-zero if the argument file is a directory, or is a symbolic
 * link which points to a directory.
 */

int isdir(const char *file)
{
	struct stat sb;

	if (stat (file, &sb) < 0)
		return (0);
	return (S_ISDIR (sb.st_mode));
}


/// Xkb is Dvorak

#define _XKB_RF_NAMES_PROP_MAXLEN       1024
#define _XKB_RF_NAMES_PROP_ATOM		"_XKB_RULES_NAMES"

Boolean is_xkb_dvorak()
{
    Display         *dpy = XtDisplay(TopLevel);
    Atom            rules_atom, actual_type;
    int             fmt,len;
    unsigned long   nitems,bytes_after;
    char            *data, *ptr;
    Status          rtrn;
    Boolean         result = False;
    
    rules_atom= XInternAtom(dpy,_XKB_RF_NAMES_PROP_ATOM,True);
    if (rules_atom == None)
        return False;
    rtrn = XGetWindowProperty(dpy,DefaultRootWindow(dpy),rules_atom,
	0L,_XKB_RF_NAMES_PROP_MAXLEN, False,
	XA_STRING, &actual_type, &fmt,&nitems, &bytes_after,
	(unsigned char **)&data);
    if (rtrn != Success)
	return False;

    /* Xkb ata is composed ad 4 parts :
       rules, model, layout, variants, option */
    ptr = data;
    ptr += strlen(ptr) + 1;
    if ((ptr - data) < nitems && *ptr )
	ptr += strlen(ptr) + 1;
    if ((ptr - data) < nitems && *ptr && !STRNCASECMP(ptr, "dvorak", 2))
		result = True;
    XFree(data);
    
    return result;
}
